/*
	Extern implementation of Nit module time
*/
#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>
#include "core__time._ffi.h"
#ifdef ANDROID
	#include <android/log.h>
	#define PRINT_ERROR(...) (void)__android_log_print(ANDROID_LOG_WARN, "Nit", __VA_ARGS__)
#else
	#define PRINT_ERROR(...) fprintf(stderr, __VA_ARGS__)
#endif
#define NativeString_to_s_with_copy core__time___NativeString_to_s_with_copy
#define String_to_cstring core__time___String_to_cstring
#define NativeString_to_s core__time___NativeString_to_s
long core__time___Object_get_time___impl( Object self )
{
#line 25 "/home/xymus/projects/nit/lib/core/time.nit"

 return time(NULL); }
void core__time___Sys_nanosleep___impl( Sys self, long sec, long nanosec )
{
#line 30 "/home/xymus/projects/nit/lib/core/time.nit"


		const struct timespec req = {sec, nanosec};
		nanosleep(&req, NULL);
	}
time_t core__time___new_TimeT___impl(  )
{
#line 40 "/home/xymus/projects/nit/lib/core/time.nit"

 return time(NULL); }
time_t core__time___new_TimeT_from_i___impl( long i )
{
#line 43 "/home/xymus/projects/nit/lib/core/time.nit"

 return i; }
void core__time___TimeT_update___impl( time_t self )
{
#line 46 "/home/xymus/projects/nit/lib/core/time.nit"

 time(&self); }
String core__time___TimeT_ctime___impl( time_t self )
{
#line 49 "/home/xymus/projects/nit/lib/core/time.nit"


		return NativeString_to_s_with_copy( ctime(&self) );
	}
double core__time___TimeT_difftime___impl( time_t self, time_t start )
{
#line 54 "/home/xymus/projects/nit/lib/core/time.nit"

 return difftime(self, start); }
long core__time___TimeT_to_i___impl( time_t self )
{
#line 59 "/home/xymus/projects/nit/lib/core/time.nit"

 return (int)self; }
struct tm * core__time___new_Tm_gmtime___impl(  )
{
#line 66 "/home/xymus/projects/nit/lib/core/time.nit"


		struct tm *tm;
		time_t t = time(NULL);
		tm = gmtime(&t);
		return tm;
	}
struct tm * core__time___new_Tm_gmtime_from_timet___impl( time_t t )
{
#line 74 "/home/xymus/projects/nit/lib/core/time.nit"


		struct tm *tm;
		tm = gmtime(&t);
		return tm;
	}
struct tm * core__time___new_Tm_localtime___impl(  )
{
#line 81 "/home/xymus/projects/nit/lib/core/time.nit"


		struct tm *tm;
		time_t t = time(NULL);
		tm = localtime(&t);
		return tm;
	}
struct tm * core__time___new_Tm_localtime_from_timet___impl( time_t t )
{
#line 89 "/home/xymus/projects/nit/lib/core/time.nit"


		struct tm *tm;
		tm = localtime(&t);
		return tm;
	}
time_t core__time___Tm_to_timet___impl( struct tm * self )
{
#line 96 "/home/xymus/projects/nit/lib/core/time.nit"

 return mktime(self); }
long core__time___Tm_sec___impl( struct tm * self )
{
#line 99 "/home/xymus/projects/nit/lib/core/time.nit"

 return self->tm_sec; }
long core__time___Tm_min___impl( struct tm * self )
{
#line 102 "/home/xymus/projects/nit/lib/core/time.nit"

 return self->tm_min; }
long core__time___Tm_hour___impl( struct tm * self )
{
#line 105 "/home/xymus/projects/nit/lib/core/time.nit"

 return self->tm_hour; }
long core__time___Tm_mday___impl( struct tm * self )
{
#line 108 "/home/xymus/projects/nit/lib/core/time.nit"

 return self->tm_mday; }
long core__time___Tm_mon___impl( struct tm * self )
{
#line 111 "/home/xymus/projects/nit/lib/core/time.nit"

 return self->tm_mon; }
long core__time___Tm_year___impl( struct tm * self )
{
#line 114 "/home/xymus/projects/nit/lib/core/time.nit"

 return self->tm_year; }
long core__time___Tm_wday___impl( struct tm * self )
{
#line 117 "/home/xymus/projects/nit/lib/core/time.nit"

 return self->tm_wday; }
long core__time___Tm_yday___impl( struct tm * self )
{
#line 120 "/home/xymus/projects/nit/lib/core/time.nit"

 return self->tm_yday; }
int core__time___Tm_is_dst___impl( struct tm * self )
{
#line 123 "/home/xymus/projects/nit/lib/core/time.nit"

 return self->tm_isdst; }
String core__time___Tm_asctime___impl( struct tm * self )
{
#line 126 "/home/xymus/projects/nit/lib/core/time.nit"


		return NativeString_to_s_with_copy( asctime(self) );
	}
String core__time___Tm_strftime___impl( struct tm * self, String format )
{
#line 132 "/home/xymus/projects/nit/lib/core/time.nit"


		char* buf, *c_format;

		buf = (char*)malloc(100);
		c_format = String_to_cstring(format);

		strftime(buf, 100, c_format, self);
		String s = NativeString_to_s_with_copy(buf);
		free(buf);
		return s;
	}
