/*
	Extern implementation of Nit module opengles1
*/
#ifndef MNIT__OPENGLES1_NIT_H
#define MNIT__OPENGLES1_NIT_H

#include <stdint.h>
#include "mnit__opengles1._nitni.h"
#line 22 "/home/xymus/projects/nit/lib/mnit/opengles1.nit"


	#include <EGL/egl.h>
	#include <GLES/gl.h>

	EGLDisplay mnit_display;
	EGLSurface mnit_surface;
	EGLContext mnit_context;
	EGLConfig mnit_config;
	int32_t mnit_width;
	int32_t mnit_height;

	struct mnit_opengles_Texture {
		GLuint texture;

		/* offsets on source texture */
		float src_xo, src_yo, src_xi, src_yi;

		/* destination width and height */
		int width, height;

		/* may vary depending on scaling */
		int center_x, center_y;

		float scale;
		int blended;
	};

	struct mnit_opengles_DrawableTexture {
		struct mnit_opengles_Texture super;
		GLuint fbo;
		GLuint depth;
		GLuint color;
	};

	GLenum mnit_opengles_error_code;

	struct mnit_opengles_Texture *mnit_opengles_load_image(
		const uint_least32_t *pixels, int width, int height,
		int width_pow2, int height_pow2, int has_alpha);
#include "core__math._ffi.h"
#include "core__time._ffi.h"
#include "core__file._ffi.h"
#include "core__exec._ffi.h"
#include "core__re._ffi.h"
#endif
