/*
	Extern implementation of Nit module pthreads
*/
#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>
#include "pthreads._ffi.h"
#ifdef ANDROID
	#include <android/log.h>
	#define PRINT_ERROR(...) (void)__android_log_print(ANDROID_LOG_WARN, "Nit", __VA_ARGS__)
#else
	#define PRINT_ERROR(...) fprintf(stderr, __VA_ARGS__)
#endif
#define Thread_main_intern pthreads___Thread_main_intern
#line 34 "/home/xymus/projects/nit/lib/pthreads/pthreads.nit"


	// TODO protect with: #ifdef WITH_LIBGC
	// We might have to add the next line to gc_chooser.c too, especially
	// if we get an error like "thread not registered with GC".
	#ifndef ANDROID
		#define GC_THREADS
		#include <gc.h>
	#endif
 pthread_t *  pthreads___Sys_native_pthread_self___impl( Sys self )
{
#line 47 "/home/xymus/projects/nit/lib/pthreads/pthreads.nit"


		pthread_t *id = malloc(sizeof(pthread_t));
		*id = pthread_self();
		return id;
	}
void pthreads___Sys_exit_thread___impl( Sys self, nullable_Object value )
{
#line 311 "/home/xymus/projects/nit/lib/pthreads/pthreads.nit"

 pthread_exit(value); }
 pthread_t *  pthreads___new_NativePthread_create___impl( Thread nit_thread )
{
#line 85 "/home/xymus/projects/nit/lib/pthreads/pthreads.nit"


		pthread_attr_t attr;
		pthread_attr_init(&attr);

		pthread_t thread;
		int r = pthread_create(&thread, &attr, (void * (*)(void *))&Thread_main_intern, nit_thread);

		if (r == 0) {
			pthread_t *pthread = malloc(sizeof(pthread_t));
			memmove(pthread, &thread, sizeof(pthread_t));
			return pthread;
		}
		return NULL;
	}
 pthread_t *  pthreads___new_NativePthread_create_ex___impl( Thread nit_thread,  pthread_attr_t *  attr )
{
#line 100 "/home/xymus/projects/nit/lib/pthreads/pthreads.nit"


		pthread_t thread;
		int r = pthread_create(&thread, attr, (void * (*)(void *))&Thread_main_intern, nit_thread);

		if (r == 0) {
			pthread_t *pthread = malloc(sizeof(pthread_t));
			memmove(pthread, &thread, sizeof(pthread_t));
			return pthread;
		}
		return NULL;
	}
nullable_Object pthreads___NativePthread_join___impl(  pthread_t *  self )
{
#line 112 "/home/xymus/projects/nit/lib/pthreads/pthreads.nit"


		void *thread_return;
		pthread_join(*self, &thread_return);
		if(thread_return == NULL) thread_return = null_Object();
		return (nullable_Object)thread_return;
	}
int pthreads___NativePthread_equal___impl(  pthread_t *  self,  pthread_t *  other )
{
#line 119 "/home/xymus/projects/nit/lib/pthreads/pthreads.nit"

 return pthread_equal(*self, *other); }
void pthreads___NativePthread_kill___impl(  pthread_t *  self, long signal )
{
#line 121 "/home/xymus/projects/nit/lib/pthreads/pthreads.nit"

 pthread_kill(*self, signal); }
 pthread_attr_t *  pthreads___new_NativePthreadAttr___impl(  )
{
#line 125 "/home/xymus/projects/nit/lib/pthreads/pthreads.nit"


		pthread_attr_t attr;
		int r = pthread_attr_init(&attr);
		if (r == 0) {
			pthread_attr_t *pattr = malloc(sizeof(pthread_attr_t));
			memmove(pattr, &attr, sizeof(pthread_attr_t));
			return pattr;
		}
		return NULL;
	}
void pthreads___NativePthreadAttr_destroy___impl(  pthread_attr_t *  self )
{
#line 136 "/home/xymus/projects/nit/lib/pthreads/pthreads.nit"


		pthread_attr_destroy(self);
	}
 pthread_mutex_t *  pthreads___new_NativePthreadMutex___impl(  pthread_mutexattr_t *  attr )
{
#line 155 "/home/xymus/projects/nit/lib/pthreads/pthreads.nit"


		pthread_mutex_t *mutex = malloc(sizeof(pthread_mutex_t));
		int r = pthread_mutex_init(mutex, attr);
		if (r != 0) {
			free(mutex);
			return NULL;
		}
		return mutex;
	}
void pthreads___NativePthreadMutex_destroy___impl(  pthread_mutex_t *  self )
{
#line 165 "/home/xymus/projects/nit/lib/pthreads/pthreads.nit"

 pthread_mutex_destroy(self); }
void pthreads___NativePthreadMutex_lock___impl(  pthread_mutex_t *  self )
{
#line 167 "/home/xymus/projects/nit/lib/pthreads/pthreads.nit"

 pthread_mutex_lock(self); }
int pthreads___NativePthreadMutex_try_lock___impl(  pthread_mutex_t *  self )
{
#line 168 "/home/xymus/projects/nit/lib/pthreads/pthreads.nit"

 return pthread_mutex_trylock(self); }
void pthreads___NativePthreadMutex_unlock___impl(  pthread_mutex_t *  self )
{
#line 169 "/home/xymus/projects/nit/lib/pthreads/pthreads.nit"

 pthread_mutex_unlock(self); }
 pthread_mutexattr_t *  pthreads___new_NativePthreadMutexAttr___impl(  )
{
#line 173 "/home/xymus/projects/nit/lib/pthreads/pthreads.nit"


		pthread_mutexattr_t *attr = malloc(sizeof(pthread_mutexattr_t));
		int r = pthread_mutexattr_init(attr);
		if (r != 0) {
			free(attr);
			return NULL;
		}
		return attr;
	}
void pthreads___NativePthreadMutexAttr_destroy___impl(  pthread_mutexattr_t *  self )
{
#line 183 "/home/xymus/projects/nit/lib/pthreads/pthreads.nit"

 pthread_mutexattr_destroy(self); }
void pthreads___NativePthreadMutexAttr_set_type_normal___impl(  pthread_mutexattr_t *  self )
{
#line 185 "/home/xymus/projects/nit/lib/pthreads/pthreads.nit"

 pthread_mutexattr_settype(self, PTHREAD_MUTEX_NORMAL); }
void pthreads___NativePthreadMutexAttr_set_type_recursive___impl(  pthread_mutexattr_t *  self )
{
#line 186 "/home/xymus/projects/nit/lib/pthreads/pthreads.nit"

 pthread_mutexattr_settype(self, PTHREAD_MUTEX_RECURSIVE); }
void pthreads___NativePthreadMutexAttr_set_type_errorcheck___impl(  pthread_mutexattr_t *  self )
{
#line 187 "/home/xymus/projects/nit/lib/pthreads/pthreads.nit"

 pthread_mutexattr_settype(self, PTHREAD_MUTEX_ERRORCHECK); }
 pthread_key_t *  pthreads___new_NativePthreadKey___impl(  )
{
#line 196 "/home/xymus/projects/nit/lib/pthreads/pthreads.nit"


		pthread_key_t *key = malloc(sizeof(pthread_key_t));
		int r = pthread_key_create(key, NULL);
		if (r != 0) {
			free(key);
			return NULL;
		}
		return key;
	}
nullable_Object pthreads___NativePthreadKey_get___impl(  pthread_key_t *  self )
{
#line 206 "/home/xymus/projects/nit/lib/pthreads/pthreads.nit"


		void *val = pthread_getspecific(*self);
		if (val == NULL) val = null_Object();
		return val;
	}
void pthreads___NativePthreadKey_set___impl(  pthread_key_t *  self, nullable_Object val )
{
#line 212 "/home/xymus/projects/nit/lib/pthreads/pthreads.nit"


		pthread_setspecific(*self, val);
	}
 pthread_cond_t *  pthreads___new_NativePthreadCond___impl(  )
{
#line 218 "/home/xymus/projects/nit/lib/pthreads/pthreads.nit"


		pthread_cond_t cond;
		int r = pthread_cond_init(&cond, NULL);
		if (r == 0) {
			pthread_cond_t *pcond = malloc(sizeof(pthread_cond_t));
			memmove(pcond, &cond, sizeof(pthread_cond_t));
			return pcond;
		}
		return NULL;
	}
void pthreads___NativePthreadCond_destroy___impl(  pthread_cond_t *  self )
{
#line 229 "/home/xymus/projects/nit/lib/pthreads/pthreads.nit"

 pthread_cond_destroy(self); }
void pthreads___NativePthreadCond_signal___impl(  pthread_cond_t *  self )
{
#line 231 "/home/xymus/projects/nit/lib/pthreads/pthreads.nit"

 pthread_cond_signal(self); }
void pthreads___NativePthreadCond_broadcast___impl(  pthread_cond_t *  self )
{
#line 233 "/home/xymus/projects/nit/lib/pthreads/pthreads.nit"

 pthread_cond_broadcast(self);  }
void pthreads___NativePthreadCond_wait___impl(  pthread_cond_t *  self,  pthread_mutex_t *  mutex )
{
#line 235 "/home/xymus/projects/nit/lib/pthreads/pthreads.nit"

 pthread_cond_wait(self, mutex); }
