#include "a_star.sep.0.h"
/* method a_star#Node#graph for (self: Node): Graph[Node, Link] */
val* a_star___a_star__Node___graph(val* self) {
val* var /* : Graph[Node, Link] */;
val* var1 /* : Graph[Node, Link] */;
var1 = self->attrs[COLOR_a_star__Node___graph].val; /* _graph on <self:Node> */
if (unlikely(var1 == NULL)) {
PRINT_ERROR("Runtime error: %s", "Uninitialized attribute _graph");
PRINT_ERROR(" (%s:%d)\n", FILE_a_star, 67);
fatal_exit(1);
}
var = var1;
RET_LABEL:;
return var;
}
/* method a_star#Node#graph= for (self: Node, Graph[Node, Link]) */
void a_star___a_star__Node___graph_61d(val* self, val* p0) {
short int var /* : Bool */;
int cltype;
int idtype;
const struct type* type_struct;
const char* var_class_name;
/* Covariant cast for argument 0 (graph) <p0:Graph[Node, Link]> isa Graph[N, Link] */
/* <p0:Graph[Node, Link]> isa Graph[N, Link] */
type_struct = self->type->resolution_table->types[COLOR_a_star__Graph__a_star__Node__N__a_star__Link];
cltype = type_struct->color;
idtype = type_struct->id;
if(cltype >= p0->type->table_size) {
var = 0;
} else {
var = p0->type->type_table[cltype] == idtype;
}
if (unlikely(!var)) {
var_class_name = p0 == NULL ? "null" : p0->type->name;
PRINT_ERROR("Runtime error: Cast failed. Expected `%s`, got `%s`", "Graph[N, Link]", var_class_name);
PRINT_ERROR(" (%s:%d)\n", FILE_a_star, 67);
fatal_exit(1);
}
self->attrs[COLOR_a_star__Node___graph].val = p0; /* _graph on <self:Node> */
RET_LABEL:;
}
/* method a_star#Node#init for (self: Node) */
void a_star___a_star__Node___core__kernel__Object__init(val* self) {
val* var /* : Graph[Node, Link] */;
short int var1 /* : Bool */;
int cltype;
int idtype;
const struct type* type_struct;
const char* var_class_name;
val* var2 /* : Node */;
{
((void(*)(val* self))(self->class->vft[COLOR_a_star___a_star__Node___core__kernel__Object__init]))(self); /* init on <self:Node>*/
}
{
var = ((val*(*)(val* self))(self->class->vft[COLOR_a_star__Node__graph]))(self); /* graph on <self:Node>*/
}
/* <self:Node> isa N */
type_struct = self->type->resolution_table->types[COLOR_a_star__Node__N];
cltype = type_struct->color;
idtype = type_struct->id;
if(cltype >= self->type->table_size) {
var1 = 0;
} else {
var1 = self->type->type_table[cltype] == idtype;
}
if (unlikely(!var1)) {
var_class_name = self == NULL ? "null" : self->type->name;
PRINT_ERROR("Runtime error: Cast failed. Expected `%s`, got `%s`", "N", var_class_name);
PRINT_ERROR(" (%s:%d)\n", FILE_a_star, 72);
fatal_exit(1);
}
{
var2 = ((val*(*)(val* self, val* p0))(var->class->vft[COLOR_a_star__Graph__add_node]))(var, self); /* add_node on <var:Graph[Node, Link]>*/
}
RET_LABEL:;
}
/* method a_star#Node#links for (self: Node): Set[Link] */
val* a_star___a_star__Node___links(val* self) {
val* var /* : Set[Link] */;
val* var1 /* : Set[Link] */;
var1 = self->attrs[COLOR_a_star__Node___links].val; /* _links on <self:Node> */
if (unlikely(var1 == NULL)) {
PRINT_ERROR("Runtime error: %s", "Uninitialized attribute _links");
PRINT_ERROR(" (%s:%d)\n", FILE_a_star, 75);
fatal_exit(1);
}
var = var1;
RET_LABEL:;
return var;
}
/* method a_star#Node#links= for (self: Node, Set[Link]) */
void a_star___a_star__Node___links_61d(val* self, val* p0) {
self->attrs[COLOR_a_star__Node___links].val = p0; /* _links on <self:Node> */
RET_LABEL:;
}
/* method a_star#Node#last_pathfinding_evocation for (self: Node): Int */
long a_star___a_star__Node___last_pathfinding_evocation(val* self) {
long var /* : Int */;
long var1 /* : Int */;
var1 = self->attrs[COLOR_a_star__Node___last_pathfinding_evocation].l; /* _last_pathfinding_evocation on <self:Node> */
var = var1;
RET_LABEL:;
return var;
}
/* method a_star#Node#last_pathfinding_evocation= for (self: Node, Int) */
void a_star___a_star__Node___last_pathfinding_evocation_61d(val* self, long p0) {
self->attrs[COLOR_a_star__Node___last_pathfinding_evocation].l = p0; /* _last_pathfinding_evocation on <self:Node> */
RET_LABEL:;
}
/* method a_star#Node#best_cost_up_to for (self: Node): Int */
long a_star___a_star__Node___best_cost_up_to(val* self) {
long var /* : Int */;
long var1 /* : Int */;
var1 = self->attrs[COLOR_a_star__Node___best_cost_up_to].l; /* _best_cost_up_to on <self:Node> */
var = var1;
RET_LABEL:;
return var;
}
/* method a_star#Node#best_cost_up_to= for (self: Node, Int) */
void a_star___a_star__Node___best_cost_up_to_61d(val* self, long p0) {
self->attrs[COLOR_a_star__Node___best_cost_up_to].l = p0; /* _best_cost_up_to on <self:Node> */
RET_LABEL:;
}
/* method a_star#Node#best_source for (self: Node): nullable Node */
val* a_star___a_star__Node___best_source(val* self) {
val* var /* : nullable Node */;
val* var1 /* : nullable Node */;
var1 = self->attrs[COLOR_a_star__Node___best_source].val; /* _best_source on <self:Node> */
var = var1;
RET_LABEL:;
return var;
}
/* method a_star#Node#best_source= for (self: Node, nullable Node) */
void a_star___a_star__Node___best_source_61d(val* self, val* p0) {
short int var /* : Bool */;
int cltype;
int idtype;
const struct type* type_struct;
const char* var_class_name;
/* Covariant cast for argument 0 (best_source) <p0:nullable Node> isa nullable N */
/* <p0:nullable Node> isa nullable N */
type_struct = self->type->resolution_table->types[COLOR_nullable__a_star__Node__N];
cltype = type_struct->color;
idtype = type_struct->id;
if(p0 == NULL) {
var = 1;
} else {
if(cltype >= p0->type->table_size) {
var = 0;
} else {
var = p0->type->type_table[cltype] == idtype;
}
}
if (unlikely(!var)) {
var_class_name = p0 == NULL ? "null" : p0->type->name;
PRINT_ERROR("Runtime error: Cast failed. Expected `%s`, got `%s`", "nullable N", var_class_name);
PRINT_ERROR(" (%s:%d)\n", FILE_a_star, 85);
fatal_exit(1);
}
self->attrs[COLOR_a_star__Node___best_source].val = p0; /* _best_source on <self:Node> */
RET_LABEL:;
}
/* method a_star#Node#open for (self: Node): Bool */
short int a_star___a_star__Node___open(val* self) {
short int var /* : Bool */;
short int var1 /* : Bool */;
var1 = self->attrs[COLOR_a_star__Node___open].s; /* _open on <self:Node> */
var = var1;
RET_LABEL:;
return var;
}
/* method a_star#Node#open= for (self: Node, Bool) */
void a_star___a_star__Node___open_61d(val* self, short int p0) {
self->attrs[COLOR_a_star__Node___open].s = p0; /* _open on <self:Node> */
RET_LABEL:;
}
/* method a_star#Node#path_to for (self: Node, Node, Int, PathContext): nullable AStarPath[Node] */
val* a_star___a_star__Node___path_to(val* self, val* p0, long p1, val* p2) {
val* var /* : nullable AStarPath[Node] */;
short int var1 /* : Bool */;
int cltype;
int idtype;
const struct type* type_struct;
const char* var_class_name;
val* var_dest /* var dest: Node */;
long var_max_cost /* var max_cost: Int */;
val* var_context /* var context: PathContext */;
val* var2 /* : nullable AStarPath[Node] */;
/* Covariant cast for argument 0 (dest) <p0:Node> isa N */
/* <p0:Node> isa N */
type_struct = self->type->resolution_table->types[COLOR_a_star__Node__N];
cltype = type_struct->color;
idtype = type_struct->id;
if(cltype >= p0->type->table_size) {
var1 = 0;
} else {
var1 = p0->type->type_table[cltype] == idtype;
}
if (unlikely(!var1)) {
var_class_name = p0 == NULL ? "null" : p0->type->name;
PRINT_ERROR("Runtime error: Cast failed. Expected `%s`, got `%s`", "N", var_class_name);
PRINT_ERROR(" (%s:%d)\n", FILE_a_star, 93);
fatal_exit(1);
}
var_dest = p0;
var_max_cost = p1;
var_context = p2;
{
var2 = ((val*(*)(val* self, val* p0, long p1, val* p2, val* p3))(self->class->vft[COLOR_a_star__Node__path_to_alts]))(self, var_dest, var_max_cost, var_context, ((val*)NULL)); /* path_to_alts on <self:Node>*/
}
var = var2;
goto RET_LABEL;
RET_LABEL:;
return var;
}
/* method a_star#Node#path_to_alts for (self: Node, nullable Node, Int, PathContext, nullable TargetCondition[Node]): nullable AStarPath[Node] */
val* a_star___a_star__Node___path_to_alts(val* self, val* p0, long p1, val* p2, val* p3) {
val* var /* : nullable AStarPath[Node] */;
short int var1 /* : Bool */;
int cltype;
int idtype;
const struct type* type_struct;
const char* var_class_name;
short int var2 /* : Bool */;
int cltype3;
int idtype4;
const struct type* type_struct5;
const char* var_class_name6;
val* var_destination /* var destination: nullable Node */;
long var_max_cost /* var max_cost: Int */;
val* var_context /* var context: PathContext */;
val* var_alt_targets /* var alt_targets: nullable TargetCondition[Node] */;
long var_cost /* var cost: Int */;
long var7 /* : Int */;
long var8 /* : Int */;
long var9 /* : Int */;
short int var11 /* : Bool */;
int cltype12;
int idtype13;
const char* var_class_name14;
long var15 /* : Int */;
long var16 /* : Int */;
short int var18 /* : Bool */;
int cltype19;
int idtype20;
const char* var_class_name21;
long var22 /* : Int */;
long var_nbr_buckets /* var nbr_buckets: Int */;
val* var23 /* : Array[List[Node]] */;
val* var_buckets /* var buckets: Array[List[Node]] */;
long var_i /* var i: Int */;
long var_ /* var : Int */;
short int var24 /* : Bool */;
short int var26 /* : Bool */;
int cltype27;
int idtype28;
const char* var_class_name29;
short int var30 /* : Bool */;
val* var31 /* : List[Node] */;
long var32 /* : Int */;
val* var33 /* : Graph[Node, Link] */;
val* var_34 /* var : Graph[Node, Link] */;
long var35 /* : Int */;
long var36 /* : Int */;
short int var38 /* : Bool */;
int cltype39;
int idtype40;
const char* var_class_name41;
long var42 /* : Int */;
val* var43 /* : nullable Object */;
short int var44 /* : Bool */;
int cltype45;
int idtype46;
const struct type* type_struct47;
const char* var_class_name48;
val* var49 /* : Graph[Node, Link] */;
long var50 /* : Int */;
val* var_frontier_node /* var frontier_node: nullable Node */;
long var_bucket_searched /* var bucket_searched: Int */;
long var51 /* : Int */;
long var53 /* : Int */;
val* var54 /* : nullable Object */;
val* var_current_bucket /* var current_bucket: List[Node] */;
short int var55 /* : Bool */;
long var56 /* : Int */;
short int var58 /* : Bool */;
int cltype59;
int idtype60;
const char* var_class_name61;
long var62 /* : Int */;
short int var63 /* : Bool */;
short int var65 /* : Bool */;
int cltype66;
int idtype67;
const char* var_class_name68;
short int var69 /* : Bool */;
long var70 /* : Int */;
short int var72 /* : Bool */;
int cltype73;
int idtype74;
const char* var_class_name75;
long var76 /* : Int */;
short int var77 /* : Bool */;
short int var79 /* : Bool */;
int cltype80;
int idtype81;
const char* var_class_name82;
short int var83 /* : Bool */;
val* var85 /* : nullable Object */;
short int var86 /* : Bool */;
short int var87 /* : Bool */;
short int var88 /* : Bool */;
short int var89 /* : Bool */;
short int var90 /* : Bool */;
short int var_91 /* var : Bool */;
short int var92 /* : Bool */;
short int var93 /* : Bool */;
short int var94 /* : Bool */;
short int var_95 /* var : Bool */;
short int var96 /* : Bool */;
val* var97 /* : AStarPath[Node] */;
val* var_path /* var path: AStarPath[Node] */;
short int var98 /* : Bool */;
val* var99 /* : List[nullable Object] */;
val* var100 /* : nullable Node */;
short int var101 /* : Bool */;
int cltype102;
int idtype103;
const struct type* type_struct104;
const char* var_class_name105;
short int var106 /* : Bool */;
short int var107 /* : Bool */;
val* var109 /* : Set[Link] */;
val* var_110 /* var : Set[Link] */;
val* var111 /* : Iterator[nullable Object] */;
val* var_112 /* var : Iterator[Link] */;
short int var113 /* : Bool */;
val* var115 /* : nullable Object */;
val* var_link /* var link: Link */;
val* var116 /* : Node */;
val* var_peek_node /* var peek_node: Node */;
short int var117 /* : Bool */;
short int var118 /* : Bool */;
short int var119 /* : Bool */;
short int var_120 /* var : Bool */;
short int var121 /* : Bool */;
long var122 /* : Int */;
val* var123 /* : Graph[Node, Link] */;
long var124 /* : Int */;
short int var125 /* : Bool */;
short int var127 /* : Bool */;
short int var128 /* : Bool */;
short int var_129 /* var : Bool */;
short int var130 /* : Bool */;
short int var131 /* : Bool */;
short int var_132 /* var : Bool */;
long var133 /* : Int */;
long var134 /* : Int */;
long var135 /* : Int */;
short int var137 /* : Bool */;
int cltype138;
int idtype139;
const char* var_class_name140;
long var141 /* : Int */;
short int var142 /* : Bool */;
short int var144 /* : Bool */;
int cltype145;
int idtype146;
const char* var_class_name147;
short int var148 /* : Bool */;
val* var149 /* : Graph[Node, Link] */;
long var150 /* : Int */;
long var151 /* : Int */;
long var152 /* : Int */;
short int var154 /* : Bool */;
int cltype155;
int idtype156;
const char* var_class_name157;
long var158 /* : Int */;
short int var159 /* : Bool */;
short int var160 /* : Bool */;
long var161 /* : Int */;
long var162 /* : Int */;
long var163 /* : Int */;
short int var165 /* : Bool */;
int cltype166;
int idtype167;
const char* var_class_name168;
long var169 /* : Int */;
val* var170 /* : nullable Object */;
val* var_est_cost /* var est_cost: nullable Object */;
short int var171 /* : Bool */;
short int var172 /* : Bool */;
long var173 /* : Int */;
short int var174 /* : Bool */;
int cltype175;
int idtype176;
const struct type* type_struct177;
const char* var_class_name178;
long var179 /* : Int */;
long var180 /* : Int */;
short int var182 /* : Bool */;
int cltype183;
int idtype184;
const char* var_class_name185;
long var186 /* : Int */;
val* var187 /* : nullable Object */;
val* var188 /* : nullable Object */;
long var189 /* : Int */;
long var191 /* : Int */;
long var192 /* : Int */;
val* var193 /* : nullable Object */;
val* var_at_bucket /* var at_bucket: List[Node] */;
short int var194 /* : Bool */;
int cltype195;
int idtype196;
const struct type* type_struct197;
const char* var_class_name198;
/* Covariant cast for argument 0 (destination) <p0:nullable Node> isa nullable N */
/* <p0:nullable Node> isa nullable N */
type_struct = self->type->resolution_table->types[COLOR_nullable__a_star__Node__N];
cltype = type_struct->color;
idtype = type_struct->id;
if(p0 == NULL) {
var1 = 1;
} else {
if(cltype >= p0->type->table_size) {
var1 = 0;
} else {
var1 = p0->type->type_table[cltype] == idtype;
}
}
if (unlikely(!var1)) {
var_class_name = p0 == NULL ? "null" : p0->type->name;
PRINT_ERROR("Runtime error: Cast failed. Expected `%s`, got `%s`", "nullable N", var_class_name);
PRINT_ERROR(" (%s:%d)\n", FILE_a_star, 99);
fatal_exit(1);
}
/* Covariant cast for argument 3 (alt_targets) <p3:nullable TargetCondition[Node]> isa nullable TargetCondition[N] */
/* <p3:nullable TargetCondition[Node]> isa nullable TargetCondition[N] */
type_struct5 = self->type->resolution_table->types[COLOR_nullable__a_star__TargetCondition__a_star__Node__N];
cltype3 = type_struct5->color;
idtype4 = type_struct5->id;
if(p3 == NULL) {
var2 = 1;
} else {
if(cltype3 >= p3->type->table_size) {
var2 = 0;
} else {
var2 = p3->type->type_table[cltype3] == idtype4;
}
}
if (unlikely(!var2)) {
var_class_name6 = p3 == NULL ? "null" : p3->type->name;
PRINT_ERROR("Runtime error: Cast failed. Expected `%s`, got `%s`", "nullable TargetCondition[N]", var_class_name6);
PRINT_ERROR(" (%s:%d)\n", FILE_a_star, 99);
fatal_exit(1);
}
var_destination = p0;
var_max_cost = p1;
var_context = p2;
var_alt_targets = p3;
var_cost = 0l;
{
var7 = ((long(*)(val* self))(var_context->class->vft[COLOR_a_star__PathContext__worst_cost]))(var_context); /* worst_cost on <var_context:PathContext>*/
}
{
var8 = ((long(*)(val* self))(var_context->class->vft[COLOR_a_star__PathContext__worst_heuristic_cost]))(var_context); /* worst_heuristic_cost on <var_context:PathContext>*/
}
{
{ /* Inline kernel#Int#+ (var7,var8) on <var7:Int> */
/* Covariant cast for argument 0 (i) <var8:Int> isa OTHER */
/* <var8:Int> isa OTHER */
var11 = 1; /* easy <var8:Int> isa OTHER*/
if (unlikely(!var11)) {
var_class_name14 = type_core__Int.name;
PRINT_ERROR("Runtime error: Cast failed. Expected `%s`, got `%s`", "OTHER", var_class_name14);
PRINT_ERROR(" (%s:%d)\n", FILE_core__kernel, 725);
fatal_exit(1);
}
var15 = var7 + var8;
var9 = var15;
goto RET_LABEL10;
RET_LABEL10:(void)0;
}
}
{
{ /* Inline kernel#Int#+ (var9,1l) on <var9:Int> */
/* Covariant cast for argument 0 (i) <1l:Int> isa OTHER */
/* <1l:Int> isa OTHER */
var18 = 1; /* easy <1l:Int> isa OTHER*/
if (unlikely(!var18)) {
var_class_name21 = type_core__Int.name;
PRINT_ERROR("Runtime error: Cast failed. Expected `%s`, got `%s`", "OTHER", var_class_name21);
PRINT_ERROR(" (%s:%d)\n", FILE_core__kernel, 725);
fatal_exit(1);
}
var22 = var9 + 1l;
var16 = var22;
goto RET_LABEL17;
RET_LABEL17:(void)0;
}
}
var_nbr_buckets = var16;
var23 = NEW_core__Array(self->type->resolution_table->types[COLOR_core__Array__core__List__a_star__Node__N]);
{
((void(*)(val* self, long p0))(var23->class->vft[COLOR_core__array__Array__with_capacity]))(var23, var_nbr_buckets); /* with_capacity on <var23:Array[List[Node]]>*/
}
var_buckets = var23;
var_i = 0l;
var_ = var_nbr_buckets;
for(;;) {
{
{ /* Inline kernel#Int#< (var_i,var_) on <var_i:Int> */
/* Covariant cast for argument 0 (i) <var_:Int> isa OTHER */
/* <var_:Int> isa OTHER */
var26 = 1; /* easy <var_:Int> isa OTHER*/
if (unlikely(!var26)) {
var_class_name29 = type_core__Int.name;
PRINT_ERROR("Runtime error: Cast failed. Expected `%s`, got `%s`", "OTHER", var_class_name29);
PRINT_ERROR(" (%s:%d)\n", FILE_core__kernel, 722);
fatal_exit(1);
}
var30 = var_i < var_;
var24 = var30;
goto RET_LABEL25;
RET_LABEL25:(void)0;
}
}
if (var24){
} else {
goto BREAK_label;
}
var31 = NEW_core__List(self->type->resolution_table->types[COLOR_core__List__a_star__Node__N]);
{
((void(*)(val* self))(var31->class->vft[COLOR_core__kernel__Object__init]))(var31); /* init on <var31:List[Node]>*/
}
{
((void(*)(val* self, val* p0))(var_buckets->class->vft[COLOR_core__abstract_collection__SimpleCollection__add]))(var_buckets, var31); /* add on <var_buckets:Array[List[Node]]>*/
}
var32 = core___core__Int___Discrete__successor(var_i, 1l);
var_i = var32;
}
BREAK_label: (void)0;
{
var33 = ((val*(*)(val* self))(self->class->vft[COLOR_a_star__Node__graph]))(self); /* graph on <self:Node>*/
}
var_34 = var33;
{
var35 = ((long(*)(val* self))(var_34->class->vft[COLOR_a_star__Graph__pathfinding_current_evocation]))(var_34); /* pathfinding_current_evocation on <var_34:Graph[Node, Link]>*/
}
{
{ /* Inline kernel#Int#+ (var35,1l) on <var35:Int> */
/* Covariant cast for argument 0 (i) <1l:Int> isa OTHER */
/* <1l:Int> isa OTHER */
var38 = 1; /* easy <1l:Int> isa OTHER*/
if (unlikely(!var38)) {
var_class_name41 = type_core__Int.name;
PRINT_ERROR("Runtime error: Cast failed. Expected `%s`, got `%s`", "OTHER", var_class_name41);
PRINT_ERROR(" (%s:%d)\n", FILE_core__kernel, 725);
fatal_exit(1);
}
var42 = var35 + 1l;
var36 = var42;
goto RET_LABEL37;
RET_LABEL37:(void)0;
}
}
{
((void(*)(val* self, long p0))(var_34->class->vft[COLOR_a_star__Graph__pathfinding_current_evocation_61d]))(var_34, var36); /* pathfinding_current_evocation= on <var_34:Graph[Node, Link]>*/
}
{
var43 = ((val*(*)(val* self, long p0))(var_buckets->class->vft[COLOR_core__abstract_collection__SequenceRead___91d_93d]))(var_buckets, 0l); /* [] on <var_buckets:Array[List[Node]]>*/
}
/* <self:Node> isa N */
type_struct47 = self->type->resolution_table->types[COLOR_a_star__Node__N];
cltype45 = type_struct47->color;
idtype46 = type_struct47->id;
if(cltype45 >= self->type->table_size) {
var44 = 0;
} else {
var44 = self->type->type_table[cltype45] == idtype46;
}
if (unlikely(!var44)) {
var_class_name48 = self == NULL ? "null" : self->type->name;
PRINT_ERROR("Runtime error: Cast failed. Expected `%s`, got `%s`", "N", var_class_name48);
PRINT_ERROR(" (%s:%d)\n", FILE_a_star, 115);
fatal_exit(1);
}
{
((void(*)(val* self, val* p0))(var43->class->vft[COLOR_core__abstract_collection__SimpleCollection__add]))(var43, self); /* add on <var43:nullable Object(List[Node])>*/
}
{
((void(*)(val* self, short int p0))(self->class->vft[COLOR_a_star__Node__open_61d]))(self, 1); /* open= on <self:Node>*/
}
{
var49 = ((val*(*)(val* self))(self->class->vft[COLOR_a_star__Node__graph]))(self); /* graph on <self:Node>*/
}
{
var50 = ((long(*)(val* self))(var49->class->vft[COLOR_a_star__Graph__pathfinding_current_evocation]))(var49); /* pathfinding_current_evocation on <var49:Graph[Node, Link]>*/
}
{
((void(*)(val* self, long p0))(self->class->vft[COLOR_a_star__Node__last_pathfinding_evocation_61d]))(self, var50); /* last_pathfinding_evocation= on <self:Node>*/
}
{
((void(*)(val* self, long p0))(self->class->vft[COLOR_a_star__Node__best_cost_up_to_61d]))(self, 0l); /* best_cost_up_to= on <self:Node>*/
}
for(;;) {
var_frontier_node = ((val*)NULL);
var_bucket_searched = 0l;
for(;;) {
{
{ /* Inline kernel#Int#% (var_cost,var_nbr_buckets) on <var_cost:Int> */
var53 = var_cost % var_nbr_buckets;
var51 = var53;
goto RET_LABEL52;
RET_LABEL52:(void)0;
}
}
{
var54 = ((val*(*)(val* self, long p0))(var_buckets->class->vft[COLOR_core__abstract_collection__SequenceRead___91d_93d]))(var_buckets, var51); /* [] on <var_buckets:Array[List[Node]]>*/
}
var_current_bucket = var54;
{
var55 = ((short int(*)(val* self))(var_current_bucket->class->vft[COLOR_core__abstract_collection__Collection__is_empty]))(var_current_bucket); /* is_empty on <var_current_bucket:List[Node]>*/
}
if (var55){
{
{ /* Inline kernel#Int#+ (var_cost,1l) on <var_cost:Int> */
/* Covariant cast for argument 0 (i) <1l:Int> isa OTHER */
/* <1l:Int> isa OTHER */
var58 = 1; /* easy <1l:Int> isa OTHER*/
if (unlikely(!var58)) {
var_class_name61 = type_core__Int.name;
PRINT_ERROR("Runtime error: Cast failed. Expected `%s`, got `%s`", "OTHER", var_class_name61);
PRINT_ERROR(" (%s:%d)\n", FILE_core__kernel, 725);
fatal_exit(1);
}
var62 = var_cost + 1l;
var56 = var62;
goto RET_LABEL57;
RET_LABEL57:(void)0;
}
}
var_cost = var56;
{
{ /* Inline kernel#Int#> (var_cost,var_max_cost) on <var_cost:Int> */
/* Covariant cast for argument 0 (i) <var_max_cost:Int> isa OTHER */
/* <var_max_cost:Int> isa OTHER */
var65 = 1; /* easy <var_max_cost:Int> isa OTHER*/
if (unlikely(!var65)) {
var_class_name68 = type_core__Int.name;
PRINT_ERROR("Runtime error: Cast failed. Expected `%s`, got `%s`", "OTHER", var_class_name68);
PRINT_ERROR(" (%s:%d)\n", FILE_core__kernel, 724);
fatal_exit(1);
}
var69 = var_cost > var_max_cost;
var63 = var69;
goto RET_LABEL64;
RET_LABEL64:(void)0;
}
}
if (var63){
var = ((val*)NULL);
goto RET_LABEL;
} else {
}
{
{ /* Inline kernel#Int#+ (var_bucket_searched,1l) on <var_bucket_searched:Int> */
/* Covariant cast for argument 0 (i) <1l:Int> isa OTHER */
/* <1l:Int> isa OTHER */
var72 = 1; /* easy <1l:Int> isa OTHER*/
if (unlikely(!var72)) {
var_class_name75 = type_core__Int.name;
PRINT_ERROR("Runtime error: Cast failed. Expected `%s`, got `%s`", "OTHER", var_class_name75);
PRINT_ERROR(" (%s:%d)\n", FILE_core__kernel, 725);
fatal_exit(1);
}
var76 = var_bucket_searched + 1l;
var70 = var76;
goto RET_LABEL71;
RET_LABEL71:(void)0;
}
}
var_bucket_searched = var70;
{
{ /* Inline kernel#Int#> (var_bucket_searched,var_nbr_buckets) on <var_bucket_searched:Int> */
/* Covariant cast for argument 0 (i) <var_nbr_buckets:Int> isa OTHER */
/* <var_nbr_buckets:Int> isa OTHER */
var79 = 1; /* easy <var_nbr_buckets:Int> isa OTHER*/
if (unlikely(!var79)) {
var_class_name82 = type_core__Int.name;
PRINT_ERROR("Runtime error: Cast failed. Expected `%s`, got `%s`", "OTHER", var_class_name82);
PRINT_ERROR(" (%s:%d)\n", FILE_core__kernel, 724);
fatal_exit(1);
}
var83 = var_bucket_searched > var_nbr_buckets;
var77 = var83;
goto RET_LABEL78;
RET_LABEL78:(void)0;
}
}
if (var77){
goto BREAK_label84;
} else {
}
} else {
{
var85 = ((val*(*)(val* self))(var_current_bucket->class->vft[COLOR_core__abstract_collection__Sequence__pop]))(var_current_bucket); /* pop on <var_current_bucket:List[Node]>*/
}
var_frontier_node = var85;
{
var86 = ((short int(*)(val* self))(var_frontier_node->class->vft[COLOR_a_star__Node__open]))(var_frontier_node); /* open on <var_frontier_node:nullable Node(Node)>*/
}
if (var86){
goto BREAK_label84;
} else {
}
}
}
BREAK_label84: (void)0;
if (var_frontier_node == NULL) {
var87 = 1; /* is null */
} else {
var87 = 0; /* arg is null but recv is not */
}
if (0) {
var88 = ((short int(*)(val* self, val* p0))(var_frontier_node->class->vft[COLOR_core__kernel__Object___61d_61d]))(var_frontier_node, ((val*)NULL)); /* == on <var_frontier_node:nullable Node>*/
var87 = var88;
}
if (var87){
var = ((val*)NULL);
goto RET_LABEL;
} else {
{
var90 = ((short int(*)(val* self, val* p0))(var_frontier_node->class->vft[COLOR_core__kernel__Object___61d_61d]))(var_frontier_node, var_destination); /* == on <var_frontier_node:nullable Node(Node)>*/
}
var_91 = var90;
if (var90){
var89 = var_91;
} else {
if (var_alt_targets == NULL) {
var93 = 0; /* is null */
} else {
var93 = 1; /* arg is null and recv is not */
}
if (0) {
var94 = ((short int(*)(val* self, val* p0))(var_alt_targets->class->vft[COLOR_core__kernel__Object___33d_61d]))(var_alt_targets, ((val*)NULL)); /* != on <var_alt_targets:nullable TargetCondition[Node]>*/
var93 = var94;
}
var_95 = var93;
if (var93){
{
var96 = ((short int(*)(val* self, val* p0))(var_alt_targets->class->vft[COLOR_a_star__TargetCondition__accept]))(var_alt_targets, var_frontier_node); /* accept on <var_alt_targets:nullable TargetCondition[Node](TargetCondition[Node])>*/
}
var92 = var96;
} else {
var92 = var_95;
}
var89 = var92;
}
if (var89){
var97 = NEW_a_star__AStarPath(self->type->resolution_table->types[COLOR_a_star__AStarPath__a_star__Node__N]);
{
((void(*)(val* self, long p0))(var97->class->vft[COLOR_a_star__AStarPath__total_cost_61d]))(var97, var_cost); /* total_cost= on <var97:AStarPath[Node]>*/
}
{
((void(*)(val* self))(var97->class->vft[COLOR_core__kernel__Object__init]))(var97); /* init on <var97:AStarPath[Node]>*/
}
var_path = var97;
for(;;) {
{
var98 = ((short int(*)(val* self, val* p0))(var_frontier_node->class->vft[COLOR_core__kernel__Object___33d_61d]))(var_frontier_node, self); /* != on <var_frontier_node:nullable Node(Node)>*/
}
if (var98){
{
var99 = ((val*(*)(val* self))(var_path->class->vft[COLOR_a_star__AStarPath__nodes]))(var_path); /* nodes on <var_path:AStarPath[Node]>*/
}
{
((void(*)(val* self, val* p0))(var99->class->vft[COLOR_core__abstract_collection__Sequence__unshift]))(var99, var_frontier_node); /* unshift on <var99:List[nullable Object](List[Node])>*/
}
{
var100 = ((val*(*)(val* self))(var_frontier_node->class->vft[COLOR_a_star__Node__best_source]))(var_frontier_node); /* best_source on <var_frontier_node:nullable Node(Node)>*/
}
/* <var100:nullable Node> isa nullable N */
type_struct104 = self->type->resolution_table->types[COLOR_nullable__a_star__Node__N];
cltype102 = type_struct104->color;
idtype103 = type_struct104->id;
if(var100 == NULL) {
var101 = 1;
} else {
if(cltype102 >= var100->type->table_size) {
var101 = 0;
} else {
var101 = var100->type->type_table[cltype102] == idtype103;
}
}
if (unlikely(!var101)) {
var_class_name105 = var100 == NULL ? "null" : var100->type->name;
PRINT_ERROR("Runtime error: Cast failed. Expected `%s`, got `%s`", "nullable N", var_class_name105);
PRINT_ERROR(" (%s:%d)\n", FILE_a_star, 154);
fatal_exit(1);
}
var_frontier_node = var100;
if (var_frontier_node == NULL) {
var106 = 0; /* is null */
} else {
var106 = 1; /* arg is null and recv is not */
}
if (0) {
var107 = ((short int(*)(val* self, val* p0))(var_frontier_node->class->vft[COLOR_core__kernel__Object___33d_61d]))(var_frontier_node, ((val*)NULL)); /* != on <var_frontier_node:nullable Node>*/
var106 = var107;
}
if (unlikely(!var106)) {
PRINT_ERROR("Runtime error: %s", "Assert failed");
PRINT_ERROR(" (%s:%d)\n", FILE_a_star, 155);
fatal_exit(1);
}
} else {
goto BREAK_label108;
}
}
BREAK_label108: (void)0;
var = var_path;
goto RET_LABEL;
} else {
{
((void(*)(val* self, short int p0))(var_frontier_node->class->vft[COLOR_a_star__Node__open_61d]))(var_frontier_node, 0); /* open= on <var_frontier_node:nullable Node(Node)>*/
}
{
var109 = ((val*(*)(val* self))(var_frontier_node->class->vft[COLOR_a_star__Node__links]))(var_frontier_node); /* links on <var_frontier_node:nullable Node(Node)>*/
}
var_110 = var109;
{
var111 = ((val*(*)(val* self))((((long)var_110&3)?class_info[((long)var_110&3)]:var_110->class)->vft[COLOR_core__abstract_collection__Collection__iterator]))(var_110); /* iterator on <var_110:Set[Link]>*/
}
var_112 = var111;
for(;;) {
{
var113 = ((short int(*)(val* self))((((long)var_112&3)?class_info[((long)var_112&3)]:var_112->class)->vft[COLOR_core__abstract_collection__Iterator__is_ok]))(var_112); /* is_ok on <var_112:Iterator[Link]>*/
}
if (var113){
} else {
goto BREAK_label114;
}
{
var115 = ((val*(*)(val* self))((((long)var_112&3)?class_info[((long)var_112&3)]:var_112->class)->vft[COLOR_core__abstract_collection__Iterator__item]))(var_112); /* item on <var_112:Iterator[Link]>*/
}
var_link = var115;
{
var116 = ((val*(*)(val* self))(var_link->class->vft[COLOR_a_star__Link__to]))(var_link); /* to on <var_link:Link>*/
}
var_peek_node = var116;
{
var118 = ((short int(*)(val* self, val* p0))(var_context->class->vft[COLOR_a_star__PathContext__is_blocked]))(var_context, var_link); /* is_blocked on <var_context:PathContext>*/
}
var119 = !var118;
var_120 = var119;
if (var119){
{
var122 = ((long(*)(val* self))(var_peek_node->class->vft[COLOR_a_star__Node__last_pathfinding_evocation]))(var_peek_node); /* last_pathfinding_evocation on <var_peek_node:Node>*/
}
{
var123 = ((val*(*)(val* self))(self->class->vft[COLOR_a_star__Node__graph]))(self); /* graph on <self:Node>*/
}
{
var124 = ((long(*)(val* self))(var123->class->vft[COLOR_a_star__Graph__pathfinding_current_evocation]))(var123); /* pathfinding_current_evocation on <var123:Graph[Node, Link]>*/
}
{
{ /* Inline kernel#Int#!= (var122,var124) on <var122:Int> */
var127 = var122 == var124;
var128 = !var127;
var125 = var128;
goto RET_LABEL126;
RET_LABEL126:(void)0;
}
}
var_129 = var125;
if (var125){
var121 = var_129;
} else {
{
var131 = ((short int(*)(val* self))(var_peek_node->class->vft[COLOR_a_star__Node__open]))(var_peek_node); /* open on <var_peek_node:Node>*/
}
var_132 = var131;
if (var131){
{
var133 = ((long(*)(val* self))(var_peek_node->class->vft[COLOR_a_star__Node__best_cost_up_to]))(var_peek_node); /* best_cost_up_to on <var_peek_node:Node>*/
}
{
var134 = ((long(*)(val* self, val* p0))(var_context->class->vft[COLOR_a_star__PathContext__cost]))(var_context, var_link); /* cost on <var_context:PathContext>*/
}
{
{ /* Inline kernel#Int#+ (var_cost,var134) on <var_cost:Int> */
/* Covariant cast for argument 0 (i) <var134:Int> isa OTHER */
/* <var134:Int> isa OTHER */
var137 = 1; /* easy <var134:Int> isa OTHER*/
if (unlikely(!var137)) {
var_class_name140 = type_core__Int.name;
PRINT_ERROR("Runtime error: Cast failed. Expected `%s`, got `%s`", "OTHER", var_class_name140);
PRINT_ERROR(" (%s:%d)\n", FILE_core__kernel, 725);
fatal_exit(1);
}
var141 = var_cost + var134;
var135 = var141;
goto RET_LABEL136;
RET_LABEL136:(void)0;
}
}
{
{ /* Inline kernel#Int#> (var133,var135) on <var133:Int> */
/* Covariant cast for argument 0 (i) <var135:Int> isa OTHER */
/* <var135:Int> isa OTHER */
var144 = 1; /* easy <var135:Int> isa OTHER*/
if (unlikely(!var144)) {
var_class_name147 = type_core__Int.name;
PRINT_ERROR("Runtime error: Cast failed. Expected `%s`, got `%s`", "OTHER", var_class_name147);
PRINT_ERROR(" (%s:%d)\n", FILE_core__kernel, 724);
fatal_exit(1);
}
var148 = var133 > var135;
var142 = var148;
goto RET_LABEL143;
RET_LABEL143:(void)0;
}
}
var130 = var142;
} else {
var130 = var_132;
}
var121 = var130;
}
var117 = var121;
} else {
var117 = var_120;
}
if (var117){
{
((void(*)(val* self, short int p0))(var_peek_node->class->vft[COLOR_a_star__Node__open_61d]))(var_peek_node, 1); /* open= on <var_peek_node:Node>*/
}
{
var149 = ((val*(*)(val* self))(self->class->vft[COLOR_a_star__Node__graph]))(self); /* graph on <self:Node>*/
}
{
var150 = ((long(*)(val* self))(var149->class->vft[COLOR_a_star__Graph__pathfinding_current_evocation]))(var149); /* pathfinding_current_evocation on <var149:Graph[Node, Link]>*/
}
{
((void(*)(val* self, long p0))(var_peek_node->class->vft[COLOR_a_star__Node__last_pathfinding_evocation_61d]))(var_peek_node, var150); /* last_pathfinding_evocation= on <var_peek_node:Node>*/
}
{
var151 = ((long(*)(val* self, val* p0))(var_context->class->vft[COLOR_a_star__PathContext__cost]))(var_context, var_link); /* cost on <var_context:PathContext>*/
}
{
{ /* Inline kernel#Int#+ (var_cost,var151) on <var_cost:Int> */
/* Covariant cast for argument 0 (i) <var151:Int> isa OTHER */
/* <var151:Int> isa OTHER */
var154 = 1; /* easy <var151:Int> isa OTHER*/
if (unlikely(!var154)) {
var_class_name157 = type_core__Int.name;
PRINT_ERROR("Runtime error: Cast failed. Expected `%s`, got `%s`", "OTHER", var_class_name157);
PRINT_ERROR(" (%s:%d)\n", FILE_core__kernel, 725);
fatal_exit(1);
}
var158 = var_cost + var151;
var152 = var158;
goto RET_LABEL153;
RET_LABEL153:(void)0;
}
}
{
((void(*)(val* self, long p0))(var_peek_node->class->vft[COLOR_a_star__Node__best_cost_up_to_61d]))(var_peek_node, var152); /* best_cost_up_to= on <var_peek_node:Node>*/
}
{
((void(*)(val* self, val* p0))(var_peek_node->class->vft[COLOR_a_star__Node__best_source_61d]))(var_peek_node, var_frontier_node); /* best_source= on <var_peek_node:Node>*/
}
if (var_destination == NULL) {
var159 = 0; /* is null */
} else {
var159 = 1; /* arg is null and recv is not */
}
if (0) {
var160 = ((short int(*)(val* self, val* p0))(var_destination->class->vft[COLOR_core__kernel__Object___33d_61d]))(var_destination, ((val*)NULL)); /* != on <var_destination:nullable Node>*/
var159 = var160;
}
if (var159){
{
var161 = ((long(*)(val* self))(var_peek_node->class->vft[COLOR_a_star__Node__best_cost_up_to]))(var_peek_node); /* best_cost_up_to on <var_peek_node:Node>*/
}
{
var162 = ((long(*)(val* self, val* p0, val* p1))(var_context->class->vft[COLOR_a_star__PathContext__heuristic_cost]))(var_context, var_peek_node, var_destination); /* heuristic_cost on <var_context:PathContext>*/
}
{
{ /* Inline kernel#Int#+ (var161,var162) on <var161:Int> */
/* Covariant cast for argument 0 (i) <var162:Int> isa OTHER */
/* <var162:Int> isa OTHER */
var165 = 1; /* easy <var162:Int> isa OTHER*/
if (unlikely(!var165)) {
var_class_name168 = type_core__Int.name;
PRINT_ERROR("Runtime error: Cast failed. Expected `%s`, got `%s`", "OTHER", var_class_name168);
PRINT_ERROR(" (%s:%d)\n", FILE_core__kernel, 725);
fatal_exit(1);
}
var169 = var161 + var162;
var163 = var169;
goto RET_LABEL164;
RET_LABEL164:(void)0;
}
}
var170 = (val*)(var163<<2|1);
var_est_cost = var170;
} else {
if (var_alt_targets == NULL) {
var171 = 0; /* is null */
} else {
var171 = 1; /* arg is null and recv is not */
}
if (0) {
var172 = ((short int(*)(val* self, val* p0))(var_alt_targets->class->vft[COLOR_core__kernel__Object___33d_61d]))(var_alt_targets, ((val*)NULL)); /* != on <var_alt_targets:nullable TargetCondition[Node]>*/
var171 = var172;
}
if (var171){
{
var173 = ((long(*)(val* self))(var_peek_node->class->vft[COLOR_a_star__Node__best_cost_up_to]))(var_peek_node); /* best_cost_up_to on <var_peek_node:Node>*/
}
/* <var_peek_node:Node> isa N */
type_struct177 = self->type->resolution_table->types[COLOR_a_star__Node__N];
cltype175 = type_struct177->color;
idtype176 = type_struct177->id;
if(cltype175 >= var_peek_node->type->table_size) {
var174 = 0;
} else {
var174 = var_peek_node->type->type_table[cltype175] == idtype176;
}
if (unlikely(!var174)) {
var_class_name178 = var_peek_node == NULL ? "null" : var_peek_node->type->name;
PRINT_ERROR("Runtime error: Cast failed. Expected `%s`, got `%s`", "N", var_class_name178);
PRINT_ERROR(" (%s:%d)\n", FILE_a_star, 180);
fatal_exit(1);
}
{
var179 = ((long(*)(val* self, val* p0, val* p1))(var_alt_targets->class->vft[COLOR_a_star__TargetCondition__heuristic_cost]))(var_alt_targets, var_peek_node, var_link); /* heuristic_cost on <var_alt_targets:nullable TargetCondition[Node](TargetCondition[Node])>*/
}
{
{ /* Inline kernel#Int#+ (var173,var179) on <var173:Int> */
/* Covariant cast for argument 0 (i) <var179:Int> isa OTHER */
/* <var179:Int> isa OTHER */
var182 = 1; /* easy <var179:Int> isa OTHER*/
if (unlikely(!var182)) {
var_class_name185 = type_core__Int.name;
PRINT_ERROR("Runtime error: Cast failed. Expected `%s`, got `%s`", "OTHER", var_class_name185);
PRINT_ERROR(" (%s:%d)\n", FILE_core__kernel, 725);
fatal_exit(1);
}
var186 = var173 + var179;
var180 = var186;
goto RET_LABEL181;
RET_LABEL181:(void)0;
}
}
var187 = (val*)(var180<<2|1);
var_est_cost = var187;
} else {
var188 = (val*)(0l<<2|1);
var_est_cost = var188;
}
}
{
{ /* Inline kernel#Int#% (var_est_cost,var_nbr_buckets) on <var_est_cost:nullable Object(Int)> */
var191 = (long)(var_est_cost)>>2;
var192 = var191 % var_nbr_buckets;
var189 = var192;
goto RET_LABEL190;
RET_LABEL190:(void)0;
}
}
{
var193 = ((val*(*)(val* self, long p0))(var_buckets->class->vft[COLOR_core__abstract_collection__SequenceRead___91d_93d]))(var_buckets, var189); /* [] on <var_buckets:Array[List[Node]]>*/
}
var_at_bucket = var193;
/* <var_peek_node:Node> isa N */
type_struct197 = self->type->resolution_table->types[COLOR_a_star__Node__N];
cltype195 = type_struct197->color;
idtype196 = type_struct197->id;
if(cltype195 >= var_peek_node->type->table_size) {
var194 = 0;
} else {
var194 = var_peek_node->type->type_table[cltype195] == idtype196;
}
if (unlikely(!var194)) {
var_class_name198 = var_peek_node == NULL ? "null" : var_peek_node->type->name;
PRINT_ERROR("Runtime error: Cast failed. Expected `%s`, got `%s`", "N", var_class_name198);
PRINT_ERROR(" (%s:%d)\n", FILE_a_star, 184);
fatal_exit(1);
}
{
((void(*)(val* self, val* p0))(var_at_bucket->class->vft[COLOR_core__abstract_collection__SimpleCollection__add]))(var_at_bucket, var_peek_node); /* add on <var_at_bucket:List[Node]>*/
}
} else {
}
{
((void(*)(val* self))((((long)var_112&3)?class_info[((long)var_112&3)]:var_112->class)->vft[COLOR_core__abstract_collection__Iterator__next]))(var_112); /* next on <var_112:Iterator[Link]>*/
}
}
BREAK_label114: (void)0;
{
((void(*)(val* self))((((long)var_112&3)?class_info[((long)var_112&3)]:var_112->class)->vft[COLOR_core__abstract_collection__Iterator__finish]))(var_112); /* finish on <var_112:Iterator[Link]>*/
}
}
}
}
RET_LABEL:;
return var;
}
/* method a_star#Node#find_closest for (self: Node, Int, PathContext, nullable TargetCondition[Node]): nullable Node */
val* a_star___a_star__Node___find_closest(val* self, long p0, val* p1, val* p2) {
val* var /* : nullable Node */;
short int var1 /* : Bool */;
int cltype;
int idtype;
const struct type* type_struct;
const char* var_class_name;
long var_max_cost /* var max_cost: Int */;
val* var_context /* var context: PathContext */;
val* var_cond /* var cond: nullable TargetCondition[Node] */;
val* var2 /* : nullable AStarPath[Node] */;
val* var_path /* var path: nullable AStarPath[Node] */;
short int var3 /* : Bool */;
short int var4 /* : Bool */;
val* var5 /* : List[nullable Object] */;
val* var6 /* : nullable Object */;
/* Covariant cast for argument 2 (cond) <p2:nullable TargetCondition[Node]> isa nullable TargetCondition[N] */
/* <p2:nullable TargetCondition[Node]> isa nullable TargetCondition[N] */
type_struct = self->type->resolution_table->types[COLOR_nullable__a_star__TargetCondition__a_star__Node__N];
cltype = type_struct->color;
idtype = type_struct->id;
if(p2 == NULL) {
var1 = 1;
} else {
if(cltype >= p2->type->table_size) {
var1 = 0;
} else {
var1 = p2->type->type_table[cltype] == idtype;
}
}
if (unlikely(!var1)) {
var_class_name = p2 == NULL ? "null" : p2->type->name;
PRINT_ERROR("Runtime error: Cast failed. Expected `%s`, got `%s`", "nullable TargetCondition[N]", var_class_name);
PRINT_ERROR(" (%s:%d)\n", FILE_a_star, 191);
fatal_exit(1);
}
var_max_cost = p0;
var_context = p1;
var_cond = p2;
{
var2 = ((val*(*)(val* self, val* p0, long p1, val* p2, val* p3))(self->class->vft[COLOR_a_star__Node__path_to_alts]))(self, ((val*)NULL), var_max_cost, var_context, var_cond); /* path_to_alts on <self:Node>*/
}
var_path = var2;
if (var_path == NULL) {
var3 = 1; /* is null */
} else {
var3 = 0; /* arg is null but recv is not */
}
if (0) {
var4 = ((short int(*)(val* self, val* p0))(var_path->class->vft[COLOR_core__kernel__Object___61d_61d]))(var_path, ((val*)NULL)); /* == on <var_path:nullable AStarPath[Node]>*/
var3 = var4;
}
if (var3){
var = ((val*)NULL);
goto RET_LABEL;
} else {
}
{
var5 = ((val*(*)(val* self))(var_path->class->vft[COLOR_a_star__AStarPath__nodes]))(var_path); /* nodes on <var_path:nullable AStarPath[Node](AStarPath[Node])>*/
}
{
var6 = ((val*(*)(val* self))(var5->class->vft[COLOR_core__abstract_collection__SequenceRead__last]))(var5); /* last on <var5:List[nullable Object](List[Node])>*/
}
var = var6;
goto RET_LABEL;
RET_LABEL:;
return var;
}
/* method a_star#Node#core_serialize_to for (self: Node, Serializer) */
void a_star___a_star__Node___serialization__Serializable__core_serialize_to(val* self, val* p0) {
val* var_serializer /* var serializer: Serializer */;
static val* varonce;
val* var /* : String */;
char* var1 /* : NativeString */;
val* var2 /* : String */;
val* var3 /* : Graph[Node, Link] */;
var_serializer = p0;
if (likely(varonce!=NULL)) {
var = varonce;
} else {
var1 = "graph";
var2 = core__flat___NativeString___to_s_full(var1, 5l, 5l);
var = var2;
varonce = var;
}
{
var3 = ((val*(*)(val* self))(self->class->vft[COLOR_a_star__Node__graph]))(self); /* graph on <self:Node>*/
}
{
((void(*)(val* self, val* p0, val* p1))((((long)var_serializer&3)?class_info[((long)var_serializer&3)]:var_serializer->class)->vft[COLOR_serialization__Serializer__serialize_attribute]))(var_serializer, var, var3); /* serialize_attribute on <var_serializer:Serializer>*/
}
RET_LABEL:;
}
/* method a_star#Node#from_deserializer for (self: Node, Deserializer) */
void a_star___a_star__Node___serialization__Serializable__from_deserializer(val* self, val* p0) {
val* var_deserializer /* var deserializer: Deserializer */;
static val* varonce;
val* var /* : String */;
char* var1 /* : NativeString */;
val* var2 /* : String */;
val* var3 /* : nullable Object */;
val* var_graph /* var graph: nullable Object */;
short int var4 /* : Bool */;
int cltype;
int idtype;
const struct type* type_struct;
short int is_nullable;
{
((void(*)(val* self, val* p0))(self->class->vft[COLOR_a_star___a_star__Node___serialization__Serializable__from_deserializer]))(self, p0); /* from_deserializer on <self:Node>*/
}
var_deserializer = p0;
{
((void(*)(val* self, val* p0))(var_deserializer->class->vft[COLOR_serialization__Deserializer__notify_of_creation]))(var_deserializer, self); /* notify_of_creation on <var_deserializer:Deserializer>*/
}
if (likely(varonce!=NULL)) {
var = varonce;
} else {
var1 = "graph";
var2 = core__flat___NativeString___to_s_full(var1, 5l, 5l);
var = var2;
varonce = var;
}
{
var3 = ((val*(*)(val* self, val* p0))(var_deserializer->class->vft[COLOR_serialization__Deserializer__deserialize_attribute]))(var_deserializer, var); /* deserialize_attribute on <var_deserializer:Deserializer>*/
}
var_graph = var3;
/* <var_graph:nullable Object> isa Graph[N, Link] */
type_struct = self->type->resolution_table->types[COLOR_a_star__Graph__a_star__Node__N__a_star__Link];
cltype = type_struct->color;
idtype = type_struct->id;
is_nullable = type_struct->is_nullable;
if(var_graph == NULL) {
var4 = is_nullable;
} else {
if(cltype >= (((long)var_graph&3)?type_info[((long)var_graph&3)]:var_graph->type)->table_size) {
var4 = 0;
} else {
var4 = (((long)var_graph&3)?type_info[((long)var_graph&3)]:var_graph->type)->type_table[cltype] == idtype;
}
}
if (unlikely(!var4)) {
PRINT_ERROR("Runtime error: %s", "Assert failed");
PRINT_ERROR(" (%s:%d)\n", FILE_a_star, 215);
fatal_exit(1);
}
{
((void(*)(val* self, val* p0))(self->class->vft[COLOR_a_star__Node__graph_61d]))(self, var_graph); /* graph= on <self:Node>*/
}
RET_LABEL:;
}
/* method a_star#Link#graph for (self: Link): Graph[Node, Link] */
val* a_star___a_star__Link___graph(val* self) {
val* var /* : Graph[Node, Link] */;
val* var1 /* : Graph[Node, Link] */;
var1 = self->attrs[COLOR_a_star__Link___graph].val; /* _graph on <self:Link> */
if (unlikely(var1 == NULL)) {
PRINT_ERROR("Runtime error: %s", "Uninitialized attribute _graph");
PRINT_ERROR(" (%s:%d)\n", FILE_a_star, 230);
fatal_exit(1);
}
var = var1;
RET_LABEL:;
return var;
}
/* method a_star#Link#graph= for (self: Link, Graph[Node, Link]) */
void a_star___a_star__Link___graph_61d(val* self, val* p0) {
short int var /* : Bool */;
int cltype;
int idtype;
const struct type* type_struct;
const char* var_class_name;
/* Covariant cast for argument 0 (graph) <p0:Graph[Node, Link]> isa Graph[N, L] */
/* <p0:Graph[Node, Link]> isa Graph[N, L] */
type_struct = self->type->resolution_table->types[COLOR_a_star__Graph__a_star__Link__N__a_star__Link__L];
cltype = type_struct->color;
idtype = type_struct->id;
if(cltype >= p0->type->table_size) {
var = 0;
} else {
var = p0->type->type_table[cltype] == idtype;
}
if (unlikely(!var)) {
var_class_name = p0 == NULL ? "null" : p0->type->name;
PRINT_ERROR("Runtime error: Cast failed. Expected `%s`, got `%s`", "Graph[N, L]", var_class_name);
PRINT_ERROR(" (%s:%d)\n", FILE_a_star, 230);
fatal_exit(1);
}
self->attrs[COLOR_a_star__Link___graph].val = p0; /* _graph on <self:Link> */
RET_LABEL:;
}
/* method a_star#Link#from for (self: Link): Node */
val* a_star___a_star__Link___from(val* self) {
val* var /* : Node */;
val* var1 /* : Node */;
var1 = self->attrs[COLOR_a_star__Link___from].val; /* _from on <self:Link> */
if (unlikely(var1 == NULL)) {
PRINT_ERROR("Runtime error: %s", "Uninitialized attribute _from");
PRINT_ERROR(" (%s:%d)\n", FILE_a_star, 233);
fatal_exit(1);
}
var = var1;
RET_LABEL:;
return var;
}
/* method a_star#Link#from= for (self: Link, Node) */
void a_star___a_star__Link___from_61d(val* self, val* p0) {
short int var /* : Bool */;
int cltype;
int idtype;
const struct type* type_struct;
const char* var_class_name;
/* Covariant cast for argument 0 (from) <p0:Node> isa N */
/* <p0:Node> isa N */
type_struct = self->type->resolution_table->types[COLOR_a_star__Link__N];
cltype = type_struct->color;
idtype = type_struct->id;
if(cltype >= p0->type->table_size) {
var = 0;
} else {
var = p0->type->type_table[cltype] == idtype;
}
if (unlikely(!var)) {
var_class_name = p0 == NULL ? "null" : p0->type->name;
PRINT_ERROR("Runtime error: Cast failed. Expected `%s`, got `%s`", "N", var_class_name);
PRINT_ERROR(" (%s:%d)\n", FILE_a_star, 233);
fatal_exit(1);
}
self->attrs[COLOR_a_star__Link___from].val = p0; /* _from on <self:Link> */
RET_LABEL:;
}
/* method a_star#Link#to for (self: Link): Node */
val* a_star___a_star__Link___to(val* self) {
val* var /* : Node */;
val* var1 /* : Node */;
var1 = self->attrs[COLOR_a_star__Link___to].val; /* _to on <self:Link> */
if (unlikely(var1 == NULL)) {
PRINT_ERROR("Runtime error: %s", "Uninitialized attribute _to");
PRINT_ERROR(" (%s:%d)\n", FILE_a_star, 236);
fatal_exit(1);
}
var = var1;
RET_LABEL:;
return var;
}
/* method a_star#Link#to= for (self: Link, Node) */
void a_star___a_star__Link___to_61d(val* self, val* p0) {
short int var /* : Bool */;
int cltype;
int idtype;
const struct type* type_struct;
const char* var_class_name;
/* Covariant cast for argument 0 (to) <p0:Node> isa N */
/* <p0:Node> isa N */
type_struct = self->type->resolution_table->types[COLOR_a_star__Link__N];
cltype = type_struct->color;
idtype = type_struct->id;
if(cltype >= p0->type->table_size) {
var = 0;
} else {
var = p0->type->type_table[cltype] == idtype;
}
if (unlikely(!var)) {
var_class_name = p0 == NULL ? "null" : p0->type->name;
PRINT_ERROR("Runtime error: Cast failed. Expected `%s`, got `%s`", "N", var_class_name);
PRINT_ERROR(" (%s:%d)\n", FILE_a_star, 236);
fatal_exit(1);
}
self->attrs[COLOR_a_star__Link___to].val = p0; /* _to on <self:Link> */
RET_LABEL:;
}
/* method a_star#Link#init for (self: Link) */
void a_star___a_star__Link___core__kernel__Object__init(val* self) {
val* var /* : Graph[Node, Link] */;
short int var1 /* : Bool */;
int cltype;
int idtype;
const struct type* type_struct;
const char* var_class_name;
val* var2 /* : Link */;
{
((void(*)(val* self))(self->class->vft[COLOR_a_star___a_star__Link___core__kernel__Object__init]))(self); /* init on <self:Link>*/
}
{
var = ((val*(*)(val* self))(self->class->vft[COLOR_a_star__Link__graph]))(self); /* graph on <self:Link>*/
}
/* <self:Link> isa L */
type_struct = self->type->resolution_table->types[COLOR_a_star__Link__L];
cltype = type_struct->color;
idtype = type_struct->id;
if(cltype >= self->type->table_size) {
var1 = 0;
} else {
var1 = self->type->type_table[cltype] == idtype;
}
if (unlikely(!var1)) {
var_class_name = self == NULL ? "null" : self->type->name;
PRINT_ERROR("Runtime error: Cast failed. Expected `%s`, got `%s`", "L", var_class_name);
PRINT_ERROR(" (%s:%d)\n", FILE_a_star, 241);
fatal_exit(1);
}
{
var2 = ((val*(*)(val* self, val* p0))(var->class->vft[COLOR_a_star__Graph__add_link]))(var, self); /* add_link on <var:Graph[Node, Link]>*/
}
RET_LABEL:;
}
/* method a_star#Link#core_serialize_to for (self: Link, Serializer) */
void a_star___a_star__Link___serialization__Serializable__core_serialize_to(val* self, val* p0) {
val* var_v /* var v: Serializer */;
static val* varonce;
val* var /* : String */;
char* var1 /* : NativeString */;
val* var2 /* : String */;
val* var3 /* : Graph[Node, Link] */;
static val* varonce4;
val* var5 /* : String */;
char* var6 /* : NativeString */;
val* var7 /* : String */;
val* var8 /* : Node */;
static val* varonce9;
val* var10 /* : String */;
char* var11 /* : NativeString */;
val* var12 /* : String */;
val* var13 /* : Node */;
var_v = p0;
{
((void(*)(val* self, val* p0))(self->class->vft[COLOR_a_star___a_star__Link___serialization__Serializable__core_serialize_to]))(self, p0); /* core_serialize_to on <self:Link>*/
}
if (likely(varonce!=NULL)) {
var = varonce;
} else {
var1 = "graph";
var2 = core__flat___NativeString___to_s_full(var1, 5l, 5l);
var = var2;
varonce = var;
}
{
var3 = ((val*(*)(val* self))(self->class->vft[COLOR_a_star__Link__graph]))(self); /* graph on <self:Link>*/
}
{
((void(*)(val* self, val* p0, val* p1))((((long)var_v&3)?class_info[((long)var_v&3)]:var_v->class)->vft[COLOR_serialization__Serializer__serialize_attribute]))(var_v, var, var3); /* serialize_attribute on <var_v:Serializer>*/
}
if (likely(varonce4!=NULL)) {
var5 = varonce4;
} else {
var6 = "from";
var7 = core__flat___NativeString___to_s_full(var6, 4l, 4l);
var5 = var7;
varonce4 = var5;
}
{
var8 = ((val*(*)(val* self))(self->class->vft[COLOR_a_star__Link__from]))(self); /* from on <self:Link>*/
}
{
((void(*)(val* self, val* p0, val* p1))((((long)var_v&3)?class_info[((long)var_v&3)]:var_v->class)->vft[COLOR_serialization__Serializer__serialize_attribute]))(var_v, var5, var8); /* serialize_attribute on <var_v:Serializer>*/
}
if (likely(varonce9!=NULL)) {
var10 = varonce9;
} else {
var11 = "to";
var12 = core__flat___NativeString___to_s_full(var11, 2l, 2l);
var10 = var12;
varonce9 = var10;
}
{
var13 = ((val*(*)(val* self))(self->class->vft[COLOR_a_star__Link__to]))(self); /* to on <self:Link>*/
}
{
((void(*)(val* self, val* p0, val* p1))((((long)var_v&3)?class_info[((long)var_v&3)]:var_v->class)->vft[COLOR_serialization__Serializer__serialize_attribute]))(var_v, var10, var13); /* serialize_attribute on <var_v:Serializer>*/
}
RET_LABEL:;
}
/* method a_star#Link#from_deserializer for (self: Link, Deserializer) */
void a_star___a_star__Link___serialization__Serializable__from_deserializer(val* self, val* p0) {
val* var_v /* var v: Deserializer */;
static val* varonce;
val* var /* : String */;
char* var1 /* : NativeString */;
val* var2 /* : String */;
val* var3 /* : nullable Object */;
val* var_graph /* var graph: nullable Object */;
short int var4 /* : Bool */;
int cltype;
int idtype;
const struct type* type_struct;
short int is_nullable;
short int var5 /* : Bool */;
val* var6 /* : Array[Error] */;
val* var7 /* : AttributeTypeError */;
static val* varonce8;
val* var9 /* : String */;
char* var10 /* : NativeString */;
val* var11 /* : String */;
static val* varonce12;
val* var13 /* : String */;
char* var14 /* : NativeString */;
val* var15 /* : String */;
static val* varonce16;
val* var17 /* : String */;
char* var18 /* : NativeString */;
val* var19 /* : String */;
val* var20 /* : nullable Bool */;
short int var21 /* : Bool */;
short int var22 /* : Bool */;
short int var24 /* : Bool */;
short int var25 /* : Bool */;
static val* varonce26;
val* var27 /* : String */;
char* var28 /* : NativeString */;
val* var29 /* : String */;
val* var30 /* : nullable Object */;
val* var_from /* var from: nullable Object */;
short int var31 /* : Bool */;
int cltype32;
int idtype33;
const struct type* type_struct34;
short int is_nullable35;
short int var36 /* : Bool */;
val* var37 /* : Array[Error] */;
val* var38 /* : AttributeTypeError */;
static val* varonce39;
val* var40 /* : String */;
char* var41 /* : NativeString */;
val* var42 /* : String */;
static val* varonce43;
val* var44 /* : String */;
char* var45 /* : NativeString */;
val* var46 /* : String */;
static val* varonce47;
val* var48 /* : String */;
char* var49 /* : NativeString */;
val* var50 /* : String */;
val* var51 /* : nullable Bool */;
short int var52 /* : Bool */;
short int var53 /* : Bool */;
short int var55 /* : Bool */;
short int var56 /* : Bool */;
static val* varonce57;
val* var58 /* : String */;
char* var59 /* : NativeString */;
val* var60 /* : String */;
val* var61 /* : nullable Object */;
val* var_to /* var to: nullable Object */;
short int var62 /* : Bool */;
int cltype63;
int idtype64;
const struct type* type_struct65;
short int is_nullable66;
short int var67 /* : Bool */;
val* var68 /* : Array[Error] */;
val* var69 /* : AttributeTypeError */;
static val* varonce70;
val* var71 /* : String */;
char* var72 /* : NativeString */;
val* var73 /* : String */;
static val* varonce74;
val* var75 /* : String */;
char* var76 /* : NativeString */;
val* var77 /* : String */;
static val* varonce78;
val* var79 /* : String */;
char* var80 /* : NativeString */;
val* var81 /* : String */;
val* var82 /* : nullable Bool */;
short int var83 /* : Bool */;
short int var84 /* : Bool */;
short int var86 /* : Bool */;
short int var87 /* : Bool */;
var_v = p0;
{
((void(*)(val* self, val* p0))(self->class->vft[COLOR_a_star___a_star__Link___serialization__Serializable__from_deserializer]))(self, p0); /* from_deserializer on <self:Link>*/
}
{
((void(*)(val* self, val* p0))(var_v->class->vft[COLOR_serialization__Deserializer__notify_of_creation]))(var_v, self); /* notify_of_creation on <var_v:Deserializer>*/
}
if (likely(varonce!=NULL)) {
var = varonce;
} else {
var1 = "graph";
var2 = core__flat___NativeString___to_s_full(var1, 5l, 5l);
var = var2;
varonce = var;
}
{
var3 = ((val*(*)(val* self, val* p0))(var_v->class->vft[COLOR_serialization__Deserializer__deserialize_attribute]))(var_v, var); /* deserialize_attribute on <var_v:Deserializer>*/
}
var_graph = var3;
/* <var_graph:nullable Object> isa Graph[N, L] */
type_struct = self->type->resolution_table->types[COLOR_a_star__Graph__a_star__Link__N__a_star__Link__L];
cltype = type_struct->color;
idtype = type_struct->id;
is_nullable = type_struct->is_nullable;
if(var_graph == NULL) {
var4 = is_nullable;
} else {
if(cltype >= (((long)var_graph&3)?type_info[((long)var_graph&3)]:var_graph->type)->table_size) {
var4 = 0;
} else {
var4 = (((long)var_graph&3)?type_info[((long)var_graph&3)]:var_graph->type)->type_table[cltype] == idtype;
}
}
var5 = !var4;
if (var5){
{
var6 = ((val*(*)(val* self))(var_v->class->vft[COLOR_serialization__Deserializer__errors]))(var_v); /* errors on <var_v:Deserializer>*/
}
var7 = NEW_serialization__AttributeTypeError(&type_serialization__AttributeTypeError);
if (likely(varonce8!=NULL)) {
var9 = varonce8;
} else {
var10 = "TODO remove this arg on c_src regen";
var11 = core__flat___NativeString___to_s_full(var10, 35l, 35l);
var9 = var11;
varonce8 = var9;
}
if (likely(varonce12!=NULL)) {
var13 = varonce12;
} else {
var14 = "graph";
var15 = core__flat___NativeString___to_s_full(var14, 5l, 5l);
var13 = var15;
varonce12 = var13;
}
if (likely(varonce16!=NULL)) {
var17 = varonce16;
} else {
var18 = "Graph[N, L]";
var19 = core__flat___NativeString___to_s_full(var18, 11l, 11l);
var17 = var19;
varonce16 = var17;
}
{
((void(*)(val* self, val* p0))(var7->class->vft[COLOR_core__error__Error__message_61d]))(var7, var9); /* message= on <var7:AttributeTypeError>*/
}
{
((void(*)(val* self, val* p0))(var7->class->vft[COLOR_serialization__AttributeTypeError__receiver_61d]))(var7, self); /* receiver= on <var7:AttributeTypeError>*/
}
{
((void(*)(val* self, val* p0))(var7->class->vft[COLOR_serialization__AttributeTypeError__attribute_name_61d]))(var7, var13); /* attribute_name= on <var7:AttributeTypeError>*/
}
{
((void(*)(val* self, val* p0))(var7->class->vft[COLOR_serialization__AttributeTypeError__attribute_61d]))(var7, var_graph); /* attribute= on <var7:AttributeTypeError>*/
}
{
((void(*)(val* self, val* p0))(var7->class->vft[COLOR_serialization__AttributeTypeError__expected_type_61d]))(var7, var17); /* expected_type= on <var7:AttributeTypeError>*/
}
{
((void(*)(val* self))(var7->class->vft[COLOR_core__kernel__Object__init]))(var7); /* init on <var7:AttributeTypeError>*/
}
{
((void(*)(val* self, val* p0))(var6->class->vft[COLOR_core__abstract_collection__SimpleCollection__add]))(var6, var7); /* add on <var6:Array[Error]>*/
}
{
var20 = ((val*(*)(val* self))(var_v->class->vft[COLOR_serialization__Deserializer__keep_going]))(var_v); /* keep_going on <var_v:Deserializer>*/
}
if (var20 == NULL) {
var21 = 0; /* <0:Bool> cannot be null */
} else {
{ /* Inline kernel#Bool#== (var20,0) on <var20:nullable Bool> */
if ((var20 != NULL)) {
var25 = (short int)((long)(var20)>>2);
var24 = var25 == 0;
} else var24 = 0;
var22 = var24;
goto RET_LABEL23;
RET_LABEL23:(void)0;
}
var21 = var22;
}
if (var21){
goto RET_LABEL;
} else {
}
} else {
{
((void(*)(val* self, val* p0))(self->class->vft[COLOR_a_star__Link__graph_61d]))(self, var_graph); /* graph= on <self:Link>*/
}
}
if (likely(varonce26!=NULL)) {
var27 = varonce26;
} else {
var28 = "from";
var29 = core__flat___NativeString___to_s_full(var28, 4l, 4l);
var27 = var29;
varonce26 = var27;
}
{
var30 = ((val*(*)(val* self, val* p0))(var_v->class->vft[COLOR_serialization__Deserializer__deserialize_attribute]))(var_v, var27); /* deserialize_attribute on <var_v:Deserializer>*/
}
var_from = var30;
/* <var_from:nullable Object> isa N */
type_struct34 = self->type->resolution_table->types[COLOR_a_star__Link__N];
cltype32 = type_struct34->color;
idtype33 = type_struct34->id;
is_nullable35 = type_struct34->is_nullable;
if(var_from == NULL) {
var31 = is_nullable35;
} else {
if(cltype32 >= (((long)var_from&3)?type_info[((long)var_from&3)]:var_from->type)->table_size) {
var31 = 0;
} else {
var31 = (((long)var_from&3)?type_info[((long)var_from&3)]:var_from->type)->type_table[cltype32] == idtype33;
}
}
var36 = !var31;
if (var36){
{
var37 = ((val*(*)(val* self))(var_v->class->vft[COLOR_serialization__Deserializer__errors]))(var_v); /* errors on <var_v:Deserializer>*/
}
var38 = NEW_serialization__AttributeTypeError(&type_serialization__AttributeTypeError);
if (likely(varonce39!=NULL)) {
var40 = varonce39;
} else {
var41 = "TODO remove this arg on c_src regen";
var42 = core__flat___NativeString___to_s_full(var41, 35l, 35l);
var40 = var42;
varonce39 = var40;
}
if (likely(varonce43!=NULL)) {
var44 = varonce43;
} else {
var45 = "from";
var46 = core__flat___NativeString___to_s_full(var45, 4l, 4l);
var44 = var46;
varonce43 = var44;
}
if (likely(varonce47!=NULL)) {
var48 = varonce47;
} else {
var49 = "N";
var50 = core__flat___NativeString___to_s_full(var49, 1l, 1l);
var48 = var50;
varonce47 = var48;
}
{
((void(*)(val* self, val* p0))(var38->class->vft[COLOR_core__error__Error__message_61d]))(var38, var40); /* message= on <var38:AttributeTypeError>*/
}
{
((void(*)(val* self, val* p0))(var38->class->vft[COLOR_serialization__AttributeTypeError__receiver_61d]))(var38, self); /* receiver= on <var38:AttributeTypeError>*/
}
{
((void(*)(val* self, val* p0))(var38->class->vft[COLOR_serialization__AttributeTypeError__attribute_name_61d]))(var38, var44); /* attribute_name= on <var38:AttributeTypeError>*/
}
{
((void(*)(val* self, val* p0))(var38->class->vft[COLOR_serialization__AttributeTypeError__attribute_61d]))(var38, var_from); /* attribute= on <var38:AttributeTypeError>*/
}
{
((void(*)(val* self, val* p0))(var38->class->vft[COLOR_serialization__AttributeTypeError__expected_type_61d]))(var38, var48); /* expected_type= on <var38:AttributeTypeError>*/
}
{
((void(*)(val* self))(var38->class->vft[COLOR_core__kernel__Object__init]))(var38); /* init on <var38:AttributeTypeError>*/
}
{
((void(*)(val* self, val* p0))(var37->class->vft[COLOR_core__abstract_collection__SimpleCollection__add]))(var37, var38); /* add on <var37:Array[Error]>*/
}
{
var51 = ((val*(*)(val* self))(var_v->class->vft[COLOR_serialization__Deserializer__keep_going]))(var_v); /* keep_going on <var_v:Deserializer>*/
}
if (var51 == NULL) {
var52 = 0; /* <0:Bool> cannot be null */
} else {
{ /* Inline kernel#Bool#== (var51,0) on <var51:nullable Bool> */
if ((var51 != NULL)) {
var56 = (short int)((long)(var51)>>2);
var55 = var56 == 0;
} else var55 = 0;
var53 = var55;
goto RET_LABEL54;
RET_LABEL54:(void)0;
}
var52 = var53;
}
if (var52){
goto RET_LABEL;
} else {
}
} else {
{
((void(*)(val* self, val* p0))(self->class->vft[COLOR_a_star__Link__from_61d]))(self, var_from); /* from= on <self:Link>*/
}
}
if (likely(varonce57!=NULL)) {
var58 = varonce57;
} else {
var59 = "to";
var60 = core__flat___NativeString___to_s_full(var59, 2l, 2l);
var58 = var60;
varonce57 = var58;
}
{
var61 = ((val*(*)(val* self, val* p0))(var_v->class->vft[COLOR_serialization__Deserializer__deserialize_attribute]))(var_v, var58); /* deserialize_attribute on <var_v:Deserializer>*/
}
var_to = var61;
/* <var_to:nullable Object> isa N */
type_struct65 = self->type->resolution_table->types[COLOR_a_star__Link__N];
cltype63 = type_struct65->color;
idtype64 = type_struct65->id;
is_nullable66 = type_struct65->is_nullable;
if(var_to == NULL) {
var62 = is_nullable66;
} else {
if(cltype63 >= (((long)var_to&3)?type_info[((long)var_to&3)]:var_to->type)->table_size) {
var62 = 0;
} else {
var62 = (((long)var_to&3)?type_info[((long)var_to&3)]:var_to->type)->type_table[cltype63] == idtype64;
}
}
var67 = !var62;
if (var67){
{
var68 = ((val*(*)(val* self))(var_v->class->vft[COLOR_serialization__Deserializer__errors]))(var_v); /* errors on <var_v:Deserializer>*/
}
var69 = NEW_serialization__AttributeTypeError(&type_serialization__AttributeTypeError);
if (likely(varonce70!=NULL)) {
var71 = varonce70;
} else {
var72 = "TODO remove this arg on c_src regen";
var73 = core__flat___NativeString___to_s_full(var72, 35l, 35l);
var71 = var73;
varonce70 = var71;
}
if (likely(varonce74!=NULL)) {
var75 = varonce74;
} else {
var76 = "to";
var77 = core__flat___NativeString___to_s_full(var76, 2l, 2l);
var75 = var77;
varonce74 = var75;
}
if (likely(varonce78!=NULL)) {
var79 = varonce78;
} else {
var80 = "N";
var81 = core__flat___NativeString___to_s_full(var80, 1l, 1l);
var79 = var81;
varonce78 = var79;
}
{
((void(*)(val* self, val* p0))(var69->class->vft[COLOR_core__error__Error__message_61d]))(var69, var71); /* message= on <var69:AttributeTypeError>*/
}
{
((void(*)(val* self, val* p0))(var69->class->vft[COLOR_serialization__AttributeTypeError__receiver_61d]))(var69, self); /* receiver= on <var69:AttributeTypeError>*/
}
{
((void(*)(val* self, val* p0))(var69->class->vft[COLOR_serialization__AttributeTypeError__attribute_name_61d]))(var69, var75); /* attribute_name= on <var69:AttributeTypeError>*/
}
{
((void(*)(val* self, val* p0))(var69->class->vft[COLOR_serialization__AttributeTypeError__attribute_61d]))(var69, var_to); /* attribute= on <var69:AttributeTypeError>*/
}
{
((void(*)(val* self, val* p0))(var69->class->vft[COLOR_serialization__AttributeTypeError__expected_type_61d]))(var69, var79); /* expected_type= on <var69:AttributeTypeError>*/
}
{
((void(*)(val* self))(var69->class->vft[COLOR_core__kernel__Object__init]))(var69); /* init on <var69:AttributeTypeError>*/
}
{
((void(*)(val* self, val* p0))(var68->class->vft[COLOR_core__abstract_collection__SimpleCollection__add]))(var68, var69); /* add on <var68:Array[Error]>*/
}
{
var82 = ((val*(*)(val* self))(var_v->class->vft[COLOR_serialization__Deserializer__keep_going]))(var_v); /* keep_going on <var_v:Deserializer>*/
}
if (var82 == NULL) {
var83 = 0; /* <0:Bool> cannot be null */
} else {
{ /* Inline kernel#Bool#== (var82,0) on <var82:nullable Bool> */
if ((var82 != NULL)) {
var87 = (short int)((long)(var82)>>2);
var86 = var87 == 0;
} else var86 = 0;
var84 = var86;
goto RET_LABEL85;
RET_LABEL85:(void)0;
}
var83 = var84;
}
if (var83){
goto RET_LABEL;
} else {
}
} else {
{
((void(*)(val* self, val* p0))(self->class->vft[COLOR_a_star__Link__to_61d]))(self, var_to); /* to= on <self:Link>*/
}
}
RET_LABEL:;
}
/* method a_star#Graph#nodes for (self: Graph[Node, Link]): Set[Node] */
val* a_star___a_star__Graph___nodes(val* self) {
val* var /* : Set[Node] */;
val* var1 /* : Set[Node] */;
var1 = self->attrs[COLOR_a_star__Graph___nodes].val; /* _nodes on <self:Graph[Node, Link]> */
if (unlikely(var1 == NULL)) {
PRINT_ERROR("Runtime error: %s", "Uninitialized attribute _nodes");
PRINT_ERROR(" (%s:%d)\n", FILE_a_star, 249);
fatal_exit(1);
}
var = var1;
RET_LABEL:;
return var;
}
/* method a_star#Graph#nodes= for (self: Graph[Node, Link], Set[Node]) */
void a_star___a_star__Graph___nodes_61d(val* self, val* p0) {
short int var /* : Bool */;
int cltype;
int idtype;
const struct type* type_struct;
const char* var_class_name;
/* Covariant cast for argument 0 (nodes) <p0:Set[Node]> isa Set[N] */
/* <p0:Set[Node]> isa Set[N] */
type_struct = self->type->resolution_table->types[COLOR_core__Set__a_star__Graph___35dN];
cltype = type_struct->color;
idtype = type_struct->id;
if(cltype >= (((long)p0&3)?type_info[((long)p0&3)]:p0->type)->table_size) {
var = 0;
} else {
var = (((long)p0&3)?type_info[((long)p0&3)]:p0->type)->type_table[cltype] == idtype;
}
if (unlikely(!var)) {
var_class_name = p0 == NULL ? "null" : (((long)p0&3)?type_info[((long)p0&3)]:p0->type)->name;
PRINT_ERROR("Runtime error: Cast failed. Expected `%s`, got `%s`", "Set[N]", var_class_name);
PRINT_ERROR(" (%s:%d)\n", FILE_a_star, 249);
fatal_exit(1);
}
self->attrs[COLOR_a_star__Graph___nodes].val = p0; /* _nodes on <self:Graph[Node, Link]> */
RET_LABEL:;
}
/* method a_star#Graph#links for (self: Graph[Node, Link]): Set[Link] */
val* a_star___a_star__Graph___links(val* self) {
val* var /* : Set[Link] */;
val* var1 /* : Set[Link] */;
var1 = self->attrs[COLOR_a_star__Graph___links].val; /* _links on <self:Graph[Node, Link]> */
if (unlikely(var1 == NULL)) {
PRINT_ERROR("Runtime error: %s", "Uninitialized attribute _links");
PRINT_ERROR(" (%s:%d)\n", FILE_a_star, 252);
fatal_exit(1);
}
var = var1;
RET_LABEL:;
return var;
}
/* method a_star#Graph#links= for (self: Graph[Node, Link], Set[Link]) */
void a_star___a_star__Graph___links_61d(val* self, val* p0) {
short int var /* : Bool */;
int cltype;
int idtype;
const struct type* type_struct;
const char* var_class_name;
/* Covariant cast for argument 0 (links) <p0:Set[Link]> isa Set[L] */
/* <p0:Set[Link]> isa Set[L] */
type_struct = self->type->resolution_table->types[COLOR_core__Set__a_star__Graph___35dL];
cltype = type_struct->color;
idtype = type_struct->id;
if(cltype >= (((long)p0&3)?type_info[((long)p0&3)]:p0->type)->table_size) {
var = 0;
} else {
var = (((long)p0&3)?type_info[((long)p0&3)]:p0->type)->type_table[cltype] == idtype;
}
if (unlikely(!var)) {
var_class_name = p0 == NULL ? "null" : (((long)p0&3)?type_info[((long)p0&3)]:p0->type)->name;
PRINT_ERROR("Runtime error: Cast failed. Expected `%s`, got `%s`", "Set[L]", var_class_name);
PRINT_ERROR(" (%s:%d)\n", FILE_a_star, 252);
fatal_exit(1);
}
self->attrs[COLOR_a_star__Graph___links].val = p0; /* _links on <self:Graph[Node, Link]> */
RET_LABEL:;
}
/* method a_star#Graph#add_node for (self: Graph[Node, Link], Node): Node */
val* a_star___a_star__Graph___add_node(val* self, val* p0) {
val* var /* : Node */;
short int var1 /* : Bool */;
int cltype;
int idtype;
const struct type* type_struct;
const char* var_class_name;
val* var_node /* var node: Node */;
val* var2 /* : Set[Node] */;
/* Covariant cast for argument 0 (node) <p0:Node> isa N */
/* <p0:Node> isa N */
type_struct = self->type->resolution_table->types[COLOR_a_star__Graph___35dN];
cltype = type_struct->color;
idtype = type_struct->id;
if(cltype >= p0->type->table_size) {
var1 = 0;
} else {
var1 = p0->type->type_table[cltype] == idtype;
}
if (unlikely(!var1)) {
var_class_name = p0 == NULL ? "null" : p0->type->name;
PRINT_ERROR("Runtime error: Cast failed. Expected `%s`, got `%s`", "N", var_class_name);
PRINT_ERROR(" (%s:%d)\n", FILE_a_star, 255);
fatal_exit(1);
}
var_node = p0;
{
var2 = ((val*(*)(val* self))(self->class->vft[COLOR_a_star__Graph__nodes]))(self); /* nodes on <self:Graph[Node, Link]>*/
}
{
((void(*)(val* self, val* p0))((((long)var2&3)?class_info[((long)var2&3)]:var2->class)->vft[COLOR_core__abstract_collection__SimpleCollection__add]))(var2, var_node); /* add on <var2:Set[Node]>*/
}
var = var_node;
goto RET_LABEL;
RET_LABEL:;
return var;
}
/* method a_star#Graph#add_link for (self: Graph[Node, Link], Link): Link */
val* a_star___a_star__Graph___add_link(val* self, val* p0) {
val* var /* : Link */;
short int var1 /* : Bool */;
int cltype;
int idtype;
const struct type* type_struct;
const char* var_class_name;
val* var_link /* var link: Link */;
val* var2 /* : Set[Link] */;
val* var3 /* : Node */;
val* var4 /* : Set[Link] */;
/* Covariant cast for argument 0 (link) <p0:Link> isa L */
/* <p0:Link> isa L */
type_struct = self->type->resolution_table->types[COLOR_a_star__Graph___35dL];
cltype = type_struct->color;
idtype = type_struct->id;
if(cltype >= p0->type->table_size) {
var1 = 0;
} else {
var1 = p0->type->type_table[cltype] == idtype;
}
if (unlikely(!var1)) {
var_class_name = p0 == NULL ? "null" : p0->type->name;
PRINT_ERROR("Runtime error: Cast failed. Expected `%s`, got `%s`", "L", var_class_name);
PRINT_ERROR(" (%s:%d)\n", FILE_a_star, 263);
fatal_exit(1);
}
var_link = p0;
{
var2 = ((val*(*)(val* self))(self->class->vft[COLOR_a_star__Graph__links]))(self); /* links on <self:Graph[Node, Link]>*/
}
{
((void(*)(val* self, val* p0))((((long)var2&3)?class_info[((long)var2&3)]:var2->class)->vft[COLOR_core__abstract_collection__SimpleCollection__add]))(var2, var_link); /* add on <var2:Set[Link]>*/
}
{
var3 = ((val*(*)(val* self))(var_link->class->vft[COLOR_a_star__Link__from]))(var_link); /* from on <var_link:Link>*/
}
{
var4 = ((val*(*)(val* self))(var3->class->vft[COLOR_a_star__Node__links]))(var3); /* links on <var3:Node>*/
}
{
((void(*)(val* self, val* p0))((((long)var4&3)?class_info[((long)var4&3)]:var4->class)->vft[COLOR_core__abstract_collection__SimpleCollection__add]))(var4, var_link); /* add on <var4:Set[Link]>*/
}
var = var_link;
goto RET_LABEL;
RET_LABEL:;
return var;
}
/* method a_star#Graph#pathfinding_current_evocation for (self: Graph[Node, Link]): Int */
long a_star___a_star__Graph___pathfinding_current_evocation(val* self) {
long var /* : Int */;
long var1 /* : Int */;
var1 = self->attrs[COLOR_a_star__Graph___pathfinding_current_evocation].l; /* _pathfinding_current_evocation on <self:Graph[Node, Link]> */
var = var1;
RET_LABEL:;
return var;
}
/* method a_star#Graph#pathfinding_current_evocation= for (self: Graph[Node, Link], Int) */
void a_star___a_star__Graph___pathfinding_current_evocation_61d(val* self, long p0) {
self->attrs[COLOR_a_star__Graph___pathfinding_current_evocation].l = p0; /* _pathfinding_current_evocation on <self:Graph[Node, Link]> */
RET_LABEL:;
}
/* method a_star#Graph#core_serialize_to for (self: Graph[Node, Link], Serializer) */
void a_star___a_star__Graph___serialization__Serializable__core_serialize_to(val* self, val* p0) {
val* var_serializer /* var serializer: Serializer */;
static val* varonce;
val* var /* : String */;
char* var1 /* : NativeString */;
val* var2 /* : String */;
val* var3 /* : Set[Node] */;
static val* varonce4;
val* var5 /* : String */;
char* var6 /* : NativeString */;
val* var7 /* : String */;
val* var8 /* : Set[Link] */;
var_serializer = p0;
if (likely(varonce!=NULL)) {
var = varonce;
} else {
var1 = "nodes";
var2 = core__flat___NativeString___to_s_full(var1, 5l, 5l);
var = var2;
varonce = var;
}
{
var3 = ((val*(*)(val* self))(self->class->vft[COLOR_a_star__Graph__nodes]))(self); /* nodes on <self:Graph[Node, Link]>*/
}
{
((void(*)(val* self, val* p0, val* p1))((((long)var_serializer&3)?class_info[((long)var_serializer&3)]:var_serializer->class)->vft[COLOR_serialization__Serializer__serialize_attribute]))(var_serializer, var, var3); /* serialize_attribute on <var_serializer:Serializer>*/
}
if (likely(varonce4!=NULL)) {
var5 = varonce4;
} else {
var6 = "links";
var7 = core__flat___NativeString___to_s_full(var6, 5l, 5l);
var5 = var7;
varonce4 = var5;
}
{
var8 = ((val*(*)(val* self))(self->class->vft[COLOR_a_star__Graph__links]))(self); /* links on <self:Graph[Node, Link]>*/
}
{
((void(*)(val* self, val* p0, val* p1))((((long)var_serializer&3)?class_info[((long)var_serializer&3)]:var_serializer->class)->vft[COLOR_serialization__Serializer__serialize_attribute]))(var_serializer, var5, var8); /* serialize_attribute on <var_serializer:Serializer>*/
}
RET_LABEL:;
}
/* method a_star#Graph#from_deserializer for (self: Graph[Node, Link], Deserializer) */
void a_star___a_star__Graph___serialization__Serializable__from_deserializer(val* self, val* p0) {
val* var_deserializer /* var deserializer: Deserializer */;
static val* varonce;
val* var /* : String */;
char* var1 /* : NativeString */;
val* var2 /* : String */;
val* var3 /* : nullable Object */;
val* var_nodes /* var nodes: nullable Object */;
short int var4 /* : Bool */;
int cltype;
int idtype;
const struct type* type_struct;
short int is_nullable;
static val* varonce5;
val* var6 /* : String */;
char* var7 /* : NativeString */;
val* var8 /* : String */;
val* var9 /* : nullable Object */;
val* var_links /* var links: nullable Object */;
short int var10 /* : Bool */;
int cltype11;
int idtype12;
const struct type* type_struct13;
short int is_nullable14;
val* var_ /* var : HashSet[Link] */;
val* var15 /* : Iterator[nullable Object] */;
val* var_16 /* var : Iterator[Link] */;
short int var17 /* : Bool */;
val* var18 /* : nullable Object */;
val* var_link /* var link: Link */;
val* var19 /* : Link */;
{
((void(*)(val* self, val* p0))(self->class->vft[COLOR_a_star___a_star__Graph___serialization__Serializable__from_deserializer]))(self, p0); /* from_deserializer on <self:Graph[Node, Link]>*/
}
var_deserializer = p0;
{
((void(*)(val* self, val* p0))(var_deserializer->class->vft[COLOR_serialization__Deserializer__notify_of_creation]))(var_deserializer, self); /* notify_of_creation on <var_deserializer:Deserializer>*/
}
if (likely(varonce!=NULL)) {
var = varonce;
} else {
var1 = "nodes";
var2 = core__flat___NativeString___to_s_full(var1, 5l, 5l);
var = var2;
varonce = var;
}
{
var3 = ((val*(*)(val* self, val* p0))(var_deserializer->class->vft[COLOR_serialization__Deserializer__deserialize_attribute]))(var_deserializer, var); /* deserialize_attribute on <var_deserializer:Deserializer>*/
}
var_nodes = var3;
/* <var_nodes:nullable Object> isa HashSet[N] */
type_struct = self->type->resolution_table->types[COLOR_core__HashSet__a_star__Graph___35dN];
cltype = type_struct->color;
idtype = type_struct->id;
is_nullable = type_struct->is_nullable;
if(var_nodes == NULL) {
var4 = is_nullable;
} else {
if(cltype >= (((long)var_nodes&3)?type_info[((long)var_nodes&3)]:var_nodes->type)->table_size) {
var4 = 0;
} else {
var4 = (((long)var_nodes&3)?type_info[((long)var_nodes&3)]:var_nodes->type)->type_table[cltype] == idtype;
}
}
if (unlikely(!var4)) {
PRINT_ERROR("Runtime error: %s", "Assert failed");
PRINT_ERROR(" (%s:%d)\n", FILE_a_star, 287);
fatal_exit(1);
}
{
((void(*)(val* self, val* p0))(self->class->vft[COLOR_a_star__Graph__nodes_61d]))(self, var_nodes); /* nodes= on <self:Graph[Node, Link]>*/
}
if (likely(varonce5!=NULL)) {
var6 = varonce5;
} else {
var7 = "links";
var8 = core__flat___NativeString___to_s_full(var7, 5l, 5l);
var6 = var8;
varonce5 = var6;
}
{
var9 = ((val*(*)(val* self, val* p0))(var_deserializer->class->vft[COLOR_serialization__Deserializer__deserialize_attribute]))(var_deserializer, var6); /* deserialize_attribute on <var_deserializer:Deserializer>*/
}
var_links = var9;
/* <var_links:nullable Object> isa HashSet[L] */
type_struct13 = self->type->resolution_table->types[COLOR_core__HashSet__a_star__Graph___35dL];
cltype11 = type_struct13->color;
idtype12 = type_struct13->id;
is_nullable14 = type_struct13->is_nullable;
if(var_links == NULL) {
var10 = is_nullable14;
} else {
if(cltype11 >= (((long)var_links&3)?type_info[((long)var_links&3)]:var_links->type)->table_size) {
var10 = 0;
} else {
var10 = (((long)var_links&3)?type_info[((long)var_links&3)]:var_links->type)->type_table[cltype11] == idtype12;
}
}
if (unlikely(!var10)) {
PRINT_ERROR("Runtime error: %s", "Assert failed");
PRINT_ERROR(" (%s:%d)\n", FILE_a_star, 291);
fatal_exit(1);
}
var_ = var_links;
{
var15 = ((val*(*)(val* self))(var_->class->vft[COLOR_core__abstract_collection__Collection__iterator]))(var_); /* iterator on <var_:HashSet[Link]>*/
}
var_16 = var15;
for(;;) {
{
var17 = ((short int(*)(val* self))((((long)var_16&3)?class_info[((long)var_16&3)]:var_16->class)->vft[COLOR_core__abstract_collection__Iterator__is_ok]))(var_16); /* is_ok on <var_16:Iterator[Link]>*/
}
if (var17){
} else {
goto BREAK_label;
}
{
var18 = ((val*(*)(val* self))((((long)var_16&3)?class_info[((long)var_16&3)]:var_16->class)->vft[COLOR_core__abstract_collection__Iterator__item]))(var_16); /* item on <var_16:Iterator[Link]>*/
}
var_link = var18;
{
var19 = ((val*(*)(val* self, val* p0))(self->class->vft[COLOR_a_star__Graph__add_link]))(self, var_link); /* add_link on <self:Graph[Node, Link]>*/
}
{
((void(*)(val* self))((((long)var_16&3)?class_info[((long)var_16&3)]:var_16->class)->vft[COLOR_core__abstract_collection__Iterator__next]))(var_16); /* next on <var_16:Iterator[Link]>*/
}
}
BREAK_label: (void)0;
{
((void(*)(val* self))((((long)var_16&3)?class_info[((long)var_16&3)]:var_16->class)->vft[COLOR_core__abstract_collection__Iterator__finish]))(var_16); /* finish on <var_16:Iterator[Link]>*/
}
RET_LABEL:;
}
/* method a_star#AStarPath#total_cost for (self: AStarPath[nullable Object]): Int */
long a_star___a_star__AStarPath___total_cost(val* self) {
long var /* : Int */;
long var1 /* : Int */;
var1 = self->attrs[COLOR_a_star__AStarPath___total_cost].l; /* _total_cost on <self:AStarPath[nullable Object]> */
var = var1;
RET_LABEL:;
return var;
}
/* method a_star#AStarPath#total_cost= for (self: AStarPath[nullable Object], Int) */
void a_star___a_star__AStarPath___total_cost_61d(val* self, long p0) {
self->attrs[COLOR_a_star__AStarPath___total_cost].l = p0; /* _total_cost on <self:AStarPath[nullable Object]> */
RET_LABEL:;
}
/* method a_star#AStarPath#nodes for (self: AStarPath[nullable Object]): List[nullable Object] */
val* a_star___a_star__AStarPath___nodes(val* self) {
val* var /* : List[nullable Object] */;
val* var1 /* : List[nullable Object] */;
var1 = self->attrs[COLOR_a_star__AStarPath___nodes].val; /* _nodes on <self:AStarPath[nullable Object]> */
if (unlikely(var1 == NULL)) {
PRINT_ERROR("Runtime error: %s", "Uninitialized attribute _nodes");
PRINT_ERROR(" (%s:%d)\n", FILE_a_star, 303);
fatal_exit(1);
}
var = var1;
RET_LABEL:;
return var;
}
/* method a_star#AStarPath#nodes= for (self: AStarPath[nullable Object], List[nullable Object]) */
void a_star___a_star__AStarPath___nodes_61d(val* self, val* p0) {
short int var /* : Bool */;
int cltype;
int idtype;
const struct type* type_struct;
const char* var_class_name;
/* Covariant cast for argument 0 (nodes) <p0:List[nullable Object]> isa List[N] */
/* <p0:List[nullable Object]> isa List[N] */
type_struct = self->type->resolution_table->types[COLOR_core__List__a_star__AStarPath___35dN];
cltype = type_struct->color;
idtype = type_struct->id;
if(cltype >= p0->type->table_size) {
var = 0;
} else {
var = p0->type->type_table[cltype] == idtype;
}
if (unlikely(!var)) {
var_class_name = p0 == NULL ? "null" : p0->type->name;
PRINT_ERROR("Runtime error: Cast failed. Expected `%s`, got `%s`", "List[N]", var_class_name);
PRINT_ERROR(" (%s:%d)\n", FILE_a_star, 303);
fatal_exit(1);
}
self->attrs[COLOR_a_star__AStarPath___nodes].val = p0; /* _nodes on <self:AStarPath[nullable Object]> */
RET_LABEL:;
}
/* method a_star#AStarPath#at for (self: AStarPath[nullable Object]): Int */
long a_star___a_star__AStarPath___at(val* self) {
long var /* : Int */;
long var1 /* : Int */;
var1 = self->attrs[COLOR_a_star__AStarPath___at].l; /* _at on <self:AStarPath[nullable Object]> */
var = var1;
RET_LABEL:;
return var;
}
/* method a_star#AStarPath#at= for (self: AStarPath[nullable Object], Int) */
void a_star___a_star__AStarPath___at_61d(val* self, long p0) {
self->attrs[COLOR_a_star__AStarPath___at].l = p0; /* _at on <self:AStarPath[nullable Object]> */
RET_LABEL:;
}
/* method a_star#AStarPath#step for (self: AStarPath[nullable Object]): nullable Object */
val* a_star___a_star__AStarPath___step(val* self) {
val* var /* : nullable Object */;
val* var1 /* : List[nullable Object] */;
long var2 /* : Int */;
long var3 /* : Int */;
short int var4 /* : Bool */;
short int var6 /* : Bool */;
int cltype;
int idtype;
const char* var_class_name;
short int var7 /* : Bool */;
val* var8 /* : Sys */;
static val* varonce;
val* var9 /* : String */;
char* var10 /* : NativeString */;
val* var11 /* : String */;
val* var12 /* : List[nullable Object] */;
long var13 /* : Int */;
val* var14 /* : nullable Object */;
val* var_s /* var s: nullable Object */;
val* var_ /* var : AStarPath[nullable Object] */;
long var15 /* : Int */;
long var16 /* : Int */;
short int var18 /* : Bool */;
int cltype19;
int idtype20;
const char* var_class_name21;
long var22 /* : Int */;
{
var1 = ((val*(*)(val* self))(self->class->vft[COLOR_a_star__AStarPath__nodes]))(self); /* nodes on <self:AStarPath[nullable Object]>*/
}
{
var2 = ((long(*)(val* self))(var1->class->vft[COLOR_core__abstract_collection__Collection__length]))(var1); /* length on <var1:List[nullable Object]>*/
}
{
var3 = ((long(*)(val* self))(self->class->vft[COLOR_a_star__AStarPath__at]))(self); /* at on <self:AStarPath[nullable Object]>*/
}
{
{ /* Inline kernel#Int#>= (var2,var3) on <var2:Int> */
/* Covariant cast for argument 0 (i) <var3:Int> isa OTHER */
/* <var3:Int> isa OTHER */
var6 = 1; /* easy <var3:Int> isa OTHER*/
if (unlikely(!var6)) {
var_class_name = type_core__Int.name;
PRINT_ERROR("Runtime error: Cast failed. Expected `%s`, got `%s`", "OTHER", var_class_name);
PRINT_ERROR(" (%s:%d)\n", FILE_core__kernel, 723);
fatal_exit(1);
}
var7 = var2 >= var3;
var4 = var7;
goto RET_LABEL5;
RET_LABEL5:(void)0;
}
}
if (unlikely(!var4)) {
var8 = glob_sys;
if (likely(varonce!=NULL)) {
var9 = varonce;
} else {
var10 = "a_star::AStarPath::step failed, is at_end_of_path";
var11 = core__flat___NativeString___to_s_full(var10, 49l, 49l);
var9 = var11;
varonce = var9;
}
{
((void(*)(val* self, val* p0))(var8->class->vft[COLOR_core__file__Sys__print]))(var8, var9); /* print on <var8:Sys>*/
}
PRINT_ERROR("Runtime error: %s", "Assert failed");
PRINT_ERROR(" (%s:%d)\n", FILE_a_star, 311);
fatal_exit(1);
}
{
var12 = ((val*(*)(val* self))(self->class->vft[COLOR_a_star__AStarPath__nodes]))(self); /* nodes on <self:AStarPath[nullable Object]>*/
}
{
var13 = ((long(*)(val* self))(self->class->vft[COLOR_a_star__AStarPath__at]))(self); /* at on <self:AStarPath[nullable Object]>*/
}
{
var14 = ((val*(*)(val* self, long p0))(var12->class->vft[COLOR_core__abstract_collection__SequenceRead___91d_93d]))(var12, var13); /* [] on <var12:List[nullable Object]>*/
}
var_s = var14;
var_ = self;
{
var15 = ((long(*)(val* self))(var_->class->vft[COLOR_a_star__AStarPath__at]))(var_); /* at on <var_:AStarPath[nullable Object]>*/
}
{
{ /* Inline kernel#Int#+ (var15,1l) on <var15:Int> */
/* Covariant cast for argument 0 (i) <1l:Int> isa OTHER */
/* <1l:Int> isa OTHER */
var18 = 1; /* easy <1l:Int> isa OTHER*/
if (unlikely(!var18)) {
var_class_name21 = type_core__Int.name;
PRINT_ERROR("Runtime error: Cast failed. Expected `%s`, got `%s`", "OTHER", var_class_name21);
PRINT_ERROR(" (%s:%d)\n", FILE_core__kernel, 725);
fatal_exit(1);
}
var22 = var15 + 1l;
var16 = var22;
goto RET_LABEL17;
RET_LABEL17:(void)0;
}
}
{
((void(*)(val* self, long p0))(var_->class->vft[COLOR_a_star__AStarPath__at_61d]))(var_, var16); /* at= on <var_:AStarPath[nullable Object]>*/
}
var = var_s;
goto RET_LABEL;
RET_LABEL:;
return var;
}
/* method a_star#AStarPath#peek_step for (self: AStarPath[nullable Object]): nullable Object */
val* a_star___a_star__AStarPath___peek_step(val* self) {
val* var /* : nullable Object */;
val* var1 /* : List[nullable Object] */;
long var2 /* : Int */;
val* var3 /* : nullable Object */;
{
var1 = ((val*(*)(val* self))(self->class->vft[COLOR_a_star__AStarPath__nodes]))(self); /* nodes on <self:AStarPath[nullable Object]>*/
}
{
var2 = ((long(*)(val* self))(self->class->vft[COLOR_a_star__AStarPath__at]))(self); /* at on <self:AStarPath[nullable Object]>*/
}
{
var3 = ((val*(*)(val* self, long p0))(var1->class->vft[COLOR_core__abstract_collection__SequenceRead___91d_93d]))(var1, var2); /* [] on <var1:List[nullable Object]>*/
}
var = var3;
goto RET_LABEL;
RET_LABEL:;
return var;
}
/* method a_star#AStarPath#at_end_of_path for (self: AStarPath[nullable Object]): Bool */
short int a_star___a_star__AStarPath___at_end_of_path(val* self) {
short int var /* : Bool */;
long var1 /* : Int */;
val* var2 /* : List[nullable Object] */;
long var3 /* : Int */;
short int var4 /* : Bool */;
short int var6 /* : Bool */;
int cltype;
int idtype;
const char* var_class_name;
short int var7 /* : Bool */;
{
var1 = ((long(*)(val* self))(self->class->vft[COLOR_a_star__AStarPath__at]))(self); /* at on <self:AStarPath[nullable Object]>*/
}
{
var2 = ((val*(*)(val* self))(self->class->vft[COLOR_a_star__AStarPath__nodes]))(self); /* nodes on <self:AStarPath[nullable Object]>*/
}
{
var3 = ((long(*)(val* self))(var2->class->vft[COLOR_core__abstract_collection__Collection__length]))(var2); /* length on <var2:List[nullable Object]>*/
}
{
{ /* Inline kernel#Int#>= (var1,var3) on <var1:Int> */
/* Covariant cast for argument 0 (i) <var3:Int> isa OTHER */
/* <var3:Int> isa OTHER */
var6 = 1; /* easy <var3:Int> isa OTHER*/
if (unlikely(!var6)) {
var_class_name = type_core__Int.name;
PRINT_ERROR("Runtime error: Cast failed. Expected `%s`, got `%s`", "OTHER", var_class_name);
PRINT_ERROR(" (%s:%d)\n", FILE_core__kernel, 723);
fatal_exit(1);
}
var7 = var1 >= var3;
var4 = var7;
goto RET_LABEL5;
RET_LABEL5:(void)0;
}
}
var = var4;
goto RET_LABEL;
RET_LABEL:;
return var;
}
/* method a_star#AStarPath#core_serialize_to for (self: AStarPath[nullable Object], Serializer) */
void a_star___a_star__AStarPath___serialization__Serializable__core_serialize_to(val* self, val* p0) {
val* var_v /* var v: Serializer */;
static val* varonce;
val* var /* : String */;
char* var1 /* : NativeString */;
val* var2 /* : String */;
long var3 /* : Int */;
val* var4 /* : nullable Object */;
static val* varonce5;
val* var6 /* : String */;
char* var7 /* : NativeString */;
val* var8 /* : String */;
val* var9 /* : List[nullable Object] */;
static val* varonce10;
val* var11 /* : String */;
char* var12 /* : NativeString */;
val* var13 /* : String */;
long var14 /* : Int */;
val* var15 /* : nullable Object */;
var_v = p0;
{
((void(*)(val* self, val* p0))(self->class->vft[COLOR_a_star___a_star__AStarPath___serialization__Serializable__core_serialize_to]))(self, p0); /* core_serialize_to on <self:AStarPath[nullable Object]>*/
}
if (likely(varonce!=NULL)) {
var = varonce;
} else {
var1 = "total_cost";
var2 = core__flat___NativeString___to_s_full(var1, 10l, 10l);
var = var2;
varonce = var;
}
{
var3 = ((long(*)(val* self))(self->class->vft[COLOR_a_star__AStarPath__total_cost]))(self); /* total_cost on <self:AStarPath[nullable Object]>*/
}
{
var4 = (val*)(var3<<2|1);
((void(*)(val* self, val* p0, val* p1))((((long)var_v&3)?class_info[((long)var_v&3)]:var_v->class)->vft[COLOR_serialization__Serializer__serialize_attribute]))(var_v, var, var4); /* serialize_attribute on <var_v:Serializer>*/
}
if (likely(varonce5!=NULL)) {
var6 = varonce5;
} else {
var7 = "nodes";
var8 = core__flat___NativeString___to_s_full(var7, 5l, 5l);
var6 = var8;
varonce5 = var6;
}
{
var9 = ((val*(*)(val* self))(self->class->vft[COLOR_a_star__AStarPath__nodes]))(self); /* nodes on <self:AStarPath[nullable Object]>*/
}
{
((void(*)(val* self, val* p0, val* p1))((((long)var_v&3)?class_info[((long)var_v&3)]:var_v->class)->vft[COLOR_serialization__Serializer__serialize_attribute]))(var_v, var6, var9); /* serialize_attribute on <var_v:Serializer>*/
}
if (likely(varonce10!=NULL)) {
var11 = varonce10;
} else {
var12 = "at";
var13 = core__flat___NativeString___to_s_full(var12, 2l, 2l);
var11 = var13;
varonce10 = var11;
}
{
var14 = ((long(*)(val* self))(self->class->vft[COLOR_a_star__AStarPath__at]))(self); /* at on <self:AStarPath[nullable Object]>*/
}
{
var15 = (val*)(var14<<2|1);
((void(*)(val* self, val* p0, val* p1))((((long)var_v&3)?class_info[((long)var_v&3)]:var_v->class)->vft[COLOR_serialization__Serializer__serialize_attribute]))(var_v, var11, var15); /* serialize_attribute on <var_v:Serializer>*/
}
RET_LABEL:;
}
/* method a_star#AStarPath#from_deserializer for (self: AStarPath[nullable Object], Deserializer) */
void a_star___a_star__AStarPath___serialization__Serializable__from_deserializer(val* self, val* p0) {
val* var_v /* var v: Deserializer */;
static val* varonce;
val* var /* : String */;
char* var1 /* : NativeString */;
val* var2 /* : String */;
val* var3 /* : nullable Object */;
val* var_total_cost /* var total_cost: nullable Object */;
short int var4 /* : Bool */;
int cltype;
int idtype;
short int var5 /* : Bool */;
val* var6 /* : Array[Error] */;
val* var7 /* : AttributeTypeError */;
static val* varonce8;
val* var9 /* : String */;
char* var10 /* : NativeString */;
val* var11 /* : String */;
static val* varonce12;
val* var13 /* : String */;
char* var14 /* : NativeString */;
val* var15 /* : String */;
static val* varonce16;
val* var17 /* : String */;
char* var18 /* : NativeString */;
val* var19 /* : String */;
val* var20 /* : nullable Bool */;
short int var21 /* : Bool */;
short int var22 /* : Bool */;
short int var24 /* : Bool */;
short int var25 /* : Bool */;
long var26 /* : Int */;
static val* varonce27;
val* var28 /* : String */;
char* var29 /* : NativeString */;
val* var30 /* : String */;
val* var31 /* : nullable Object */;
val* var_nodes /* var nodes: nullable Object */;
short int var32 /* : Bool */;
int cltype33;
int idtype34;
const struct type* type_struct;
short int is_nullable;
short int var35 /* : Bool */;
val* var36 /* : Array[Error] */;
val* var37 /* : AttributeTypeError */;
static val* varonce38;
val* var39 /* : String */;
char* var40 /* : NativeString */;
val* var41 /* : String */;
static val* varonce42;
val* var43 /* : String */;
char* var44 /* : NativeString */;
val* var45 /* : String */;
static val* varonce46;
val* var47 /* : String */;
char* var48 /* : NativeString */;
val* var49 /* : String */;
val* var50 /* : nullable Bool */;
short int var51 /* : Bool */;
short int var52 /* : Bool */;
short int var54 /* : Bool */;
short int var55 /* : Bool */;
static val* varonce56;
val* var57 /* : String */;
char* var58 /* : NativeString */;
val* var59 /* : String */;
val* var60 /* : nullable Object */;
val* var_at /* var at: nullable Object */;
short int var61 /* : Bool */;
int cltype62;
int idtype63;
short int var64 /* : Bool */;
val* var65 /* : Array[Error] */;
val* var66 /* : AttributeTypeError */;
static val* varonce67;
val* var68 /* : String */;
char* var69 /* : NativeString */;
val* var70 /* : String */;
static val* varonce71;
val* var72 /* : String */;
char* var73 /* : NativeString */;
val* var74 /* : String */;
static val* varonce75;
val* var76 /* : String */;
char* var77 /* : NativeString */;
val* var78 /* : String */;
val* var79 /* : nullable Bool */;
short int var80 /* : Bool */;
short int var81 /* : Bool */;
short int var83 /* : Bool */;
short int var84 /* : Bool */;
long var85 /* : Int */;
var_v = p0;
{
((void(*)(val* self, val* p0))(self->class->vft[COLOR_a_star___a_star__AStarPath___serialization__Serializable__from_deserializer]))(self, p0); /* from_deserializer on <self:AStarPath[nullable Object]>*/
}
{
((void(*)(val* self, val* p0))(var_v->class->vft[COLOR_serialization__Deserializer__notify_of_creation]))(var_v, self); /* notify_of_creation on <var_v:Deserializer>*/
}
if (likely(varonce!=NULL)) {
var = varonce;
} else {
var1 = "total_cost";
var2 = core__flat___NativeString___to_s_full(var1, 10l, 10l);
var = var2;
varonce = var;
}
{
var3 = ((val*(*)(val* self, val* p0))(var_v->class->vft[COLOR_serialization__Deserializer__deserialize_attribute]))(var_v, var); /* deserialize_attribute on <var_v:Deserializer>*/
}
var_total_cost = var3;
/* <var_total_cost:nullable Object> isa Int */
cltype = type_core__Int.color;
idtype = type_core__Int.id;
if(var_total_cost == NULL) {
var4 = 0;
} else {
if(cltype >= (((long)var_total_cost&3)?type_info[((long)var_total_cost&3)]:var_total_cost->type)->table_size) {
var4 = 0;
} else {
var4 = (((long)var_total_cost&3)?type_info[((long)var_total_cost&3)]:var_total_cost->type)->type_table[cltype] == idtype;
}
}
var5 = !var4;
if (var5){
{
var6 = ((val*(*)(val* self))(var_v->class->vft[COLOR_serialization__Deserializer__errors]))(var_v); /* errors on <var_v:Deserializer>*/
}
var7 = NEW_serialization__AttributeTypeError(&type_serialization__AttributeTypeError);
if (likely(varonce8!=NULL)) {
var9 = varonce8;
} else {
var10 = "TODO remove this arg on c_src regen";
var11 = core__flat___NativeString___to_s_full(var10, 35l, 35l);
var9 = var11;
varonce8 = var9;
}
if (likely(varonce12!=NULL)) {
var13 = varonce12;
} else {
var14 = "total_cost";
var15 = core__flat___NativeString___to_s_full(var14, 10l, 10l);
var13 = var15;
varonce12 = var13;
}
if (likely(varonce16!=NULL)) {
var17 = varonce16;
} else {
var18 = "Int";
var19 = core__flat___NativeString___to_s_full(var18, 3l, 3l);
var17 = var19;
varonce16 = var17;
}
{
((void(*)(val* self, val* p0))(var7->class->vft[COLOR_core__error__Error__message_61d]))(var7, var9); /* message= on <var7:AttributeTypeError>*/
}
{
((void(*)(val* self, val* p0))(var7->class->vft[COLOR_serialization__AttributeTypeError__receiver_61d]))(var7, self); /* receiver= on <var7:AttributeTypeError>*/
}
{
((void(*)(val* self, val* p0))(var7->class->vft[COLOR_serialization__AttributeTypeError__attribute_name_61d]))(var7, var13); /* attribute_name= on <var7:AttributeTypeError>*/
}
{
((void(*)(val* self, val* p0))(var7->class->vft[COLOR_serialization__AttributeTypeError__attribute_61d]))(var7, var_total_cost); /* attribute= on <var7:AttributeTypeError>*/
}
{
((void(*)(val* self, val* p0))(var7->class->vft[COLOR_serialization__AttributeTypeError__expected_type_61d]))(var7, var17); /* expected_type= on <var7:AttributeTypeError>*/
}
{
((void(*)(val* self))(var7->class->vft[COLOR_core__kernel__Object__init]))(var7); /* init on <var7:AttributeTypeError>*/
}
{
((void(*)(val* self, val* p0))(var6->class->vft[COLOR_core__abstract_collection__SimpleCollection__add]))(var6, var7); /* add on <var6:Array[Error]>*/
}
{
var20 = ((val*(*)(val* self))(var_v->class->vft[COLOR_serialization__Deserializer__keep_going]))(var_v); /* keep_going on <var_v:Deserializer>*/
}
if (var20 == NULL) {
var21 = 0; /* <0:Bool> cannot be null */
} else {
{ /* Inline kernel#Bool#== (var20,0) on <var20:nullable Bool> */
if ((var20 != NULL)) {
var25 = (short int)((long)(var20)>>2);
var24 = var25 == 0;
} else var24 = 0;
var22 = var24;
goto RET_LABEL23;
RET_LABEL23:(void)0;
}
var21 = var22;
}
if (var21){
goto RET_LABEL;
} else {
}
} else {
{
var26 = (long)(var_total_cost)>>2;
((void(*)(val* self, long p0))(self->class->vft[COLOR_a_star__AStarPath__total_cost_61d]))(self, var26); /* total_cost= on <self:AStarPath[nullable Object]>*/
}
}
if (likely(varonce27!=NULL)) {
var28 = varonce27;
} else {
var29 = "nodes";
var30 = core__flat___NativeString___to_s_full(var29, 5l, 5l);
var28 = var30;
varonce27 = var28;
}
{
var31 = ((val*(*)(val* self, val* p0))(var_v->class->vft[COLOR_serialization__Deserializer__deserialize_attribute]))(var_v, var28); /* deserialize_attribute on <var_v:Deserializer>*/
}
var_nodes = var31;
/* <var_nodes:nullable Object> isa List[N] */
type_struct = self->type->resolution_table->types[COLOR_core__List__a_star__AStarPath___35dN];
cltype33 = type_struct->color;
idtype34 = type_struct->id;
is_nullable = type_struct->is_nullable;
if(var_nodes == NULL) {
var32 = is_nullable;
} else {
if(cltype33 >= (((long)var_nodes&3)?type_info[((long)var_nodes&3)]:var_nodes->type)->table_size) {
var32 = 0;
} else {
var32 = (((long)var_nodes&3)?type_info[((long)var_nodes&3)]:var_nodes->type)->type_table[cltype33] == idtype34;
}
}
var35 = !var32;
if (var35){
{
var36 = ((val*(*)(val* self))(var_v->class->vft[COLOR_serialization__Deserializer__errors]))(var_v); /* errors on <var_v:Deserializer>*/
}
var37 = NEW_serialization__AttributeTypeError(&type_serialization__AttributeTypeError);
if (likely(varonce38!=NULL)) {
var39 = varonce38;
} else {
var40 = "TODO remove this arg on c_src regen";
var41 = core__flat___NativeString___to_s_full(var40, 35l, 35l);
var39 = var41;
varonce38 = var39;
}
if (likely(varonce42!=NULL)) {
var43 = varonce42;
} else {
var44 = "nodes";
var45 = core__flat___NativeString___to_s_full(var44, 5l, 5l);
var43 = var45;
varonce42 = var43;
}
if (likely(varonce46!=NULL)) {
var47 = varonce46;
} else {
var48 = "PlaceHolderTypeWhichShouldNotExist";
var49 = core__flat___NativeString___to_s_full(var48, 34l, 34l);
var47 = var49;
varonce46 = var47;
}
{
((void(*)(val* self, val* p0))(var37->class->vft[COLOR_core__error__Error__message_61d]))(var37, var39); /* message= on <var37:AttributeTypeError>*/
}
{
((void(*)(val* self, val* p0))(var37->class->vft[COLOR_serialization__AttributeTypeError__receiver_61d]))(var37, self); /* receiver= on <var37:AttributeTypeError>*/
}
{
((void(*)(val* self, val* p0))(var37->class->vft[COLOR_serialization__AttributeTypeError__attribute_name_61d]))(var37, var43); /* attribute_name= on <var37:AttributeTypeError>*/
}
{
((void(*)(val* self, val* p0))(var37->class->vft[COLOR_serialization__AttributeTypeError__attribute_61d]))(var37, var_nodes); /* attribute= on <var37:AttributeTypeError>*/
}
{
((void(*)(val* self, val* p0))(var37->class->vft[COLOR_serialization__AttributeTypeError__expected_type_61d]))(var37, var47); /* expected_type= on <var37:AttributeTypeError>*/
}
{
((void(*)(val* self))(var37->class->vft[COLOR_core__kernel__Object__init]))(var37); /* init on <var37:AttributeTypeError>*/
}
{
((void(*)(val* self, val* p0))(var36->class->vft[COLOR_core__abstract_collection__SimpleCollection__add]))(var36, var37); /* add on <var36:Array[Error]>*/
}
{
var50 = ((val*(*)(val* self))(var_v->class->vft[COLOR_serialization__Deserializer__keep_going]))(var_v); /* keep_going on <var_v:Deserializer>*/
}
if (var50 == NULL) {
var51 = 0; /* <0:Bool> cannot be null */
} else {
{ /* Inline kernel#Bool#== (var50,0) on <var50:nullable Bool> */
if ((var50 != NULL)) {
var55 = (short int)((long)(var50)>>2);
var54 = var55 == 0;
} else var54 = 0;
var52 = var54;
goto RET_LABEL53;
RET_LABEL53:(void)0;
}
var51 = var52;
}
if (var51){
goto RET_LABEL;
} else {
}
} else {
{
((void(*)(val* self, val* p0))(self->class->vft[COLOR_a_star__AStarPath__nodes_61d]))(self, var_nodes); /* nodes= on <self:AStarPath[nullable Object]>*/
}
}
if (likely(varonce56!=NULL)) {
var57 = varonce56;
} else {
var58 = "at";
var59 = core__flat___NativeString___to_s_full(var58, 2l, 2l);
var57 = var59;
varonce56 = var57;
}
{
var60 = ((val*(*)(val* self, val* p0))(var_v->class->vft[COLOR_serialization__Deserializer__deserialize_attribute]))(var_v, var57); /* deserialize_attribute on <var_v:Deserializer>*/
}
var_at = var60;
/* <var_at:nullable Object> isa Int */
cltype62 = type_core__Int.color;
idtype63 = type_core__Int.id;
if(var_at == NULL) {
var61 = 0;
} else {
if(cltype62 >= (((long)var_at&3)?type_info[((long)var_at&3)]:var_at->type)->table_size) {
var61 = 0;
} else {
var61 = (((long)var_at&3)?type_info[((long)var_at&3)]:var_at->type)->type_table[cltype62] == idtype63;
}
}
var64 = !var61;
if (var64){
{
var65 = ((val*(*)(val* self))(var_v->class->vft[COLOR_serialization__Deserializer__errors]))(var_v); /* errors on <var_v:Deserializer>*/
}
var66 = NEW_serialization__AttributeTypeError(&type_serialization__AttributeTypeError);
if (likely(varonce67!=NULL)) {
var68 = varonce67;
} else {
var69 = "TODO remove this arg on c_src regen";
var70 = core__flat___NativeString___to_s_full(var69, 35l, 35l);
var68 = var70;
varonce67 = var68;
}
if (likely(varonce71!=NULL)) {
var72 = varonce71;
} else {
var73 = "at";
var74 = core__flat___NativeString___to_s_full(var73, 2l, 2l);
var72 = var74;
varonce71 = var72;
}
if (likely(varonce75!=NULL)) {
var76 = varonce75;
} else {
var77 = "Int";
var78 = core__flat___NativeString___to_s_full(var77, 3l, 3l);
var76 = var78;
varonce75 = var76;
}
{
((void(*)(val* self, val* p0))(var66->class->vft[COLOR_core__error__Error__message_61d]))(var66, var68); /* message= on <var66:AttributeTypeError>*/
}
{
((void(*)(val* self, val* p0))(var66->class->vft[COLOR_serialization__AttributeTypeError__receiver_61d]))(var66, self); /* receiver= on <var66:AttributeTypeError>*/
}
{
((void(*)(val* self, val* p0))(var66->class->vft[COLOR_serialization__AttributeTypeError__attribute_name_61d]))(var66, var72); /* attribute_name= on <var66:AttributeTypeError>*/
}
{
((void(*)(val* self, val* p0))(var66->class->vft[COLOR_serialization__AttributeTypeError__attribute_61d]))(var66, var_at); /* attribute= on <var66:AttributeTypeError>*/
}
{
((void(*)(val* self, val* p0))(var66->class->vft[COLOR_serialization__AttributeTypeError__expected_type_61d]))(var66, var76); /* expected_type= on <var66:AttributeTypeError>*/
}
{
((void(*)(val* self))(var66->class->vft[COLOR_core__kernel__Object__init]))(var66); /* init on <var66:AttributeTypeError>*/
}
{
((void(*)(val* self, val* p0))(var65->class->vft[COLOR_core__abstract_collection__SimpleCollection__add]))(var65, var66); /* add on <var65:Array[Error]>*/
}
{
var79 = ((val*(*)(val* self))(var_v->class->vft[COLOR_serialization__Deserializer__keep_going]))(var_v); /* keep_going on <var_v:Deserializer>*/
}
if (var79 == NULL) {
var80 = 0; /* <0:Bool> cannot be null */
} else {
{ /* Inline kernel#Bool#== (var79,0) on <var79:nullable Bool> */
if ((var79 != NULL)) {
var84 = (short int)((long)(var79)>>2);
var83 = var84 == 0;
} else var83 = 0;
var81 = var83;
goto RET_LABEL82;
RET_LABEL82:(void)0;
}
var80 = var81;
}
if (var80){
goto RET_LABEL;
} else {
}
} else {
{
var85 = (long)(var_at)>>2;
((void(*)(val* self, long p0))(self->class->vft[COLOR_a_star__AStarPath__at_61d]))(self, var85); /* at= on <self:AStarPath[nullable Object]>*/
}
}
RET_LABEL:;
}
/* method a_star#AStarPath#init for (self: AStarPath[nullable Object]) */
void a_star___a_star__AStarPath___core__kernel__Object__init(val* self) {
{
((void(*)(val* self))(self->class->vft[COLOR_a_star___a_star__AStarPath___core__kernel__Object__init]))(self); /* init on <self:AStarPath[nullable Object]>*/
}
RET_LABEL:;
}
/* method a_star#PathContext#graph for (self: PathContext): Graph[Node, Link] */
val* a_star___a_star__PathContext___graph(val* self) {
val* var /* : Graph[Node, Link] */;
val* var1 /* : Graph[Node, Link] */;
var1 = self->attrs[COLOR_a_star__PathContext___graph].val; /* _graph on <self:PathContext> */
if (unlikely(var1 == NULL)) {
PRINT_ERROR("Runtime error: %s", "Uninitialized attribute _graph");
PRINT_ERROR(" (%s:%d)\n", FILE_a_star, 336);
fatal_exit(1);
}
var = var1;
RET_LABEL:;
return var;
}
/* method a_star#PathContext#graph= for (self: PathContext, Graph[Node, Link]) */
void a_star___a_star__PathContext___graph_61d(val* self, val* p0) {
short int var /* : Bool */;
int cltype;
int idtype;
const struct type* type_struct;
const char* var_class_name;
/* Covariant cast for argument 0 (graph) <p0:Graph[Node, Link]> isa Graph[N, L] */
/* <p0:Graph[Node, Link]> isa Graph[N, L] */
type_struct = self->type->resolution_table->types[COLOR_a_star__Graph__a_star__PathContext__N__a_star__PathContext__L];
cltype = type_struct->color;
idtype = type_struct->id;
if(cltype >= p0->type->table_size) {
var = 0;
} else {
var = p0->type->type_table[cltype] == idtype;
}
if (unlikely(!var)) {
var_class_name = p0 == NULL ? "null" : p0->type->name;
PRINT_ERROR("Runtime error: Cast failed. Expected `%s`, got `%s`", "Graph[N, L]", var_class_name);
PRINT_ERROR(" (%s:%d)\n", FILE_a_star, 336);
fatal_exit(1);
}
self->attrs[COLOR_a_star__PathContext___graph].val = p0; /* _graph on <self:PathContext> */
RET_LABEL:;
}
/* method a_star#PathContext#worst_cost for (self: PathContext): Int */
long a_star___a_star__PathContext___worst_cost(val* self) {
long var /* : Int */;
const char* var_class_name;
var_class_name = self == NULL ? "null" : self->type->name;
PRINT_ERROR("Runtime error: Abstract method `%s` called on `%s`", "worst_cost", var_class_name);
PRINT_ERROR(" (%s:%d)\n", FILE_a_star, 339);
fatal_exit(1);
RET_LABEL:;
return var;
}
/* method a_star#PathContext#cost for (self: PathContext, Link): Int */
long a_star___a_star__PathContext___cost(val* self, val* p0) {
long var /* : Int */;
const char* var_class_name;
var_class_name = self == NULL ? "null" : self->type->name;
PRINT_ERROR("Runtime error: Abstract method `%s` called on `%s`", "cost", var_class_name);
PRINT_ERROR(" (%s:%d)\n", FILE_a_star, 342);
fatal_exit(1);
RET_LABEL:;
return var;
}
/* method a_star#PathContext#is_blocked for (self: PathContext, Link): Bool */
short int a_star___a_star__PathContext___is_blocked(val* self, val* p0) {
short int var /* : Bool */;
const char* var_class_name;
var_class_name = self == NULL ? "null" : self->type->name;
PRINT_ERROR("Runtime error: Abstract method `%s` called on `%s`", "is_blocked", var_class_name);
PRINT_ERROR(" (%s:%d)\n", FILE_a_star, 345);
fatal_exit(1);
RET_LABEL:;
return var;
}
/* method a_star#PathContext#heuristic_cost for (self: PathContext, Node, Node): Int */
long a_star___a_star__PathContext___heuristic_cost(val* self, val* p0, val* p1) {
long var /* : Int */;
const char* var_class_name;
var_class_name = self == NULL ? "null" : self->type->name;
PRINT_ERROR("Runtime error: Abstract method `%s` called on `%s`", "heuristic_cost", var_class_name);
PRINT_ERROR(" (%s:%d)\n", FILE_a_star, 348);
fatal_exit(1);
RET_LABEL:;
return var;
}
/* method a_star#PathContext#worst_heuristic_cost for (self: PathContext): Int */
long a_star___a_star__PathContext___worst_heuristic_cost(val* self) {
long var /* : Int */;
const char* var_class_name;
var_class_name = self == NULL ? "null" : self->type->name;
PRINT_ERROR("Runtime error: Abstract method `%s` called on `%s`", "worst_heuristic_cost", var_class_name);
PRINT_ERROR(" (%s:%d)\n", FILE_a_star, 351);
fatal_exit(1);
RET_LABEL:;
return var;
}
/* method a_star#PathContext#core_serialize_to for (self: PathContext, Serializer) */
void a_star___a_star__PathContext___serialization__Serializable__core_serialize_to(val* self, val* p0) {
val* var_v /* var v: Serializer */;
static val* varonce;
val* var /* : String */;
char* var1 /* : NativeString */;
val* var2 /* : String */;
val* var3 /* : Graph[Node, Link] */;
var_v = p0;
{
((void(*)(val* self, val* p0))(self->class->vft[COLOR_a_star___a_star__PathContext___serialization__Serializable__core_serialize_to]))(self, p0); /* core_serialize_to on <self:PathContext>*/
}
if (likely(varonce!=NULL)) {
var = varonce;
} else {
var1 = "graph";
var2 = core__flat___NativeString___to_s_full(var1, 5l, 5l);
var = var2;
varonce = var;
}
{
var3 = ((val*(*)(val* self))(self->class->vft[COLOR_a_star__PathContext__graph]))(self); /* graph on <self:PathContext>*/
}
{
((void(*)(val* self, val* p0, val* p1))((((long)var_v&3)?class_info[((long)var_v&3)]:var_v->class)->vft[COLOR_serialization__Serializer__serialize_attribute]))(var_v, var, var3); /* serialize_attribute on <var_v:Serializer>*/
}
RET_LABEL:;
}
/* method a_star#PathContext#from_deserializer for (self: PathContext, Deserializer) */
void a_star___a_star__PathContext___serialization__Serializable__from_deserializer(val* self, val* p0) {
val* var_v /* var v: Deserializer */;
static val* varonce;
val* var /* : String */;
char* var1 /* : NativeString */;
val* var2 /* : String */;
val* var3 /* : nullable Object */;
val* var_graph /* var graph: nullable Object */;
short int var4 /* : Bool */;
int cltype;
int idtype;
const struct type* type_struct;
short int is_nullable;
short int var5 /* : Bool */;
val* var6 /* : Array[Error] */;
val* var7 /* : AttributeTypeError */;
static val* varonce8;
val* var9 /* : String */;
char* var10 /* : NativeString */;
val* var11 /* : String */;
static val* varonce12;
val* var13 /* : String */;
char* var14 /* : NativeString */;
val* var15 /* : String */;
static val* varonce16;
val* var17 /* : String */;
char* var18 /* : NativeString */;
val* var19 /* : String */;
val* var20 /* : nullable Bool */;
short int var21 /* : Bool */;
short int var22 /* : Bool */;
short int var24 /* : Bool */;
short int var25 /* : Bool */;
var_v = p0;
{
((void(*)(val* self, val* p0))(self->class->vft[COLOR_a_star___a_star__PathContext___serialization__Serializable__from_deserializer]))(self, p0); /* from_deserializer on <self:PathContext>*/
}
{
((void(*)(val* self, val* p0))(var_v->class->vft[COLOR_serialization__Deserializer__notify_of_creation]))(var_v, self); /* notify_of_creation on <var_v:Deserializer>*/
}
if (likely(varonce!=NULL)) {
var = varonce;
} else {
var1 = "graph";
var2 = core__flat___NativeString___to_s_full(var1, 5l, 5l);
var = var2;
varonce = var;
}
{
var3 = ((val*(*)(val* self, val* p0))(var_v->class->vft[COLOR_serialization__Deserializer__deserialize_attribute]))(var_v, var); /* deserialize_attribute on <var_v:Deserializer>*/
}
var_graph = var3;
/* <var_graph:nullable Object> isa Graph[N, L] */
type_struct = self->type->resolution_table->types[COLOR_a_star__Graph__a_star__PathContext__N__a_star__PathContext__L];
cltype = type_struct->color;
idtype = type_struct->id;
is_nullable = type_struct->is_nullable;
if(var_graph == NULL) {
var4 = is_nullable;
} else {
if(cltype >= (((long)var_graph&3)?type_info[((long)var_graph&3)]:var_graph->type)->table_size) {
var4 = 0;
} else {
var4 = (((long)var_graph&3)?type_info[((long)var_graph&3)]:var_graph->type)->type_table[cltype] == idtype;
}
}
var5 = !var4;
if (var5){
{
var6 = ((val*(*)(val* self))(var_v->class->vft[COLOR_serialization__Deserializer__errors]))(var_v); /* errors on <var_v:Deserializer>*/
}
var7 = NEW_serialization__AttributeTypeError(&type_serialization__AttributeTypeError);
if (likely(varonce8!=NULL)) {
var9 = varonce8;
} else {
var10 = "TODO remove this arg on c_src regen";
var11 = core__flat___NativeString___to_s_full(var10, 35l, 35l);
var9 = var11;
varonce8 = var9;
}
if (likely(varonce12!=NULL)) {
var13 = varonce12;
} else {
var14 = "graph";
var15 = core__flat___NativeString___to_s_full(var14, 5l, 5l);
var13 = var15;
varonce12 = var13;
}
if (likely(varonce16!=NULL)) {
var17 = varonce16;
} else {
var18 = "Graph[N, L]";
var19 = core__flat___NativeString___to_s_full(var18, 11l, 11l);
var17 = var19;
varonce16 = var17;
}
{
((void(*)(val* self, val* p0))(var7->class->vft[COLOR_core__error__Error__message_61d]))(var7, var9); /* message= on <var7:AttributeTypeError>*/
}
{
((void(*)(val* self, val* p0))(var7->class->vft[COLOR_serialization__AttributeTypeError__receiver_61d]))(var7, self); /* receiver= on <var7:AttributeTypeError>*/
}
{
((void(*)(val* self, val* p0))(var7->class->vft[COLOR_serialization__AttributeTypeError__attribute_name_61d]))(var7, var13); /* attribute_name= on <var7:AttributeTypeError>*/
}
{
((void(*)(val* self, val* p0))(var7->class->vft[COLOR_serialization__AttributeTypeError__attribute_61d]))(var7, var_graph); /* attribute= on <var7:AttributeTypeError>*/
}
{
((void(*)(val* self, val* p0))(var7->class->vft[COLOR_serialization__AttributeTypeError__expected_type_61d]))(var7, var17); /* expected_type= on <var7:AttributeTypeError>*/
}
{
((void(*)(val* self))(var7->class->vft[COLOR_core__kernel__Object__init]))(var7); /* init on <var7:AttributeTypeError>*/
}
{
((void(*)(val* self, val* p0))(var6->class->vft[COLOR_core__abstract_collection__SimpleCollection__add]))(var6, var7); /* add on <var6:Array[Error]>*/
}
{
var20 = ((val*(*)(val* self))(var_v->class->vft[COLOR_serialization__Deserializer__keep_going]))(var_v); /* keep_going on <var_v:Deserializer>*/
}
if (var20 == NULL) {
var21 = 0; /* <0:Bool> cannot be null */
} else {
{ /* Inline kernel#Bool#== (var20,0) on <var20:nullable Bool> */
if ((var20 != NULL)) {
var25 = (short int)((long)(var20)>>2);
var24 = var25 == 0;
} else var24 = 0;
var22 = var24;
goto RET_LABEL23;
RET_LABEL23:(void)0;
}
var21 = var22;
}
if (var21){
goto RET_LABEL;
} else {
}
} else {
{
((void(*)(val* self, val* p0))(self->class->vft[COLOR_a_star__PathContext__graph_61d]))(self, var_graph); /* graph= on <self:PathContext>*/
}
}
RET_LABEL:;
}
/* method a_star#PathContext#init for (self: PathContext) */
void a_star___a_star__PathContext___core__kernel__Object__init(val* self) {
{
((void(*)(val* self))(self->class->vft[COLOR_a_star___a_star__PathContext___core__kernel__Object__init]))(self); /* init on <self:PathContext>*/
}
RET_LABEL:;
}
/* method a_star#ConstantPathContext#worst_cost for (self: ConstantPathContext): Int */
long a_star___a_star__ConstantPathContext___PathContext__worst_cost(val* self) {
long var /* : Int */;
var = 1l;
goto RET_LABEL;
RET_LABEL:;
return var;
}
/* method a_star#ConstantPathContext#cost for (self: ConstantPathContext, Link): Int */
long a_star___a_star__ConstantPathContext___PathContext__cost(val* self, val* p0) {
long var /* : Int */;
short int var1 /* : Bool */;
int cltype;
int idtype;
const struct type* type_struct;
const char* var_class_name;
val* var_l /* var l: Link */;
/* Covariant cast for argument 0 (l) <p0:Link> isa L */
/* <p0:Link> isa L */
type_struct = self->type->resolution_table->types[COLOR_a_star__PathContext__L];
cltype = type_struct->color;
idtype = type_struct->id;
if(cltype >= p0->type->table_size) {
var1 = 0;
} else {
var1 = p0->type->type_table[cltype] == idtype;
}
if (unlikely(!var1)) {
var_class_name = p0 == NULL ? "null" : p0->type->name;
PRINT_ERROR("Runtime error: Cast failed. Expected `%s`, got `%s`", "L", var_class_name);
PRINT_ERROR(" (%s:%d)\n", FILE_a_star, 366);
fatal_exit(1);
}
var_l = p0;
var = 1l;
goto RET_LABEL;
RET_LABEL:;
return var;
}
/* method a_star#ConstantPathContext#is_blocked for (self: ConstantPathContext, Link): Bool */
short int a_star___a_star__ConstantPathContext___PathContext__is_blocked(val* self, val* p0) {
short int var /* : Bool */;
short int var1 /* : Bool */;
int cltype;
int idtype;
const struct type* type_struct;
const char* var_class_name;
val* var_l /* var l: Link */;
/* Covariant cast for argument 0 (l) <p0:Link> isa L */
/* <p0:Link> isa L */
type_struct = self->type->resolution_table->types[COLOR_a_star__PathContext__L];
cltype = type_struct->color;
idtype = type_struct->id;
if(cltype >= p0->type->table_size) {
var1 = 0;
} else {
var1 = p0->type->type_table[cltype] == idtype;
}
if (unlikely(!var1)) {
var_class_name = p0 == NULL ? "null" : p0->type->name;
PRINT_ERROR("Runtime error: Cast failed. Expected `%s`, got `%s`", "L", var_class_name);
PRINT_ERROR(" (%s:%d)\n", FILE_a_star, 367);
fatal_exit(1);
}
var_l = p0;
var = 0;
goto RET_LABEL;
RET_LABEL:;
return var;
}
/* method a_star#ConstantPathContext#heuristic_cost for (self: ConstantPathContext, Node, Node): Int */
long a_star___a_star__ConstantPathContext___PathContext__heuristic_cost(val* self, val* p0, val* p1) {
long var /* : Int */;
short int var1 /* : Bool */;
int cltype;
int idtype;
const struct type* type_struct;
const char* var_class_name;
short int var2 /* : Bool */;
int cltype3;
int idtype4;
const struct type* type_struct5;
const char* var_class_name6;
val* var_a /* var a: Node */;
val* var_b /* var b: Node */;
/* Covariant cast for argument 0 (a) <p0:Node> isa N */
/* <p0:Node> isa N */
type_struct = self->type->resolution_table->types[COLOR_a_star__PathContext__N];
cltype = type_struct->color;
idtype = type_struct->id;
if(cltype >= p0->type->table_size) {
var1 = 0;
} else {
var1 = p0->type->type_table[cltype] == idtype;
}
if (unlikely(!var1)) {
var_class_name = p0 == NULL ? "null" : p0->type->name;
PRINT_ERROR("Runtime error: Cast failed. Expected `%s`, got `%s`", "N", var_class_name);
PRINT_ERROR(" (%s:%d)\n", FILE_a_star, 368);
fatal_exit(1);
}
/* Covariant cast for argument 1 (b) <p1:Node> isa N */
/* <p1:Node> isa N */
type_struct5 = self->type->resolution_table->types[COLOR_a_star__PathContext__N];
cltype3 = type_struct5->color;
idtype4 = type_struct5->id;
if(cltype3 >= p1->type->table_size) {
var2 = 0;
} else {
var2 = p1->type->type_table[cltype3] == idtype4;
}
if (unlikely(!var2)) {
var_class_name6 = p1 == NULL ? "null" : p1->type->name;
PRINT_ERROR("Runtime error: Cast failed. Expected `%s`, got `%s`", "N", var_class_name6);
PRINT_ERROR(" (%s:%d)\n", FILE_a_star, 368);
fatal_exit(1);
}
var_a = p0;
var_b = p1;
var = 0l;
goto RET_LABEL;
RET_LABEL:;
return var;
}
/* method a_star#ConstantPathContext#worst_heuristic_cost for (self: ConstantPathContext): Int */
long a_star___a_star__ConstantPathContext___PathContext__worst_heuristic_cost(val* self) {
long var /* : Int */;
var = 0l;
goto RET_LABEL;
RET_LABEL:;
return var;
}
/* method a_star#ConstantPathContext#core_serialize_to for (self: ConstantPathContext, Serializer) */
void a_star___a_star__ConstantPathContext___serialization__Serializable__core_serialize_to(val* self, val* p0) {
val* var_v /* var v: Serializer */;
var_v = p0;
{
((void(*)(val* self, val* p0))(self->class->vft[COLOR_a_star___a_star__ConstantPathContext___serialization__Serializable__core_serialize_to]))(self, p0); /* core_serialize_to on <self:ConstantPathContext>*/
}
RET_LABEL:;
}
/* method a_star#ConstantPathContext#from_deserializer for (self: ConstantPathContext, Deserializer) */
void a_star___a_star__ConstantPathContext___serialization__Serializable__from_deserializer(val* self, val* p0) {
val* var_v /* var v: Deserializer */;
var_v = p0;
{
((void(*)(val* self, val* p0))(self->class->vft[COLOR_a_star___a_star__ConstantPathContext___serialization__Serializable__from_deserializer]))(self, p0); /* from_deserializer on <self:ConstantPathContext>*/
}
{
((void(*)(val* self, val* p0))(var_v->class->vft[COLOR_serialization__Deserializer__notify_of_creation]))(var_v, self); /* notify_of_creation on <var_v:Deserializer>*/
}
RET_LABEL:;
}
/* method a_star#WeightedPathContext#init for (self: WeightedPathContext) */
void a_star___a_star__WeightedPathContext___core__kernel__Object__init(val* self) {
long var_worst_cost /* var worst_cost: Int */;
val* var /* : Graph[Node, Link] */;
val* var1 /* : Set[Link] */;
val* var_ /* var : Set[WeightedLink] */;
val* var2 /* : Iterator[nullable Object] */;
val* var_3 /* var : Iterator[WeightedLink] */;
short int var4 /* : Bool */;
val* var5 /* : nullable Object */;
val* var_l /* var l: WeightedLink */;
long var6 /* : Int */;
long var_cost /* var cost: Int */;
short int var7 /* : Bool */;
short int var9 /* : Bool */;
int cltype;
int idtype;
const char* var_class_name;
short int var10 /* : Bool */;
long var11 /* : Int */;
short int var13 /* : Bool */;
int cltype14;
int idtype15;
const char* var_class_name16;
long var17 /* : Int */;
{
((void(*)(val* self))(self->class->vft[COLOR_a_star___a_star__WeightedPathContext___core__kernel__Object__init]))(self); /* init on <self:WeightedPathContext>*/
}
var_worst_cost = 0l;
{
var = ((val*(*)(val* self))(self->class->vft[COLOR_a_star__PathContext__graph]))(self); /* graph on <self:WeightedPathContext>*/
}
{
var1 = ((val*(*)(val* self))(var->class->vft[COLOR_a_star__Graph__links]))(var); /* links on <var:Graph[Node, Link](Graph[Node, WeightedLink])>*/
}
var_ = var1;
{
var2 = ((val*(*)(val* self))((((long)var_&3)?class_info[((long)var_&3)]:var_->class)->vft[COLOR_core__abstract_collection__Collection__iterator]))(var_); /* iterator on <var_:Set[WeightedLink]>*/
}
var_3 = var2;
for(;;) {
{
var4 = ((short int(*)(val* self))((((long)var_3&3)?class_info[((long)var_3&3)]:var_3->class)->vft[COLOR_core__abstract_collection__Iterator__is_ok]))(var_3); /* is_ok on <var_3:Iterator[WeightedLink]>*/
}
if (var4){
} else {
goto BREAK_label;
}
{
var5 = ((val*(*)(val* self))((((long)var_3&3)?class_info[((long)var_3&3)]:var_3->class)->vft[COLOR_core__abstract_collection__Iterator__item]))(var_3); /* item on <var_3:Iterator[WeightedLink]>*/
}
var_l = var5;
{
var6 = ((long(*)(val* self))(var_l->class->vft[COLOR_a_star__WeightedLink__weight]))(var_l); /* weight on <var_l:WeightedLink>*/
}
var_cost = var6;
{
{ /* Inline kernel#Int#>= (var_cost,var_worst_cost) on <var_cost:Int> */
/* Covariant cast for argument 0 (i) <var_worst_cost:Int> isa OTHER */
/* <var_worst_cost:Int> isa OTHER */
var9 = 1; /* easy <var_worst_cost:Int> isa OTHER*/
if (unlikely(!var9)) {
var_class_name = type_core__Int.name;
PRINT_ERROR("Runtime error: Cast failed. Expected `%s`, got `%s`", "OTHER", var_class_name);
PRINT_ERROR(" (%s:%d)\n", FILE_core__kernel, 723);
fatal_exit(1);
}
var10 = var_cost >= var_worst_cost;
var7 = var10;
goto RET_LABEL8;
RET_LABEL8:(void)0;
}
}
if (var7){
{
{ /* Inline kernel#Int#+ (var_cost,1l) on <var_cost:Int> */
/* Covariant cast for argument 0 (i) <1l:Int> isa OTHER */
/* <1l:Int> isa OTHER */
var13 = 1; /* easy <1l:Int> isa OTHER*/
if (unlikely(!var13)) {
var_class_name16 = type_core__Int.name;
PRINT_ERROR("Runtime error: Cast failed. Expected `%s`, got `%s`", "OTHER", var_class_name16);
PRINT_ERROR(" (%s:%d)\n", FILE_core__kernel, 725);
fatal_exit(1);
}
var17 = var_cost + 1l;
var11 = var17;
goto RET_LABEL12;
RET_LABEL12:(void)0;
}
}
var_worst_cost = var11;
} else {
}
{
((void(*)(val* self))((((long)var_3&3)?class_info[((long)var_3&3)]:var_3->class)->vft[COLOR_core__abstract_collection__Iterator__next]))(var_3); /* next on <var_3:Iterator[WeightedLink]>*/
}
}
BREAK_label: (void)0;
{
((void(*)(val* self))((((long)var_3&3)?class_info[((long)var_3&3)]:var_3->class)->vft[COLOR_core__abstract_collection__Iterator__finish]))(var_3); /* finish on <var_3:Iterator[WeightedLink]>*/
}
{
((void(*)(val* self, long p0))(self->class->vft[COLOR_a_star__WeightedPathContext__worst_cost_61d]))(self, var_worst_cost); /* worst_cost= on <self:WeightedPathContext>*/
}
RET_LABEL:;
}
/* method a_star#WeightedPathContext#worst_cost for (self: WeightedPathContext): Int */
long a_star___a_star__WeightedPathContext___PathContext__worst_cost(val* self) {
long var /* : Int */;
long var1 /* : Int */;
var1 = self->attrs[COLOR_a_star__WeightedPathContext___worst_cost].l; /* _worst_cost on <self:WeightedPathContext> */
var = var1;
RET_LABEL:;
return var;
}
/* method a_star#WeightedPathContext#worst_cost= for (self: WeightedPathContext, Int) */
void a_star___a_star__WeightedPathContext___worst_cost_61d(val* self, long p0) {
self->attrs[COLOR_a_star__WeightedPathContext___worst_cost].l = p0; /* _worst_cost on <self:WeightedPathContext> */
RET_LABEL:;
}
/* method a_star#WeightedPathContext#cost for (self: WeightedPathContext, WeightedLink): Int */
long a_star___a_star__WeightedPathContext___PathContext__cost(val* self, val* p0) {
long var /* : Int */;
short int var1 /* : Bool */;
int cltype;
int idtype;
const struct type* type_struct;
const char* var_class_name;
val* var_l /* var l: WeightedLink */;
long var2 /* : Int */;
/* Covariant cast for argument 0 (l) <p0:WeightedLink> isa L */
/* <p0:WeightedLink> isa L */
type_struct = self->type->resolution_table->types[COLOR_a_star__PathContext__L];
cltype = type_struct->color;
idtype = type_struct->id;
if(cltype >= p0->type->table_size) {
var1 = 0;
} else {
var1 = p0->type->type_table[cltype] == idtype;
}
if (unlikely(!var1)) {
var_class_name = p0 == NULL ? "null" : p0->type->name;
PRINT_ERROR("Runtime error: Cast failed. Expected `%s`, got `%s`", "L", var_class_name);
PRINT_ERROR(" (%s:%d)\n", FILE_a_star, 393);
fatal_exit(1);
}
var_l = p0;
{
var2 = ((long(*)(val* self))(var_l->class->vft[COLOR_a_star__WeightedLink__weight]))(var_l); /* weight on <var_l:WeightedLink>*/
}
var = var2;
goto RET_LABEL;
RET_LABEL:;
return var;
}
/* method a_star#WeightedPathContext#is_blocked for (self: WeightedPathContext, WeightedLink): Bool */
short int a_star___a_star__WeightedPathContext___PathContext__is_blocked(val* self, val* p0) {
short int var /* : Bool */;
short int var1 /* : Bool */;
int cltype;
int idtype;
const struct type* type_struct;
const char* var_class_name;
val* var_l /* var l: WeightedLink */;
/* Covariant cast for argument 0 (l) <p0:WeightedLink> isa L */
/* <p0:WeightedLink> isa L */
type_struct = self->type->resolution_table->types[COLOR_a_star__PathContext__L];
cltype = type_struct->color;
idtype = type_struct->id;
if(cltype >= p0->type->table_size) {
var1 = 0;
} else {
var1 = p0->type->type_table[cltype] == idtype;
}
if (unlikely(!var1)) {
var_class_name = p0 == NULL ? "null" : p0->type->name;
PRINT_ERROR("Runtime error: Cast failed. Expected `%s`, got `%s`", "L", var_class_name);
PRINT_ERROR(" (%s:%d)\n", FILE_a_star, 396);
fatal_exit(1);
}
var_l = p0;
var = 0;
goto RET_LABEL;
RET_LABEL:;
return var;
}
/* method a_star#WeightedPathContext#heuristic_cost for (self: WeightedPathContext, Node, Node): Int */
long a_star___a_star__WeightedPathContext___PathContext__heuristic_cost(val* self, val* p0, val* p1) {
long var /* : Int */;
short int var1 /* : Bool */;
int cltype;
int idtype;
const struct type* type_struct;
const char* var_class_name;
short int var2 /* : Bool */;
int cltype3;
int idtype4;
const struct type* type_struct5;
const char* var_class_name6;
val* var_a /* var a: Node */;
val* var_b /* var b: Node */;
/* Covariant cast for argument 0 (a) <p0:Node> isa N */
/* <p0:Node> isa N */
type_struct = self->type->resolution_table->types[COLOR_a_star__PathContext__N];
cltype = type_struct->color;
idtype = type_struct->id;
if(cltype >= p0->type->table_size) {
var1 = 0;
} else {
var1 = p0->type->type_table[cltype] == idtype;
}
if (unlikely(!var1)) {
var_class_name = p0 == NULL ? "null" : p0->type->name;
PRINT_ERROR("Runtime error: Cast failed. Expected `%s`, got `%s`", "N", var_class_name);
PRINT_ERROR(" (%s:%d)\n", FILE_a_star, 397);
fatal_exit(1);
}
/* Covariant cast for argument 1 (b) <p1:Node> isa N */
/* <p1:Node> isa N */
type_struct5 = self->type->resolution_table->types[COLOR_a_star__PathContext__N];
cltype3 = type_struct5->color;
idtype4 = type_struct5->id;
if(cltype3 >= p1->type->table_size) {
var2 = 0;
} else {
var2 = p1->type->type_table[cltype3] == idtype4;
}
if (unlikely(!var2)) {
var_class_name6 = p1 == NULL ? "null" : p1->type->name;
PRINT_ERROR("Runtime error: Cast failed. Expected `%s`, got `%s`", "N", var_class_name6);
PRINT_ERROR(" (%s:%d)\n", FILE_a_star, 397);
fatal_exit(1);
}
var_a = p0;
var_b = p1;
var = 0l;
goto RET_LABEL;
RET_LABEL:;
return var;
}
/* method a_star#WeightedPathContext#worst_heuristic_cost for (self: WeightedPathContext): Int */
long a_star___a_star__WeightedPathContext___PathContext__worst_heuristic_cost(val* self) {
long var /* : Int */;
var = 0l;
goto RET_LABEL;
RET_LABEL:;
return var;
}
/* method a_star#WeightedPathContext#core_serialize_to for (self: WeightedPathContext, Serializer) */
void a_star___a_star__WeightedPathContext___serialization__Serializable__core_serialize_to(val* self, val* p0) {
val* var_v /* var v: Serializer */;
static val* varonce;
val* var /* : String */;
char* var1 /* : NativeString */;
val* var2 /* : String */;
long var3 /* : Int */;
val* var4 /* : nullable Object */;
var_v = p0;
{
((void(*)(val* self, val* p0))(self->class->vft[COLOR_a_star___a_star__WeightedPathContext___serialization__Serializable__core_serialize_to]))(self, p0); /* core_serialize_to on <self:WeightedPathContext>*/
}
if (likely(varonce!=NULL)) {
var = varonce;
} else {
var1 = "worst_cost";
var2 = core__flat___NativeString___to_s_full(var1, 10l, 10l);
var = var2;
varonce = var;
}
{
var3 = ((long(*)(val* self))(self->class->vft[COLOR_a_star__PathContext__worst_cost]))(self); /* worst_cost on <self:WeightedPathContext>*/
}
{
var4 = (val*)(var3<<2|1);
((void(*)(val* self, val* p0, val* p1))((((long)var_v&3)?class_info[((long)var_v&3)]:var_v->class)->vft[COLOR_serialization__Serializer__serialize_attribute]))(var_v, var, var4); /* serialize_attribute on <var_v:Serializer>*/
}
RET_LABEL:;
}
/* method a_star#WeightedPathContext#from_deserializer for (self: WeightedPathContext, Deserializer) */
void a_star___a_star__WeightedPathContext___serialization__Serializable__from_deserializer(val* self, val* p0) {
val* var_v /* var v: Deserializer */;
static val* varonce;
val* var /* : String */;
char* var1 /* : NativeString */;
val* var2 /* : String */;
val* var3 /* : nullable Object */;
val* var_worst_cost /* var worst_cost: nullable Object */;
short int var4 /* : Bool */;
int cltype;
int idtype;
short int var5 /* : Bool */;
val* var6 /* : Array[Error] */;
val* var7 /* : AttributeTypeError */;
static val* varonce8;
val* var9 /* : String */;
char* var10 /* : NativeString */;
val* var11 /* : String */;
static val* varonce12;
val* var13 /* : String */;
char* var14 /* : NativeString */;
val* var15 /* : String */;
static val* varonce16;
val* var17 /* : String */;
char* var18 /* : NativeString */;
val* var19 /* : String */;
val* var20 /* : nullable Bool */;
short int var21 /* : Bool */;
short int var22 /* : Bool */;
short int var24 /* : Bool */;
short int var25 /* : Bool */;
long var26 /* : Int */;
var_v = p0;
{
((void(*)(val* self, val* p0))(self->class->vft[COLOR_a_star___a_star__WeightedPathContext___serialization__Serializable__from_deserializer]))(self, p0); /* from_deserializer on <self:WeightedPathContext>*/
}
{
((void(*)(val* self, val* p0))(var_v->class->vft[COLOR_serialization__Deserializer__notify_of_creation]))(var_v, self); /* notify_of_creation on <var_v:Deserializer>*/
}
if (likely(varonce!=NULL)) {
var = varonce;
} else {
var1 = "worst_cost";
var2 = core__flat___NativeString___to_s_full(var1, 10l, 10l);
var = var2;
varonce = var;
}
{
var3 = ((val*(*)(val* self, val* p0))(var_v->class->vft[COLOR_serialization__Deserializer__deserialize_attribute]))(var_v, var); /* deserialize_attribute on <var_v:Deserializer>*/
}
var_worst_cost = var3;
/* <var_worst_cost:nullable Object> isa Int */
cltype = type_core__Int.color;
idtype = type_core__Int.id;
if(var_worst_cost == NULL) {
var4 = 0;
} else {
if(cltype >= (((long)var_worst_cost&3)?type_info[((long)var_worst_cost&3)]:var_worst_cost->type)->table_size) {
var4 = 0;
} else {
var4 = (((long)var_worst_cost&3)?type_info[((long)var_worst_cost&3)]:var_worst_cost->type)->type_table[cltype] == idtype;
}
}
var5 = !var4;
if (var5){
{
var6 = ((val*(*)(val* self))(var_v->class->vft[COLOR_serialization__Deserializer__errors]))(var_v); /* errors on <var_v:Deserializer>*/
}
var7 = NEW_serialization__AttributeTypeError(&type_serialization__AttributeTypeError);
if (likely(varonce8!=NULL)) {
var9 = varonce8;
} else {
var10 = "TODO remove this arg on c_src regen";
var11 = core__flat___NativeString___to_s_full(var10, 35l, 35l);
var9 = var11;
varonce8 = var9;
}
if (likely(varonce12!=NULL)) {
var13 = varonce12;
} else {
var14 = "worst_cost";
var15 = core__flat___NativeString___to_s_full(var14, 10l, 10l);
var13 = var15;
varonce12 = var13;
}
if (likely(varonce16!=NULL)) {
var17 = varonce16;
} else {
var18 = "PlaceHolderTypeWhichShouldNotExist";
var19 = core__flat___NativeString___to_s_full(var18, 34l, 34l);
var17 = var19;
varonce16 = var17;
}
{
((void(*)(val* self, val* p0))(var7->class->vft[COLOR_core__error__Error__message_61d]))(var7, var9); /* message= on <var7:AttributeTypeError>*/
}
{
((void(*)(val* self, val* p0))(var7->class->vft[COLOR_serialization__AttributeTypeError__receiver_61d]))(var7, self); /* receiver= on <var7:AttributeTypeError>*/
}
{
((void(*)(val* self, val* p0))(var7->class->vft[COLOR_serialization__AttributeTypeError__attribute_name_61d]))(var7, var13); /* attribute_name= on <var7:AttributeTypeError>*/
}
{
((void(*)(val* self, val* p0))(var7->class->vft[COLOR_serialization__AttributeTypeError__attribute_61d]))(var7, var_worst_cost); /* attribute= on <var7:AttributeTypeError>*/
}
{
((void(*)(val* self, val* p0))(var7->class->vft[COLOR_serialization__AttributeTypeError__expected_type_61d]))(var7, var17); /* expected_type= on <var7:AttributeTypeError>*/
}
{
((void(*)(val* self))(var7->class->vft[COLOR_core__kernel__Object__init]))(var7); /* init on <var7:AttributeTypeError>*/
}
{
((void(*)(val* self, val* p0))(var6->class->vft[COLOR_core__abstract_collection__SimpleCollection__add]))(var6, var7); /* add on <var6:Array[Error]>*/
}
{
var20 = ((val*(*)(val* self))(var_v->class->vft[COLOR_serialization__Deserializer__keep_going]))(var_v); /* keep_going on <var_v:Deserializer>*/
}
if (var20 == NULL) {
var21 = 0; /* <0:Bool> cannot be null */
} else {
{ /* Inline kernel#Bool#== (var20,0) on <var20:nullable Bool> */
if ((var20 != NULL)) {
var25 = (short int)((long)(var20)>>2);
var24 = var25 == 0;
} else var24 = 0;
var22 = var24;
goto RET_LABEL23;
RET_LABEL23:(void)0;
}
var21 = var22;
}
if (var21){
goto RET_LABEL;
} else {
}
} else {
{
var26 = (long)(var_worst_cost)>>2;
((void(*)(val* self, long p0))(self->class->vft[COLOR_a_star__WeightedPathContext__worst_cost_61d]))(self, var26); /* worst_cost= on <self:WeightedPathContext>*/
}
}
RET_LABEL:;
}
/* method a_star#WeightedLink#weight for (self: WeightedLink): Int */
long a_star___a_star__WeightedLink___weight(val* self) {
long var /* : Int */;
long var1 /* : Int */;
var1 = self->attrs[COLOR_a_star__WeightedLink___weight].l; /* _weight on <self:WeightedLink> */
var = var1;
RET_LABEL:;
return var;
}
/* method a_star#WeightedLink#weight= for (self: WeightedLink, Int) */
void a_star___a_star__WeightedLink___weight_61d(val* self, long p0) {
self->attrs[COLOR_a_star__WeightedLink___weight].l = p0; /* _weight on <self:WeightedLink> */
RET_LABEL:;
}
/* method a_star#WeightedLink#core_serialize_to for (self: WeightedLink, Serializer) */
void a_star___a_star__WeightedLink___serialization__Serializable__core_serialize_to(val* self, val* p0) {
val* var_v /* var v: Serializer */;
static val* varonce;
val* var /* : String */;
char* var1 /* : NativeString */;
val* var2 /* : String */;
long var3 /* : Int */;
val* var4 /* : nullable Object */;
var_v = p0;
{
((void(*)(val* self, val* p0))(self->class->vft[COLOR_a_star___a_star__WeightedLink___serialization__Serializable__core_serialize_to]))(self, p0); /* core_serialize_to on <self:WeightedLink>*/
}
if (likely(varonce!=NULL)) {
var = varonce;
} else {
var1 = "weight";
var2 = core__flat___NativeString___to_s_full(var1, 6l, 6l);
var = var2;
varonce = var;
}
{
var3 = ((long(*)(val* self))(self->class->vft[COLOR_a_star__WeightedLink__weight]))(self); /* weight on <self:WeightedLink>*/
}
{
var4 = (val*)(var3<<2|1);
((void(*)(val* self, val* p0, val* p1))((((long)var_v&3)?class_info[((long)var_v&3)]:var_v->class)->vft[COLOR_serialization__Serializer__serialize_attribute]))(var_v, var, var4); /* serialize_attribute on <var_v:Serializer>*/
}
RET_LABEL:;
}
/* method a_star#WeightedLink#from_deserializer for (self: WeightedLink, Deserializer) */
void a_star___a_star__WeightedLink___serialization__Serializable__from_deserializer(val* self, val* p0) {
val* var_v /* var v: Deserializer */;
static val* varonce;
val* var /* : String */;
char* var1 /* : NativeString */;
val* var2 /* : String */;
val* var3 /* : nullable Object */;
val* var_weight /* var weight: nullable Object */;
short int var4 /* : Bool */;
int cltype;
int idtype;
short int var5 /* : Bool */;
val* var6 /* : Array[Error] */;
val* var7 /* : AttributeTypeError */;
static val* varonce8;
val* var9 /* : String */;
char* var10 /* : NativeString */;
val* var11 /* : String */;
static val* varonce12;
val* var13 /* : String */;
char* var14 /* : NativeString */;
val* var15 /* : String */;
static val* varonce16;
val* var17 /* : String */;
char* var18 /* : NativeString */;
val* var19 /* : String */;
val* var20 /* : nullable Bool */;
short int var21 /* : Bool */;
short int var22 /* : Bool */;
short int var24 /* : Bool */;
short int var25 /* : Bool */;
long var26 /* : Int */;
var_v = p0;
{
((void(*)(val* self, val* p0))(self->class->vft[COLOR_a_star___a_star__WeightedLink___serialization__Serializable__from_deserializer]))(self, p0); /* from_deserializer on <self:WeightedLink>*/
}
{
((void(*)(val* self, val* p0))(var_v->class->vft[COLOR_serialization__Deserializer__notify_of_creation]))(var_v, self); /* notify_of_creation on <var_v:Deserializer>*/
}
if (likely(varonce!=NULL)) {
var = varonce;
} else {
var1 = "weight";
var2 = core__flat___NativeString___to_s_full(var1, 6l, 6l);
var = var2;
varonce = var;
}
{
var3 = ((val*(*)(val* self, val* p0))(var_v->class->vft[COLOR_serialization__Deserializer__deserialize_attribute]))(var_v, var); /* deserialize_attribute on <var_v:Deserializer>*/
}
var_weight = var3;
/* <var_weight:nullable Object> isa Int */
cltype = type_core__Int.color;
idtype = type_core__Int.id;
if(var_weight == NULL) {
var4 = 0;
} else {
if(cltype >= (((long)var_weight&3)?type_info[((long)var_weight&3)]:var_weight->type)->table_size) {
var4 = 0;
} else {
var4 = (((long)var_weight&3)?type_info[((long)var_weight&3)]:var_weight->type)->type_table[cltype] == idtype;
}
}
var5 = !var4;
if (var5){
{
var6 = ((val*(*)(val* self))(var_v->class->vft[COLOR_serialization__Deserializer__errors]))(var_v); /* errors on <var_v:Deserializer>*/
}
var7 = NEW_serialization__AttributeTypeError(&type_serialization__AttributeTypeError);
if (likely(varonce8!=NULL)) {
var9 = varonce8;
} else {
var10 = "TODO remove this arg on c_src regen";
var11 = core__flat___NativeString___to_s_full(var10, 35l, 35l);
var9 = var11;
varonce8 = var9;
}
if (likely(varonce12!=NULL)) {
var13 = varonce12;
} else {
var14 = "weight";
var15 = core__flat___NativeString___to_s_full(var14, 6l, 6l);
var13 = var15;
varonce12 = var13;
}
if (likely(varonce16!=NULL)) {
var17 = varonce16;
} else {
var18 = "Int";
var19 = core__flat___NativeString___to_s_full(var18, 3l, 3l);
var17 = var19;
varonce16 = var17;
}
{
((void(*)(val* self, val* p0))(var7->class->vft[COLOR_core__error__Error__message_61d]))(var7, var9); /* message= on <var7:AttributeTypeError>*/
}
{
((void(*)(val* self, val* p0))(var7->class->vft[COLOR_serialization__AttributeTypeError__receiver_61d]))(var7, self); /* receiver= on <var7:AttributeTypeError>*/
}
{
((void(*)(val* self, val* p0))(var7->class->vft[COLOR_serialization__AttributeTypeError__attribute_name_61d]))(var7, var13); /* attribute_name= on <var7:AttributeTypeError>*/
}
{
((void(*)(val* self, val* p0))(var7->class->vft[COLOR_serialization__AttributeTypeError__attribute_61d]))(var7, var_weight); /* attribute= on <var7:AttributeTypeError>*/
}
{
((void(*)(val* self, val* p0))(var7->class->vft[COLOR_serialization__AttributeTypeError__expected_type_61d]))(var7, var17); /* expected_type= on <var7:AttributeTypeError>*/
}
{
((void(*)(val* self))(var7->class->vft[COLOR_core__kernel__Object__init]))(var7); /* init on <var7:AttributeTypeError>*/
}
{
((void(*)(val* self, val* p0))(var6->class->vft[COLOR_core__abstract_collection__SimpleCollection__add]))(var6, var7); /* add on <var6:Array[Error]>*/
}
{
var20 = ((val*(*)(val* self))(var_v->class->vft[COLOR_serialization__Deserializer__keep_going]))(var_v); /* keep_going on <var_v:Deserializer>*/
}
if (var20 == NULL) {
var21 = 0; /* <0:Bool> cannot be null */
} else {
{ /* Inline kernel#Bool#== (var20,0) on <var20:nullable Bool> */
if ((var20 != NULL)) {
var25 = (short int)((long)(var20)>>2);
var24 = var25 == 0;
} else var24 = 0;
var22 = var24;
goto RET_LABEL23;
RET_LABEL23:(void)0;
}
var21 = var22;
}
if (var21){
goto RET_LABEL;
} else {
}
} else {
{
var26 = (long)(var_weight)>>2;
((void(*)(val* self, long p0))(self->class->vft[COLOR_a_star__WeightedLink__weight_61d]))(self, var26); /* weight= on <self:WeightedLink>*/
}
}
RET_LABEL:;
}
/* method a_star#WeightedLink#init for (self: WeightedLink) */
void a_star___a_star__WeightedLink___core__kernel__Object__init(val* self) {
{
((void(*)(val* self))(self->class->vft[COLOR_a_star___a_star__WeightedLink___core__kernel__Object__init]))(self); /* init on <self:WeightedLink>*/
}
RET_LABEL:;
}
/* method a_star#TargetCondition#accept for (self: TargetCondition[Node], Node): Bool */
short int a_star___a_star__TargetCondition___accept(val* self, val* p0) {
short int var /* : Bool */;
const char* var_class_name;
var_class_name = self == NULL ? "null" : self->type->name;
PRINT_ERROR("Runtime error: Abstract method `%s` called on `%s`", "accept", var_class_name);
PRINT_ERROR(" (%s:%d)\n", FILE_a_star, 414);
fatal_exit(1);
RET_LABEL:;
return var;
}
/* method a_star#TargetCondition#heuristic_cost for (self: TargetCondition[Node], Node, Link): Int */
long a_star___a_star__TargetCondition___heuristic_cost(val* self, val* p0, val* p1) {
long var /* : Int */;
const char* var_class_name;
var_class_name = self == NULL ? "null" : self->type->name;
PRINT_ERROR("Runtime error: Abstract method `%s` called on `%s`", "heuristic_cost", var_class_name);
PRINT_ERROR(" (%s:%d)\n", FILE_a_star, 417);
fatal_exit(1);
RET_LABEL:;
return var;
}
/* method a_star#TargetCondition#core_serialize_to for (self: TargetCondition[Node], Serializer) */
void a_star___a_star__TargetCondition___serialization__Serializable__core_serialize_to(val* self, val* p0) {
val* var_v /* var v: Serializer */;
var_v = p0;
{
((void(*)(val* self, val* p0))(self->class->vft[COLOR_a_star___a_star__TargetCondition___serialization__Serializable__core_serialize_to]))(self, p0); /* core_serialize_to on <self:TargetCondition[Node]>*/
}
RET_LABEL:;
}
/* method a_star#TargetCondition#from_deserializer for (self: TargetCondition[Node], Deserializer) */
void a_star___a_star__TargetCondition___serialization__Serializable__from_deserializer(val* self, val* p0) {
val* var_v /* var v: Deserializer */;
var_v = p0;
{
((void(*)(val* self, val* p0))(self->class->vft[COLOR_a_star___a_star__TargetCondition___serialization__Serializable__from_deserializer]))(self, p0); /* from_deserializer on <self:TargetCondition[Node]>*/
}
{
((void(*)(val* self, val* p0))(var_v->class->vft[COLOR_serialization__Deserializer__notify_of_creation]))(var_v, self); /* notify_of_creation on <var_v:Deserializer>*/
}
RET_LABEL:;
}
/* method a_star#Deserializer#deserialize_class_intern for (self: Deserializer, String): nullable Object */
val* a_star___serialization__Deserializer___deserialize_class_intern(val* self, val* p0) {
val* var /* : nullable Object */;
val* var_name /* var name: String */;
static val* varonce;
val* var1 /* : String */;
char* var2 /* : NativeString */;
val* var3 /* : String */;
short int var4 /* : Bool */;
val* var5 /* : Link */;
static val* varonce6;
val* var7 /* : String */;
char* var8 /* : NativeString */;
val* var9 /* : String */;
short int var10 /* : Bool */;
val* var11 /* : ConstantPathContext */;
static val* varonce12;
val* var13 /* : String */;
char* var14 /* : NativeString */;
val* var15 /* : String */;
short int var16 /* : Bool */;
val* var17 /* : WeightedPathContext */;
static val* varonce18;
val* var19 /* : String */;
char* var20 /* : NativeString */;
val* var21 /* : String */;
short int var22 /* : Bool */;
val* var23 /* : WeightedLink */;
val* var24 /* : nullable Object */;
var_name = p0;
if (likely(varonce!=NULL)) {
var1 = varonce;
} else {
var2 = "Link";
var3 = core__flat___NativeString___to_s_full(var2, 4l, 4l);
var1 = var3;
varonce = var1;
}
{
var4 = ((short int(*)(val* self, val* p0))(var_name->class->vft[COLOR_core__kernel__Object___61d_61d]))(var_name, var1); /* == on <var_name:String>*/
}
if (var4){
var5 = NEW_a_star__Link(&type_a_star__Link);
{
((void(*)(val* self, val* p0))(var5->class->vft[COLOR_serialization__Serializable__from_deserializer]))(var5, self); /* from_deserializer on <var5:Link>*/
}
var = var5;
goto RET_LABEL;
} else {
}
if (likely(varonce6!=NULL)) {
var7 = varonce6;
} else {
var8 = "ConstantPathContext";
var9 = core__flat___NativeString___to_s_full(var8, 19l, 19l);
var7 = var9;
varonce6 = var7;
}
{
var10 = ((short int(*)(val* self, val* p0))(var_name->class->vft[COLOR_core__kernel__Object___61d_61d]))(var_name, var7); /* == on <var_name:String>*/
}
if (var10){
var11 = NEW_a_star__ConstantPathContext(&type_a_star__ConstantPathContext);
{
((void(*)(val* self, val* p0))(var11->class->vft[COLOR_serialization__Serializable__from_deserializer]))(var11, self); /* from_deserializer on <var11:ConstantPathContext>*/
}
var = var11;
goto RET_LABEL;
} else {
}
if (likely(varonce12!=NULL)) {
var13 = varonce12;
} else {
var14 = "WeightedPathContext";
var15 = core__flat___NativeString___to_s_full(var14, 19l, 19l);
var13 = var15;
varonce12 = var13;
}
{
var16 = ((short int(*)(val* self, val* p0))(var_name->class->vft[COLOR_core__kernel__Object___61d_61d]))(var_name, var13); /* == on <var_name:String>*/
}
if (var16){
var17 = NEW_a_star__WeightedPathContext(&type_a_star__WeightedPathContext);
{
((void(*)(val* self, val* p0))(var17->class->vft[COLOR_serialization__Serializable__from_deserializer]))(var17, self); /* from_deserializer on <var17:WeightedPathContext>*/
}
var = var17;
goto RET_LABEL;
} else {
}
if (likely(varonce18!=NULL)) {
var19 = varonce18;
} else {
var20 = "WeightedLink";
var21 = core__flat___NativeString___to_s_full(var20, 12l, 12l);
var19 = var21;
varonce18 = var19;
}
{
var22 = ((short int(*)(val* self, val* p0))(var_name->class->vft[COLOR_core__kernel__Object___61d_61d]))(var_name, var19); /* == on <var_name:String>*/
}
if (var22){
var23 = NEW_a_star__WeightedLink(&type_a_star__WeightedLink);
{
((void(*)(val* self, val* p0))(var23->class->vft[COLOR_serialization__Serializable__from_deserializer]))(var23, self); /* from_deserializer on <var23:WeightedLink>*/
}
var = var23;
goto RET_LABEL;
} else {
}
{
var24 = ((val*(*)(val* self, val* p0))(self->class->vft[COLOR_a_star___serialization__Deserializer___deserialize_class_intern]))(self, p0); /* deserialize_class_intern on <self:Deserializer>*/
}
var = var24;
goto RET_LABEL;
RET_LABEL:;
return var;
}
