/*
	Extern implementation of Nit module nebula
*/
#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>
#include "rnr__nebula._ffi.h"
#ifdef ANDROID
	#include <android/log.h>
	#define PRINT_ERROR(...) (void)__android_log_print(ANDROID_LOG_WARN, "Nit", __VA_ARGS__)
#else
	#define PRINT_ERROR(...) fprintf(stderr, __VA_ARGS__)
#endif
void rnr__nebula___Opengles1Display_native_blit_nebula___impl( Opengles1Display self,  float*  coords,  float*  colors, long w, long h )
{
#line 194 "src/client/nebula.nit"


		glLoadIdentity();

		glEnableClientState(GL_VERTEX_ARRAY);
		glEnableClientState(GL_COLOR_ARRAY);

		glEnable(GL_BLEND);
		glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

		glDisable(GL_DEPTH_TEST);
		glDisable(GL_TEXTURE_2D);

		glVertexPointer(3, GL_FLOAT, 0, coords);
		glColorPointer(4, GL_FLOAT, 0, colors);
		glDrawArrays(GL_TRIANGLES, 0, w * h * 2 * 3);

		glDisableClientState(GL_VERTEX_ARRAY);
		glDisableClientState(GL_COLOR_ARRAY);
		glDisable(GL_BLEND);

		if ((mnit_opengles_error_code = glGetError()) != GL_NO_ERROR) {
			fprintf(stderr, "Error drawing: %i\n", mnit_opengles_error_code);
		}
	}
