/*
	Extern implementation of Nit module socket_c
*/
#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>
#include "socket__socket_c._ffi.h"
#ifdef ANDROID
	#include <android/log.h>
	#define PRINT_ERROR(...) (void)__android_log_print(ANDROID_LOG_WARN, "Nit", __VA_ARGS__)
#else
	#define PRINT_ERROR(...) fprintf(stderr, __VA_ARGS__)
#endif
#line 32 "/home/xymus/projects/nit/lib/socket/socket_c.nit"


	#include <fcntl.h>
	#include <netinet/tcp.h>
long socket__socket_c___PollFD_c_check_resp___impl( PollFD self, long response,  int  mask )
{
#line 75 "/home/xymus/projects/nit/lib/socket/socket_c.nit"


		return response & mask;
	}
long socket__socket_c___NativeSocketPollFD_fd___impl(  struct pollfd *  self )
{
#line 89 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return self->fd; }
long socket__socket_c___NativeSocketPollFD_events___impl(  struct pollfd *  self )
{
#line 92 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return self->events; }
long socket__socket_c___NativeSocketPollFD_revents___impl(  struct pollfd *  self )
{
#line 95 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

  return self->revents; }
 struct pollfd *  socket__socket_c___new_NativeSocketPollFD___impl( long pid,  int  events )
{
#line 97 "/home/xymus/projects/nit/lib/socket/socket_c.nit"


		struct pollfd *poll = malloc(sizeof(struct pollfd));
		poll->fd = pid;
		poll->events = events;
		return poll;
	}
 int*  socket__socket_c___new_NativeSocket_socket___impl(  int  domain,  int  socketType,  int  protocol )
{
#line 107 "/home/xymus/projects/nit/lib/socket/socket_c.nit"


		int ds = socket(domain, socketType, protocol);
		if(ds == -1){
			return NULL;
		}
		int *d = malloc(sizeof(int));
		memcpy(d, &ds, sizeof(ds));
		return d;
	}
void socket__socket_c___NativeSocket_destroy___impl(  int*  self )
{
#line 117 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 free(self); }
long socket__socket_c___NativeSocket_close___impl(  int*  self )
{
#line 119 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return close(*self); }
long socket__socket_c___NativeSocket_descriptor___impl(  int*  self )
{
#line 121 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return *self; }
long socket__socket_c___NativeSocket_connect___impl(  int*  self,  struct sockaddr_in*  addrIn )
{
#line 123 "/home/xymus/projects/nit/lib/socket/socket_c.nit"


		return connect(*self, (struct sockaddr*)addrIn, sizeof(*addrIn));
	}
long socket__socket_c___NativeSocket_write___impl(  int*  self, char* buffer, long length )
{
#line 128 "/home/xymus/projects/nit/lib/socket/socket_c.nit"


		return write(*self, buffer, length);
	}
long socket__socket_c___NativeSocket_write_byte___impl(  int*  self, unsigned char value )
{
#line 133 "/home/xymus/projects/nit/lib/socket/socket_c.nit"


		unsigned char byt = (unsigned char)value;
		return write(*self, &byt, 1);
	}
long socket__socket_c___NativeSocket_read___impl(  int*  self, char* buffer, long length )
{
#line 139 "/home/xymus/projects/nit/lib/socket/socket_c.nit"


		return read(*self, buffer, length);
	}
int socket__socket_c___NativeSocket_setsockopt___impl(  int*  self,  int  level,  int  option_name, long option_value )
{
#line 146 "/home/xymus/projects/nit/lib/socket/socket_c.nit"


		int err = setsockopt(*self, level, option_name, &option_value, sizeof(int));
		if(err != 0){
			return 0;
		}
		return 1;
	}
long socket__socket_c___NativeSocket_bind___impl(  int*  self,  struct sockaddr_in*  addrIn )
{
#line 154 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return bind(*self, (struct sockaddr*)addrIn, sizeof(*addrIn)); }
long socket__socket_c___NativeSocket_listen___impl(  int*  self, long size )
{
#line 156 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return listen(*self, size); }
long socket__socket_c___NativeSocket_poll_hup_err___impl(  int*  self )
{
#line 169 "/home/xymus/projects/nit/lib/socket/socket_c.nit"


		struct pollfd fd = {*self, POLLHUP|POLLERR, 0};
		int res = poll(&fd, 1, 0);
		return res;
	}
long socket__socket_c___NativeSocket_native_poll___impl(  int*  self,  struct pollfd *  filedesc, long timeout )
{
#line 190 "/home/xymus/projects/nit/lib/socket/socket_c.nit"


		int poll_return = poll(filedesc, 1, timeout);
		return poll_return;
	}
 int*  socket__socket_c___NativeSocket_native_accept___impl(  int*  self,  struct sockaddr_in*  addr_in )
{
#line 195 "/home/xymus/projects/nit/lib/socket/socket_c.nit"


		socklen_t s = sizeof(struct sockaddr);
		int socket = accept(*self, (struct sockaddr*)addr_in, &s);
		if (socket == -1) return NULL;

		int *ptr = malloc(sizeof(int));
		*ptr = socket;
		return ptr;
	}
void socket__socket_c___NativeSocket_non_blocking__assign___impl(  int*  self, int value )
{
#line 214 "/home/xymus/projects/nit/lib/socket/socket_c.nit"


		int flags = fcntl(*self, F_GETFL, 0);
		if (flags == -1) flags = 0;

		if (value) {
			flags = flags | O_NONBLOCK;
		} else if (flags & O_NONBLOCK) {
			flags = flags - O_NONBLOCK;
		} else {
			return;
		}
		fcntl(*self, F_SETFL, flags);
	}
long socket__socket_c___NativeSocket_sendto___impl(  int*  self, char* buf, long len, long flags,  struct sockaddr_in*  dest_addr )
{
#line 229 "/home/xymus/projects/nit/lib/socket/socket_c.nit"


		return sendto(*self, buf, len, flags, (struct sockaddr*)dest_addr, sizeof(struct sockaddr_in));
	}
long socket__socket_c___NativeSocket_recv___impl(  int*  self, char* buf, long len, long flags )
{
#line 234 "/home/xymus/projects/nit/lib/socket/socket_c.nit"


		return recv(*self, buf, len, flags);
	}
long socket__socket_c___NativeSocket_recvfrom___impl(  int*  self, char* buf, long len, long flags,  struct sockaddr_in*  src_addr )
{
#line 239 "/home/xymus/projects/nit/lib/socket/socket_c.nit"


		socklen_t srclen = sizeof(struct sockaddr_in);
		return recvfrom(*self, buf, len, flags, (struct sockaddr*)src_addr, &srclen);
	}
 struct sockaddr_in*  socket__socket_c___new_NativeSocketAddrIn_nul___impl(  )
{
#line 259 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return NULL; }
 struct sockaddr_in*  socket__socket_c___new_NativeSocketAddrIn___impl(  )
{
#line 262 "/home/xymus/projects/nit/lib/socket/socket_c.nit"


		struct sockaddr_in *sai = NULL;
		sai = malloc(sizeof(struct sockaddr_in));
		return sai;
	}
void socket__socket_c___NativeSocketAddrIn_fill_from_hostent___impl(  struct sockaddr_in*  self,  struct hostent*  hostent )
{
#line 269 "/home/xymus/projects/nit/lib/socket/socket_c.nit"


		self->sin_family = hostent->h_addrtype;
		memcpy((char*)&self->sin_addr.s_addr,
		       (char*)hostent->h_addr,
			   hostent->h_length);
	}
char* socket__socket_c___NativeSocketAddrIn_address___impl(  struct sockaddr_in*  self )
{
#line 277 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return (char*)inet_ntoa(self->sin_addr); }
void socket__socket_c___NativeSocketAddrIn_address_any___impl(  struct sockaddr_in*  self )
{
#line 280 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 self->sin_addr.s_addr = INADDR_ANY; }
void socket__socket_c___NativeSocketAddrIn_address_broadcast___impl(  struct sockaddr_in*  self )
{
#line 283 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 self->sin_addr.s_addr = INADDR_BROADCAST; }
 int  socket__socket_c___NativeSocketAddrIn_family___impl(  struct sockaddr_in*  self )
{
#line 286 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return self->sin_family; }
void socket__socket_c___NativeSocketAddrIn_family__assign___impl(  struct sockaddr_in*  self,  int  value )
{
#line 289 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 self->sin_family = value; }
long socket__socket_c___NativeSocketAddrIn_port___impl(  struct sockaddr_in*  self )
{
#line 292 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return ntohs(self->sin_port); }
void socket__socket_c___NativeSocketAddrIn_port__assign___impl(  struct sockaddr_in*  self, long value )
{
#line 295 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 self->sin_port = htons(value); }
char* socket__socket_c___NativeSocketHostent_native_h_aliases___impl(  struct hostent*  self, long i )
{
#line 300 "/home/xymus/projects/nit/lib/socket/socket_c.nit"


		return self->h_aliases[i];
	}
char* socket__socket_c___NativeSocketHostent_h_addr___impl(  struct hostent*  self )
{
#line 316 "/home/xymus/projects/nit/lib/socket/socket_c.nit"


		return (char*)inet_ntoa(*(struct in_addr*)self->h_addr);
	}
long socket__socket_c___NativeSocketHostent_h_addrtype___impl(  struct hostent*  self )
{
#line 320 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return self->h_addrtype; }
long socket__socket_c___NativeSocketHostent_h_length___impl(  struct hostent*  self )
{
#line 322 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return self->h_length; }
char* socket__socket_c___NativeSocketHostent_h_name___impl(  struct hostent*  self )
{
#line 324 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return self->h_name; }
 struct timeval*  socket__socket_c___new_NativeTimeval___impl( long seconds, long microseconds )
{
#line 328 "/home/xymus/projects/nit/lib/socket/socket_c.nit"


		struct timeval* tv = NULL;
		tv = malloc(sizeof(struct timeval));
		tv->tv_sec = seconds;
		tv->tv_usec = microseconds;
		return tv;
	}
long socket__socket_c___NativeTimeval_seconds___impl(  struct timeval*  self )
{
#line 336 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return self->tv_sec; }
long socket__socket_c___NativeTimeval_microseconds___impl(  struct timeval*  self )
{
#line 338 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return self->tv_usec; }
void socket__socket_c___NativeTimeval_destroy___impl(  struct timeval*  self )
{
#line 340 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 free(self); }
 fd_set*  socket__socket_c___new_NativeSocketSet___impl(  )
{
#line 344 "/home/xymus/projects/nit/lib/socket/socket_c.nit"


		fd_set *f = NULL;
		f = malloc(sizeof(fd_set));
		return f;
	}
void socket__socket_c___NativeSocketSet_set___impl(  fd_set*  self,  int*  s )
{
#line 350 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 FD_SET(*s, self); }
int socket__socket_c___NativeSocketSet_is_set___impl(  fd_set*  self,  int*  s )
{
#line 352 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return FD_ISSET(*s, self); }
void socket__socket_c___NativeSocketSet_zero___impl(  fd_set*  self )
{
#line 354 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 FD_ZERO(self); }
void socket__socket_c___NativeSocketSet_clear___impl(  fd_set*  self,  int*  s )
{
#line 356 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 FD_CLR(*s, self); }
void socket__socket_c___NativeSocketSet_destroy___impl(  fd_set*  self )
{
#line 358 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 free(self); }
long socket__socket_c___NativeSocketObserver_select___impl( NativeSocketObserver self,  int*  max, nullable_NativeSocketSet reads, nullable_NativeSocketSet write, nullable_NativeSocketSet except,  struct timeval*  timeout )
{
#line 365 "/home/xymus/projects/nit/lib/socket/socket_c.nit"


		fd_set *rds = NULL,
		       *wts = NULL,
		       *exs = NULL;
		struct timeval *tm = NULL;
		if (reads != NULL) rds = (fd_set*)reads;
		if (write != NULL) wts = (fd_set*)write;
		if (except != NULL) exs = (fd_set*)except;
		if (timeout != NULL) tm = (struct timeval*)timeout;
		return select(*max, rds, wts, exs, tm);
	}
 int  socket__socket_c___new_NativeSocketTypes_sock_stream___impl(  )
{
#line 379 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return SOCK_STREAM; }
 int  socket__socket_c___new_NativeSocketTypes_sock_dgram___impl(  )
{
#line 380 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return SOCK_DGRAM; }
 int  socket__socket_c___new_NativeSocketTypes_sock_raw___impl(  )
{
#line 381 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return SOCK_RAW; }
 int  socket__socket_c___new_NativeSocketTypes_sock_seqpacket___impl(  )
{
#line 382 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return SOCK_SEQPACKET; }
 int  socket__socket_c___new_NativeSocketAddressFamilies_af_null___impl(  )
{
#line 386 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return 0; }
 int  socket__socket_c___new_NativeSocketAddressFamilies_af_unspec___impl(  )
{
#line 389 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return AF_UNSPEC; }
 int  socket__socket_c___new_NativeSocketAddressFamilies_af_unix___impl(  )
{
#line 392 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return AF_UNIX; }
 int  socket__socket_c___new_NativeSocketAddressFamilies_af_local___impl(  )
{
#line 395 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return AF_LOCAL; }
 int  socket__socket_c___new_NativeSocketAddressFamilies_af_inet___impl(  )
{
#line 398 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return AF_INET; }
 int  socket__socket_c___new_NativeSocketAddressFamilies_af_sna___impl(  )
{
#line 401 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return AF_SNA; }
 int  socket__socket_c___new_NativeSocketAddressFamilies_af_decnet___impl(  )
{
#line 404 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return AF_DECnet; }
 int  socket__socket_c___new_NativeSocketAddressFamilies_af_route___impl(  )
{
#line 407 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return AF_ROUTE; }
 int  socket__socket_c___new_NativeSocketAddressFamilies_af_ipx___impl(  )
{
#line 410 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return AF_IPX; }
 int  socket__socket_c___new_NativeSocketAddressFamilies_af_inet6___impl(  )
{
#line 413 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return AF_INET6; }
 int  socket__socket_c___new_NativeSocketAddressFamilies_af_max___impl(  )
{
#line 415 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return AF_MAX; }
 int  socket__socket_c___new_NativeSocketProtocolFamilies_pf_null___impl(  )
{
#line 419 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return 0; }
 int  socket__socket_c___new_NativeSocketProtocolFamilies_pf_unspec___impl(  )
{
#line 420 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return PF_UNSPEC; }
 int  socket__socket_c___new_NativeSocketProtocolFamilies_pf_local___impl(  )
{
#line 421 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return PF_LOCAL; }
 int  socket__socket_c___new_NativeSocketProtocolFamilies_pf_unix___impl(  )
{
#line 422 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return PF_UNIX; }
 int  socket__socket_c___new_NativeSocketProtocolFamilies_pf_inet___impl(  )
{
#line 423 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return PF_INET; }
 int  socket__socket_c___new_NativeSocketProtocolFamilies_pf_sna___impl(  )
{
#line 424 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return PF_SNA; }
 int  socket__socket_c___new_NativeSocketProtocolFamilies_pf_decnet___impl(  )
{
#line 425 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return PF_DECnet; }
 int  socket__socket_c___new_NativeSocketProtocolFamilies_pf_route___impl(  )
{
#line 426 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return PF_ROUTE; }
 int  socket__socket_c___new_NativeSocketProtocolFamilies_pf_ipx___impl(  )
{
#line 427 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return PF_IPX; }
 int  socket__socket_c___new_NativeSocketProtocolFamilies_pf_key___impl(  )
{
#line 428 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return PF_KEY; }
 int  socket__socket_c___new_NativeSocketProtocolFamilies_pf_inet6___impl(  )
{
#line 429 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return PF_INET6; }
 int  socket__socket_c___new_NativeSocketProtocolFamilies_pf_max___impl(  )
{
#line 430 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return PF_MAX; }
 int  socket__socket_c___new_NativeSocketProtocolFamilies_ipproto_udp___impl(  )
{
#line 431 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return IPPROTO_UDP; }
 int  socket__socket_c___new_NativeSocketOptLevels_ip___impl(  )
{
#line 438 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return IPPROTO_IP;}
 int  socket__socket_c___new_NativeSocketOptLevels_icmp___impl(  )
{
#line 441 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return IPPROTO_ICMP;}
 int  socket__socket_c___new_NativeSocketOptLevels_tcp___impl(  )
{
#line 444 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return IPPROTO_TCP; }
 int  socket__socket_c___new_NativeSocketOptLevels_socket___impl(  )
{
#line 447 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return SOL_SOCKET; }
 int  socket__socket_c___new_NativeSocketOptNames_debug___impl(  )
{
#line 454 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return SO_DEBUG; }
 int  socket__socket_c___new_NativeSocketOptNames_broadcast___impl(  )
{
#line 457 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return SO_BROADCAST; }
 int  socket__socket_c___new_NativeSocketOptNames_reuseaddr___impl(  )
{
#line 460 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return SO_REUSEADDR; }
 int  socket__socket_c___new_NativeSocketOptNames_keepalive___impl(  )
{
#line 463 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return SO_KEEPALIVE; }
 int  socket__socket_c___new_NativeSocketOptNames_tcp_nodelay___impl(  )
{
#line 466 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return TCP_NODELAY; }
 int  socket__socket_c___new_NativeSocketPollValues_pollin___impl(  )
{
#line 473 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return POLLIN; }
 int  socket__socket_c___new_NativeSocketPollValues_pollrdnorm___impl(  )
{
#line 476 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return POLLRDNORM; }
 int  socket__socket_c___new_NativeSocketPollValues_pollrdband___impl(  )
{
#line 479 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return POLLRDBAND; }
 int  socket__socket_c___new_NativeSocketPollValues_pollpri___impl(  )
{
#line 482 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return POLLPRI; }
 int  socket__socket_c___new_NativeSocketPollValues_pollout___impl(  )
{
#line 485 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return POLLOUT; }
 int  socket__socket_c___new_NativeSocketPollValues_pollwrnorm___impl(  )
{
#line 488 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return POLLWRNORM; }
 int  socket__socket_c___new_NativeSocketPollValues_pollwrband___impl(  )
{
#line 491 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return POLLWRBAND; }
 int  socket__socket_c___new_NativeSocketPollValues_pollerr___impl(  )
{
#line 496 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return POLLERR; }
 int  socket__socket_c___new_NativeSocketPollValues_pollhup___impl(  )
{
#line 505 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return POLLHUP; }
 int  socket__socket_c___new_NativeSocketPollValues_pollnval___impl(  )
{
#line 510 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return POLLNVAL; }
 int  socket__socket_c___NativeSocketPollValues__plus___impl(  int  self,  int  other )
{
#line 513 "/home/xymus/projects/nit/lib/socket/socket_c.nit"


		return self | other;
	}
 struct hostent*  socket__socket_c___Sys_gethostbyname___impl( Sys self, char* name )
{
#line 520 "/home/xymus/projects/nit/lib/socket/socket_c.nit"


		return gethostbyname(name);
	}
 int  socket__socket_c___Sys_h_errno___impl( Sys self )
{
#line 525 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return h_errno; }
int socket__socket_c___HErrno_host_not_found___impl(  int  self )
{
#line 531 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return self == HOST_NOT_FOUND; }
int socket__socket_c___HErrno_no_address___impl(  int  self )
{
#line 536 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return self == NO_ADDRESS; }
int socket__socket_c___HErrno_no_data___impl(  int  self )
{
#line 541 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return self == NO_DATA; }
int socket__socket_c___HErrno_no_recovery___impl(  int  self )
{
#line 544 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return self == NO_RECOVERY; }
int socket__socket_c___HErrno_try_again___impl(  int  self )
{
#line 547 "/home/xymus/projects/nit/lib/socket/socket_c.nit"

 return self == TRY_AGAIN; }
