/*
	Extern implementation of Nit module native_sqlite3
*/
#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>
#include "sqlite3__native_sqlite3._ffi.h"
#ifdef ANDROID
	#include <android/log.h>
	#define PRINT_ERROR(...) (void)__android_log_print(ANDROID_LOG_WARN, "Nit", __VA_ARGS__)
#else
	#define PRINT_ERROR(...) fprintf(stderr, __VA_ARGS__)
#endif
#define NativeString_to_s sqlite3__native_sqlite3___NativeString_to_s
#define String_to_cstring sqlite3__native_sqlite3___String_to_cstring
#define NativeSqlite3_set_sys_sqlite_open_error sqlite3__native_sqlite3___NativeSqlite3_set_sys_sqlite_open_error
int sqlite3__native_sqlite3___new_Sqlite3Code_ok___impl(  )
{
#line 30 "/home/xymus/projects/nit/lib/sqlite3/native_sqlite3.nit"

 return SQLITE_OK; }
int sqlite3__native_sqlite3___Sqlite3Code_is_ok___impl( int self )
{
#line 31 "/home/xymus/projects/nit/lib/sqlite3/native_sqlite3.nit"

 return self == SQLITE_OK; }
int sqlite3__native_sqlite3___new_Sqlite3Code_row___impl(  )
{
#line 62 "/home/xymus/projects/nit/lib/sqlite3/native_sqlite3.nit"

 return SQLITE_ROW; }
int sqlite3__native_sqlite3___Sqlite3Code_is_row___impl( int self )
{
#line 63 "/home/xymus/projects/nit/lib/sqlite3/native_sqlite3.nit"

 return self == SQLITE_ROW; }
int sqlite3__native_sqlite3___new_Sqlite3Code_done___impl(  )
{
#line 65 "/home/xymus/projects/nit/lib/sqlite3/native_sqlite3.nit"

 return SQLITE_DONE; }
int sqlite3__native_sqlite3___Sqlite3Code_is_done___impl( int self )
{
#line 66 "/home/xymus/projects/nit/lib/sqlite3/native_sqlite3.nit"

 return self == SQLITE_DONE; }
String sqlite3__native_sqlite3___Sqlite3Code_to_s___impl( int self )
{
#line 68 "/home/xymus/projects/nit/lib/sqlite3/native_sqlite3.nit"


#if SQLITE_VERSION_NUMBER >= 3007015
		char *err = (char *)sqlite3_errstr(self);
#else
		char *err = "sqlite3_errstr supported only by version >= 3.7.15";
#endif
		if (err == NULL) err = "";
		return NativeString_to_s(err);
	}
int sqlite3__native_sqlite3___NativeStatement_step___impl( sqlite3_stmt* self )
{
#line 83 "/home/xymus/projects/nit/lib/sqlite3/native_sqlite3.nit"


		return sqlite3_step(self);
	}
String sqlite3__native_sqlite3___NativeStatement_column_name___impl( sqlite3_stmt* self, long i )
{
#line 87 "/home/xymus/projects/nit/lib/sqlite3/native_sqlite3.nit"


		const char * name = (sqlite3_column_name(self, i));
		if(name == NULL){
			name = "";
		}
		char * ret = (char *) name;
		return NativeString_to_s(ret);
	}
long sqlite3__native_sqlite3___NativeStatement_column_bytes___impl( sqlite3_stmt* self, long i )
{
#line 97 "/home/xymus/projects/nit/lib/sqlite3/native_sqlite3.nit"


		return sqlite3_column_bytes(self, i);
	}
double sqlite3__native_sqlite3___NativeStatement_column_double___impl( sqlite3_stmt* self, long i )
{
#line 101 "/home/xymus/projects/nit/lib/sqlite3/native_sqlite3.nit"


		return sqlite3_column_double(self, i);
	}
long sqlite3__native_sqlite3___NativeStatement_column_int___impl( sqlite3_stmt* self, long i )
{
#line 105 "/home/xymus/projects/nit/lib/sqlite3/native_sqlite3.nit"


		return sqlite3_column_int(self, i);
	}
char* sqlite3__native_sqlite3___NativeStatement_column_text___impl( sqlite3_stmt* self, long i )
{
#line 109 "/home/xymus/projects/nit/lib/sqlite3/native_sqlite3.nit"


		return (char *)sqlite3_column_text(self, i);
	}
 int  sqlite3__native_sqlite3___NativeStatement_column_type___impl( sqlite3_stmt* self, long i )
{
#line 114 "/home/xymus/projects/nit/lib/sqlite3/native_sqlite3.nit"


		return sqlite3_column_type(self, i);
	}
void* sqlite3__native_sqlite3___NativeStatement_column_blob___impl( sqlite3_stmt* self, long i )
{
#line 118 "/home/xymus/projects/nit/lib/sqlite3/native_sqlite3.nit"

 return (void*)sqlite3_column_blob(self, i); }
long sqlite3__native_sqlite3___NativeStatement_column_count___impl( sqlite3_stmt* self )
{
#line 120 "/home/xymus/projects/nit/lib/sqlite3/native_sqlite3.nit"


		return sqlite3_column_count(self);
	}
int sqlite3__native_sqlite3___NativeStatement_reset___impl( sqlite3_stmt* self )
{
#line 125 "/home/xymus/projects/nit/lib/sqlite3/native_sqlite3.nit"

 return sqlite3_reset(self); }
int sqlite3__native_sqlite3___NativeStatement_finalize___impl( sqlite3_stmt* self )
{
#line 128 "/home/xymus/projects/nit/lib/sqlite3/native_sqlite3.nit"

 return sqlite3_finalize(self); }
sqlite3 * sqlite3__native_sqlite3___new_NativeSqlite3_open___impl( String filename )
{
#line 135 "/home/xymus/projects/nit/lib/sqlite3/native_sqlite3.nit"


		sqlite3 *self = NULL;
		int err = sqlite3_open(String_to_cstring(filename), &self);
		NativeSqlite3_set_sys_sqlite_open_error(self, (void*)(long)err);
		// The previous cast is a hack, using non pointers in extern classes is not
		// yet in the spec of the FFI.
		return self;
	}
void sqlite3__native_sqlite3___NativeSqlite3_close___impl( sqlite3 * self )
{
#line 155 "/home/xymus/projects/nit/lib/sqlite3/native_sqlite3.nit"


#if SQLITE_VERSION_NUMBER >= 3007014
		sqlite3_close_v2(self);
#else
		// A program using the older version should not rely on the garbage-collector
		// to close its connections. They must be closed manually after the associated
		// prepare statements have been finalized.
		sqlite3_close(self);
#endif
	}
int sqlite3__native_sqlite3___NativeSqlite3_exec___impl( sqlite3 * self, String sql )
{
#line 167 "/home/xymus/projects/nit/lib/sqlite3/native_sqlite3.nit"


		return sqlite3_exec(self, String_to_cstring(sql), 0, 0, 0);
	}
nullable_NativeStatement sqlite3__native_sqlite3___NativeSqlite3_prepare___impl( sqlite3 * self, String sql )
{
#line 172 "/home/xymus/projects/nit/lib/sqlite3/native_sqlite3.nit"


		sqlite3_stmt *stmt;
		int res = sqlite3_prepare_v2(self, String_to_cstring(sql), -1, &stmt, 0);
		if (res == SQLITE_OK)
			return NativeStatement_as_nullable(stmt);
		else
			return null_NativeStatement();
	}
long sqlite3__native_sqlite3___NativeSqlite3_last_insert_rowid___impl( sqlite3 * self )
{
#line 181 "/home/xymus/projects/nit/lib/sqlite3/native_sqlite3.nit"


		return sqlite3_last_insert_rowid(self);
	}
int sqlite3__native_sqlite3___NativeSqlite3_error___impl( sqlite3 * self )
{
#line 185 "/home/xymus/projects/nit/lib/sqlite3/native_sqlite3.nit"


		return sqlite3_errcode(self);
	}
int sqlite3__native_sqlite3___DataType_is_integer___impl(  int  self )
{
#line 192 "/home/xymus/projects/nit/lib/sqlite3/native_sqlite3.nit"

 return self == SQLITE_INTEGER; }
int sqlite3__native_sqlite3___DataType_is_float___impl(  int  self )
{
#line 193 "/home/xymus/projects/nit/lib/sqlite3/native_sqlite3.nit"

 return self == SQLITE_FLOAT; }
int sqlite3__native_sqlite3___DataType_is_blob___impl(  int  self )
{
#line 194 "/home/xymus/projects/nit/lib/sqlite3/native_sqlite3.nit"

 return self == SQLITE_BLOB; }
int sqlite3__native_sqlite3___DataType_is_null___impl(  int  self )
{
#line 195 "/home/xymus/projects/nit/lib/sqlite3/native_sqlite3.nit"

 return self == SQLITE_NULL; }
int sqlite3__native_sqlite3___DataType_is_text___impl(  int  self )
{
#line 196 "/home/xymus/projects/nit/lib/sqlite3/native_sqlite3.nit"

 return self == SQLITE_TEXT; }
long sqlite3__native_sqlite3___DataType_to_i___impl(  int  self )
{
#line 198 "/home/xymus/projects/nit/lib/sqlite3/native_sqlite3.nit"

 return self; }
