/*
	Extern implementation of Nit module xdg_basedir
*/
#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>
#include "xdg_basedir._ffi.h"
#ifdef ANDROID
	#include <android/log.h>
	#define PRINT_ERROR(...) (void)__android_log_print(ANDROID_LOG_WARN, "Nit", __VA_ARGS__)
#else
	#define PRINT_ERROR(...) fprintf(stderr, __VA_ARGS__)
#endif
#define NativeString_to_s xdg_basedir___NativeString_to_s
#define new_Array_of_String xdg_basedir___new_Array_of_String
#define Array_of_String_add xdg_basedir___Array_of_String_add
 xdgHandle*  xdg_basedir___new_XdgBasedir___impl(  )
{
#line 33 "/home/xymus/projects/nit/lib/xdg_basedir/xdg_basedir.nit"

 return xdgInitHandle(NULL); }
void xdg_basedir___XdgBasedir_destroy___impl(  xdgHandle*  self )
{
#line 39 "/home/xymus/projects/nit/lib/xdg_basedir/xdg_basedir.nit"

 xdgWipeHandle(self); }
int xdg_basedir___XdgBasedir_update___impl(  xdgHandle*  self )
{
#line 48 "/home/xymus/projects/nit/lib/xdg_basedir/xdg_basedir.nit"

 return xdgUpdateData(self); }
String xdg_basedir___XdgBasedir_data_home___impl(  xdgHandle*  self )
{
#line 51 "/home/xymus/projects/nit/lib/xdg_basedir/xdg_basedir.nit"


		return NativeString_to_s((char*)xdgDataHome(self));
	}
String xdg_basedir___XdgBasedir_config_home___impl(  xdgHandle*  self )
{
#line 56 "/home/xymus/projects/nit/lib/xdg_basedir/xdg_basedir.nit"


		return NativeString_to_s((char*)xdgConfigHome(self));
	}
String xdg_basedir___XdgBasedir_cache_home___impl(  xdgHandle*  self )
{
#line 61 "/home/xymus/projects/nit/lib/xdg_basedir/xdg_basedir.nit"


		return NativeString_to_s((char*)xdgCacheHome(self));
	}
 const void *  xdg_basedir___XdgBasedir_native_data_dirs___impl(  xdgHandle*  self )
{
#line 69 "/home/xymus/projects/nit/lib/xdg_basedir/xdg_basedir.nit"


		return xdgDataDirectories(self);
	}
 const void *  xdg_basedir___XdgBasedir_native_searchable_data_dirs___impl(  xdgHandle*  self )
{
#line 83 "/home/xymus/projects/nit/lib/xdg_basedir/xdg_basedir.nit"


		return xdgSearchableDataDirectories(self);
	}
 const void *  xdg_basedir___XdgBasedir_native_config_dirs___impl(  xdgHandle*  self )
{
#line 91 "/home/xymus/projects/nit/lib/xdg_basedir/xdg_basedir.nit"


		return xdgConfigDirectories(self);
	}
 const void *  xdg_basedir___XdgBasedir_native_searchable_config_dirs___impl(  xdgHandle*  self )
{
#line 105 "/home/xymus/projects/nit/lib/xdg_basedir/xdg_basedir.nit"


		return xdgSearchableConfigDirectories(self);
	}
Array_of_String xdg_basedir___ConstPointer_to_string_array___impl(  const void *  self )
{
#line 113 "/home/xymus/projects/nit/lib/xdg_basedir/xdg_basedir.nit"


		char **strings = (char**)self;

		Array_of_String aos = new_Array_of_String();
		int p = 0;
		while (strings[p] != NULL) {
			Array_of_String_add(aos, NativeString_to_s((char*)strings[p]));
			p ++;
		}

		return aos;
	}
double xdg_basedir___Sys_xdg_basedir_spec___impl( Sys self )
{
#line 128 "/home/xymus/projects/nit/lib/xdg_basedir/xdg_basedir.nit"

 return XDG_BASEDIR_SPEC; }
